Parsers.jl
=============

[![CI](https://github.com/JuliaData/Parsers.jl/workflows/CI/badge.svg)](https://github.com/JuliaData/Parsers.jl/actions?query=workflow%3ACI)
[![codecov](https://codecov.io/gh/JuliaData/Parsers.jl/branch/master/graph/badge.svg)](https://codecov.io/gh/JuliaData/Parsers.jl)
[![deps](https://juliahub.com/docs/Parsers/deps.svg)](https://juliahub.com/ui/Packages/Parsers/833b9?t=2)
[![version](https://juliahub.com/docs/Parsers/version.svg)](https://juliahub.com/ui/Packages/Parsers/833b9)
[![pkgeval](https://juliahub.com/docs/Parsers/pkgeval.svg)](https://juliahub.com/ui/Packages/Parsers/833b9)

A collection of type parsers and utilities for Julia.

**Installation**: at the Julia REPL, `import Pkg; Pkg.add("Parsers")`

**Maintenance**: Parsers is maintained collectively by the [JuliaData collaborators](https://github.com/orgs/JuliaData/people).
Responsiveness to pull requests and issues can vary, depending on the availability of key collaborators.


### Basic Usage
```julia
using Parsers

# basic int/float parsing
x = Parsers.parse(Int, "101")
y = Parsers.parse(Float64, "101.101")

# use comma as decimal
y2 = Parsers.parse(Float64, "101,101", Parsers.Options(decimal=','))

# Bool parsing
z = Parsers.parse(Bool, "true")

# Date/DateTime parsing
using Dates
a = Parsers.parse(Date, "2018-01-01")

# custom dateformat
b = Parsers.parse(Date, "01/20/2018", Parsers.Options(dateformat="mm/dd/yyyy"))

# will throw on invalid values
Parsers.parse(Int, "abc")

# tryparse will return `nothing` on invalid values
y = Parsers.tryparse(Int, "abc")
```

### Additional usage
Read through the docs of the following types/functions for more information on using advanced Parsers machinery:
  * `?Parsers.Options`
  * `?Parsers.xparse`
  * `?Parsers.Result`
  * `?Parsers.ReturnCode`

using Parsers, Test, Dates

import Parsers: INVALID, OK, SENTINEL, QUOTED, DELIMITED, NEWLINE, EOF, INVALID_QUOTED_FIELD, INVALID_DELIMITER, OVERFLOW, ESCAPED_STRING, SPECIAL_VALUE, INEXACT
import Aqua
import Serialization
struct CustomType
    x::String
end

Base.tryparse(::Type{CustomType}, x::String) = CustomType(x)

@testset "Parsers" begin

@testset "Core Parsers.xparse" begin

sentinels = ["NANA", "NAN", "NA"]

testcases = [
    (str="", kwargs=(), x=0, code=(INVALID | EOF), vpos=1, vlen=0, tlen=0),
    (str="", kwargs=(sentinel=missing,), x=0, code=(SENTINEL | EOF), vpos=1, vlen=0, tlen=0),
    (str=" ", kwargs=(), x=0, code=(INVALID | EOF), vpos=1, vlen=1, tlen=1),
    (str=" ", kwargs=(sentinel=missing,), x=0, code=(INVALID | EOF), vpos=1, vlen=1, tlen=1),
    (str=" -", kwargs=(sentinel=missing,), x=0, code=(INVALID | EOF), vpos=1, vlen=2, tlen=2),
    (str=" +", kwargs=(sentinel=missing,), x=0, code=(INVALID | EOF), vpos=1, vlen=2, tlen=2),
    (str="-", kwargs=(sentinel=missing,), x=0, code=(INVALID | EOF), vpos=1, vlen=1, tlen=1),
    (str=" {-", kwargs=(sentinel=missing,), x=0, code=(QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=1, tlen=3),
    (str="{+", kwargs=(sentinel=missing,), x=0, code=(QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=1, tlen=2),
    (str=" {+,", kwargs=(sentinel=missing,), x=0, code=(QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=1, tlen=4),
    (str="{-,", kwargs=(sentinel=missing,), x=0, code=(QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=1, tlen=3),
    (str="+,", kwargs=(sentinel=missing,), x=0, code=(INVALID | DELIMITED), vpos=1, vlen=1, tlen=2),
    (str="-,", kwargs=(sentinel=missing,), x=0, code=(INVALID | DELIMITED), vpos=1, vlen=1, tlen=2),
    (str="t,", kwargs=(sentinel=missing,), x=0, code=(INVALID | INVALID_DELIMITER | DELIMITED), vpos=1, vlen=1, tlen=2),
    (str=" {-},", kwargs=(sentinel=missing,), x=0, code=(INVALID | QUOTED | DELIMITED), vpos=3, vlen=1, tlen=5),
    (str="{+} ,", kwargs=(sentinel=missing,), x=0, code=(INVALID | QUOTED | DELIMITED), vpos=2, vlen=1, tlen=5),
    (str="{}", kwargs=(sentinel=missing,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=2, vlen=0, tlen=2),
    (str="{},", kwargs=(sentinel=missing,), x=0, code=(SENTINEL | QUOTED | DELIMITED), vpos=2, vlen=0, tlen=3),
    (str="{a},", kwargs=(sentinel=missing,), x=0, code=(INVALID | QUOTED | DELIMITED), vpos=2, vlen=1, tlen=4),
    (str="{", kwargs=(), x=0, code=(QUOTED | INVALID_QUOTED_FIELD | EOF), vpos=2, vlen=-1, tlen=1),
    (str="{}", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=2, vlen=0, tlen=2),
    (str=" {", kwargs=(), x=0, code=(QUOTED | INVALID_QUOTED_FIELD | EOF), vpos=3, vlen=-2, tlen=2),
    (str=" {\\\\", kwargs=(), x=0, code=(QUOTED | INVALID_QUOTED_FIELD | ESCAPED_STRING | EOF), vpos=3, vlen=0, tlen=4),
    (str=" {\\}} ", kwargs=(), x=0, code=(QUOTED | INVALID | ESCAPED_STRING | EOF), vpos=3, vlen=2, tlen=6),
    (str=" {\\\\}", kwargs=(), x=0, code=(INVALID | QUOTED | ESCAPED_STRING | EOF), vpos=3, vlen=2, tlen=5),

    (str=" {}", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=0, tlen=3),
    (str=" { }", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=1, tlen=4),
    (str=" {,} ", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=1, tlen=5),
    (str=" { } ", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=1, tlen=5),
    (str=" {\t", kwargs=(), x=0, code=(INVALID_QUOTED_FIELD | QUOTED | EOF), vpos=3, vlen=-2, tlen=3),

    (str="NA", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF), vpos=1, vlen=2, tlen=2),
    (str="£", kwargs=(sentinel=["£"],), x=0, code=(SENTINEL | EOF), vpos=1, vlen=2, tlen=2),
    (str="NA2", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF | INVALID_DELIMITER), vpos=1, vlen=3, tlen=3),
    (str="NAN", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF), vpos=1, vlen=3, tlen=3),
    (str="NANA", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF), vpos=1, vlen=4, tlen=4),
    (str=" NA", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF), vpos=1, vlen=3, tlen=3),
    (str="{NAN", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=3, tlen=4),
    (str="{NANA}", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=2, vlen=4, tlen=6),
    (str=" {NA", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=2, tlen=4),
    (str=" {NANA}", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=4, tlen=7),
    (str=" { NAN}", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=4, tlen=7),
    (str=" {NAN }", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=4, tlen=7),
    (str=" {NA} ", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" { NANA} ", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=5, tlen=9),
    (str=" {\tNA", kwargs=(sentinel=sentinels,), x=0, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=3, vlen=3, tlen=5),

    (str="-", kwargs=(sentinel=["-"],), x=0, code=(SENTINEL | EOF), vpos=1, vlen=1, tlen=1),
    (str=" +", kwargs=(sentinel=["+"],), x=0, code=(SENTINEL | EOF), vpos=1, vlen=2, tlen=2),
    (str="+1 ", kwargs=(sentinel=["+1"],), x=1, code=(SENTINEL | EOF), vpos=1, vlen=3, tlen=3),
    (str=" -1 ", kwargs=(sentinel=["-1"],), x=-1, code=(SENTINEL | EOF), vpos=1, vlen=4, tlen=4),
    (str="{1", kwargs=(sentinel=["1"],), x=1, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=1, tlen=2),
    (str="{1 ", kwargs=(sentinel=["1"],), x=1, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=2, tlen=3),
    (str="{-1}", kwargs=(sentinel=["-1"],), x=-1, code=(SENTINEL | QUOTED | EOF), vpos=2, vlen=2, tlen=4),
    (str=" {+1", kwargs=(sentinel=["+1"],), x=1, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=3, vlen=2, tlen=4),
    (str=" {-}", kwargs=(sentinel=["-"],), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=1, tlen=4),
    (str=" { +}", kwargs=(sentinel=["+"],), x=0, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=2, tlen=5),
    (str=" {-1 }", kwargs=(sentinel=["-1"],), x=-1, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=3, tlen=6),
    (str=" {+1} ", kwargs=(sentinel=["+1"],), x=1, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" { 1} ", kwargs=(sentinel=["1"],), x=1, code=(SENTINEL | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" {\t-", kwargs=(sentinel=["-"],), x=0, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=3, vlen=2, tlen=4),

    (str="+a ", kwargs=(sentinel=["+1"],), x=0, code=(INVALID | EOF | INVALID_DELIMITER), vpos=1, vlen=3, tlen=3),
    (str=" -a ", kwargs=(sentinel=["-1"],), x=0, code=(INVALID | EOF | INVALID_DELIMITER), vpos=1, vlen=4, tlen=4),
    (str="{a", kwargs=(sentinel=["1"],), x=0, code=(INVALID | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=0, tlen=2),
    (str="{-a}", kwargs=(sentinel=["-1"],), x=0, code=(INVALID | EOF | QUOTED), vpos=2, vlen=2, tlen=4),
    (str=" {+1a", kwargs=(sentinel=["+1"],), x=1, code=(SENTINEL | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=3, tlen=5),
    (str=" {-1a }", kwargs=(sentinel=["-1"],), x=-1, code=(SENTINEL | QUOTED | INVALID | EOF), vpos=3, vlen=4, tlen=7),
    (str=" {+a} ", kwargs=(sentinel=["+1"],), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" { a} ", kwargs=(sentinel=["1"],), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=2, tlen=6),

    (str="-", kwargs=(), x=0, code=(INVALID | EOF), vpos=1, vlen=1, tlen=1),
    (str="0", kwargs=(), x=0, code=(OK | EOF), vpos=1, vlen=1, tlen=1),
    (str=" +", kwargs=(), x=0, code=(INVALID | EOF), vpos=1, vlen=2, tlen=2),
    (str=" +1", kwargs=(), x=1, code=(OK | EOF), vpos=1, vlen=3, tlen=3),
    (str="-1 ", kwargs=(), x=-1, code=(OK | EOF), vpos=1, vlen=3, tlen=3),
    (str=" +1 ", kwargs=(), x=1, code=(OK | EOF), vpos=1, vlen=4, tlen=4),
    (str="{1", kwargs=(), x=1, code=(OK | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=1, tlen=2),
    (str="{1 ", kwargs=(), x=1, code=(OK | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=2, tlen=3),
    (str="{-1}", kwargs=(), x=-1, code=(OK | QUOTED | EOF), vpos=2, vlen=2, tlen=4),
    (str=" {+1", kwargs=(), x=1, code=(OK | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=2, tlen=4),
    (str=" {-}", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=1, tlen=4),
    (str=" { +}", kwargs=(), x=0, code=(INVALID | QUOTED | EOF), vpos=3, vlen=2, tlen=5),
    (str=" {-1 }", kwargs=(), x=-1, code=(OK | QUOTED | EOF), vpos=3, vlen=3, tlen=6),
    (str=" {+1} ", kwargs=(), x=1, code=(OK | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" { 1} ", kwargs=(), x=1, code=(OK | QUOTED | EOF), vpos=3, vlen=2, tlen=6),
    (str=" {\t-", kwargs=(), x=0, code=(QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=3, vlen=2, tlen=4),
    (str="{1ab\\\\c}", kwargs=(), x=1, code=(OK | QUOTED | ESCAPED_STRING | EOF | INVALID), vpos=2, vlen=6, tlen=8),
    (str="{1\\\\abc,", kwargs=(), x=1, code=(OK | QUOTED | ESCAPED_STRING | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=6, tlen=8),
    (str="{1abc},", kwargs=(sentinel=["1abc"],), x=1, code=(SENTINEL | QUOTED | DELIMITED), vpos=2, vlen=4, tlen=7),
    (str="{1abc", kwargs=(sentinel=["1abc"],), x=1, code=(SENTINEL | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=4, tlen=5),

    (str="922337203,", kwargs=(sentinel=["92233"],), x=922337203, code=(OK | DELIMITED), vpos=1, vlen=9, tlen=10),
    (str="92233,", kwargs=(sentinel=["92233"],), x=92233, code=(SENTINEL | DELIMITED), vpos=1, vlen=5, tlen=6),
    (str="92233  ", kwargs=(sentinel=["92233"],), x=92233, code=(SENTINEL | EOF), vpos=1, vlen=7, tlen=7),
    (str="{92233  ,", kwargs=(sentinel=["92233"],), x=92233, code=(SENTINEL | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=7, tlen=9),
    (str="{92233} ,", kwargs=(sentinel=["92233"],), x=92233, code=(SENTINEL | QUOTED | DELIMITED), vpos=2, vlen=5, tlen=9),
    (str=" { 92233 },", kwargs=(sentinel=["92233"],), x=92233, code=(SENTINEL | QUOTED | DELIMITED), vpos=3, vlen=7, tlen=11),
    (str="922337203685477580", kwargs=(), x=922337203685477580, code=(OK | EOF), vpos=1, vlen=18, tlen=18),
    (str="9223372036854775808", kwargs=(), x=-9223372036854775808, code=(OVERFLOW | EOF), vpos=1, vlen=19, tlen=19),
    (str="9223372036854775808a", kwargs=(sentinel=["9223372036854775808a"],), x=-9223372036854775808, code=(SENTINEL | EOF), vpos=1, vlen=20, tlen=20),
    (str="{9223372036854775808a", kwargs=(sentinel=["9223372036854775808a"],), x=-9223372036854775808, code=(SENTINEL | QUOTED | EOF | INVALID_QUOTED_FIELD), vpos=2, vlen=20, tlen=21),

    (str="{9223372036854775808", kwargs=(), x=-9223372036854775808, code=(OVERFLOW | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=19, tlen=20),
    (str="{9223372036854775807", kwargs=(), x=9223372036854775807, code=(OK | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=19, tlen=20),
    (str="{9223372036854775807a", kwargs=(), x=9223372036854775807, code=(OK | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=19, tlen=21),
    (str="9223372036854775807a", kwargs=(), x=9223372036854775807, code=(OK | EOF | INVALID_DELIMITER), vpos=1, vlen=20, tlen=20),
    (str="9223372036854775807,", kwargs=(), x=9223372036854775807, code=(OK | DELIMITED), vpos=1, vlen=19, tlen=20),
    (str="9223372036854775807", kwargs=(sentinel=["9223372036854775807"],), x=9223372036854775807, code=(SENTINEL | EOF), vpos=1, vlen=19, tlen=19),
    (str="{9223372036854775807a", kwargs=(sentinel=["9223372036854775807a"],), x=9223372036854775807, code=(SENTINEL | EOF | QUOTED | INVALID_QUOTED_FIELD), vpos=2, vlen=20, tlen=21),

    (str="9223372036854775808", kwargs=(sentinel=["92233"],), x=-9223372036854775808, code=(OVERFLOW | EOF), vpos=1, vlen=19, tlen=19),
    (str="922337203685477580", kwargs=(sentinel=["92233"],), x=922337203685477580, code=(OK | EOF), vpos=1, vlen=18, tlen=18),
    (str="922337203685477580,", kwargs=(), x=922337203685477580, code=(OK | DELIMITED), vpos=1, vlen=18, tlen=19),
    (str="922337203685477580,", kwargs=(sentinel=["92233"],), x=922337203685477580, code=(OK | DELIMITED), vpos=1, vlen=18, tlen=19),
    (str="9223372036854775800000,", kwargs=(sentinel=["92233"],), x=-80, code=(DELIMITED | INVALID_DELIMITER | OVERFLOW), vpos=1, vlen=22, tlen=23),

    (str="1;", kwargs=(), x=1, code=(OK | EOF | INVALID_DELIMITER), vpos=1, vlen=2, tlen=2),
    (str="1;", kwargs=(delim=UInt8(';'),), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=2),
    (str="1abc;", kwargs=(delim=UInt8(';'),), x=1, code=(OK | DELIMITED | INVALID_DELIMITER), vpos=1, vlen=4, tlen=5),
    (str="1\n", kwargs=(), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=2),
    (str="1\r", kwargs=(), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=2),
    (str="1\r\n", kwargs=(), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=3),
    (str="1\n2", kwargs=(), x=1, code=(OK | NEWLINE), vpos=1, vlen=1, tlen=2),
    (str="1\r2", kwargs=(), x=1, code=(OK | NEWLINE), vpos=1, vlen=1, tlen=2),
    (str="1\r\n2", kwargs=(), x=1, code=(OK | NEWLINE), vpos=1, vlen=1, tlen=3),
    (str="1a\n", kwargs=(), x=1, code=(OK | NEWLINE | EOF | INVALID_DELIMITER), vpos=1, vlen=2, tlen=3),
    (str="1a\r", kwargs=(), x=1, code=(OK | NEWLINE | EOF | INVALID_DELIMITER), vpos=1, vlen=2, tlen=3),
    (str="1a\r\n", kwargs=(), x=1, code=(OK | NEWLINE | EOF | INVALID_DELIMITER), vpos=1, vlen=2, tlen=4),
    (str="1a\n2", kwargs=(), x=1, code=(OK | NEWLINE | INVALID_DELIMITER), vpos=1, vlen=2, tlen=3),
    (str="1a\r2", kwargs=(), x=1, code=(OK | NEWLINE | INVALID_DELIMITER), vpos=1, vlen=2, tlen=3),
    (str="1a\r\n2", kwargs=(), x=1, code=(OK | NEWLINE | INVALID_DELIMITER), vpos=1, vlen=2, tlen=4),

    (str="1,,,2,null,4", kwargs=(), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=2),
    (str="1,,,2,null,4", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=4),
    (str="1,", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED | EOF), vpos=1, vlen=1, tlen=2),
    (str="1,,", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED | EOF), vpos=1, vlen=1, tlen=3),
    (str="1,,,", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED | EOF), vpos=1, vlen=1, tlen=4),
    (str="1::2", kwargs=(delim="::",), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=3),
    (str="1::::2", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=5),
    (str="1a::::2", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED | INVALID_DELIMITER), vpos=1, vlen=2, tlen=6),
    (str="1[][]", kwargs=(delim="[]", ignorerepeated = true), x = 1, code=(OK | DELIMITED | EOF), vpos=1, vlen=1, tlen=5),
    (str="1a[][]", kwargs=(delim="[]", ignorerepeated = true), x = 1, code=(OK | DELIMITED | INVALID_DELIMITER | EOF), vpos=1, vlen=2, tlen=6),
    (str="1a[][]", kwargs=(delim="[]",), x = 1, code=(OK | DELIMITED | INVALID_DELIMITER), vpos=1, vlen=2, tlen=4),
    # ignorerepeated
    (str="1a,,", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED | INVALID_DELIMITER | EOF), vpos=1, vlen=2, tlen=4),
    (str="1a,,2", kwargs=(ignorerepeated=true,), x=1, code=(OK | DELIMITED | INVALID_DELIMITER), vpos=1, vlen=2, tlen=4),
    (str="1,\n", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | DELIMITED | NEWLINE | EOF), vpos=1, vlen=1, tlen=3),
    (str="1,\n,", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=4),
    (str="1,\n,\n", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=4),
    (str="1::\n::", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=6),
    (str="1::\n::\n", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=6),
    (str="1,\r\n,", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=5),
    (str="1,\r\n,\r\n", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=5),
    (str="1::\r\n::", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=7),
    (str="1::\r\n::\r\n", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | DELIMITED | NEWLINE), vpos=1, vlen=1, tlen=7),
    # invalid
    (str="1a,\n,", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=5),
    (str="1a,\n,\n", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=5),
    (str="1a::\n::", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=7),
    (str="1a::\n::\n", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=7),
    (str="1a,\r\n,", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=6),
    (str="1a,\r\n,\r\n", kwargs=(ignorerepeated=true, delim=UInt8(',')), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=6),
    (str="1a::\r\n::", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=8),
    (str="1a::\r\n::\r\n", kwargs=(ignorerepeated=true, delim="::"), x=1, code=(OK | INVALID_DELIMITER | DELIMITED | NEWLINE), vpos=1, vlen=2, tlen=8),
    # ignoreemptylines
    (str="1\n\n", kwargs=(ignoreemptylines=true,), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=3),
    (str="1\n\n\n", kwargs=(ignoreemptylines=true,), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=4),
    (str="1,\n\n\n,", kwargs=(ignorerepeated=true, ignoreemptylines=true, delim=UInt8(',')), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=6),
    (str="1::\n\n\n::", kwargs=(ignorerepeated=true, ignoreemptylines=true, delim="::"), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=8),
    (str="1\r\n\r\n", kwargs=(ignoreemptylines=true,), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=5),
    (str="1\r\n\r\n\r\n", kwargs=(ignoreemptylines=true,), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=7),
    (str="1,\r\n\r\n\r\n,", kwargs=(ignorerepeated=true, ignoreemptylines=true, delim=UInt8(',')), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=9),
    (str="1::\r\n\r\n\r\n::", kwargs=(ignorerepeated=true, ignoreemptylines=true, delim="::"), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=11),
    # comments
    (str="1\n#\n", kwargs=(comment="#",), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=4),
    (str="1\n#   \n", kwargs=(comment="#",), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=7),
    (str="1,\n#  \n\n,", kwargs=(ignorerepeated=true, ignoreemptylines=true, comment="#", delim=UInt8(',')), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=9),
    (str="1::\n#  \n\n::", kwargs=(ignorerepeated=true, ignoreemptylines=true, comment="#", delim="::"), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=11),
    (str="1\r\n#  \r\n", kwargs=(ignoreemptylines=true, comment="#",), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=8),
    (str="1\r\n#  \r\n\r\n", kwargs=(ignoreemptylines=true, comment="#",), x=1, code=(OK | NEWLINE | EOF), vpos=1, vlen=1, tlen=10),
    (str="1,\r\n#  \r\n\r\n,", kwargs=(ignorerepeated=true, ignoreemptylines=true, comment="#", delim=UInt8(',')), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=12),
    (str="1::\r\n#  \r\n\r\n::", kwargs=(ignorerepeated=true, ignoreemptylines=true, comment="#", delim="::"), x=1, code=(OK | NEWLINE | DELIMITED), vpos=1, vlen=1, tlen=14),
    # stripquoted
    (str=" 1", kwargs=(stripquoted=true,), x=1, code=(OK | EOF), vpos=2, vlen=1, tlen=2),
    (str="{ 1}", kwargs=(stripquoted=true,), x=1, code=(OK | QUOTED | EOF), vpos=3, vlen=1, tlen=4),
    (str="{1 }", kwargs=(stripquoted=true,), x=1, code=(OK | QUOTED | EOF), vpos=2, vlen=1, tlen=4),
    (str="1 ", kwargs=(stripquoted=true,), x=1, code=(OK | EOF), vpos=1, vlen=1, tlen=2),
    (str="1 ,", kwargs=(stripquoted=true,delim=UInt8(',')), x=1, code=(OK | DELIMITED), vpos=1, vlen=1, tlen=3),
    (str="{1 } ,", kwargs=(stripquoted=true,delim=UInt8(',')), x=1, code=(OK | DELIMITED | QUOTED), vpos=2, vlen=1, tlen=6),
];

chars(s) = Char(s)
chars(s::AbstractString) = s
for useio in (false, true)
    for (oq, cq, e) in (
        (UInt8('"'), UInt8('"'), UInt8('"')),
        (UInt8('"'), UInt8('"'), UInt8('\\')),
        (UInt8('{'), UInt8('}'), UInt8('\\')),
        ("#=", "=#", UInt8('\\')),
    )
        for (i, case) in enumerate(testcases)
            # println("testing int case i = $i, case = $case, useio = $useio, oq = `$(chars(oq))`, cq = `$(chars(cq))`, e = `$(chars(e))`")
            str = replace(replace(replace(case.str, '{'=>chars(oq)), '}'=>chars(cq)), '\\'=>chars(e))
            source = useio ? IOBuffer(str) : str
            res = Parsers.xparse(Int64, source; openquotechar=oq, closequotechar=cq, escapechar=e, case.kwargs...)
            x, code, tlen = res.val, res.code, res.tlen
            if !Parsers.invalid(code) && !Parsers.sentinel(code)
                @test x == case.x
            end
            @test code == case.code
            if Parsers.quoted(code)
                # Above we may have `replace`d quote chars, so original `case.tlen` may no longer hold.
                # Assume `str` had no chars after delim, and whole input should have been consumed.
                @test tlen == ncodeunits(str)
            else
                @test tlen == case.tlen
            end
        end
    end
end

# strings
for useio in (false, true)
    for (oq, cq, e) in ((UInt8('"'), UInt8('"'), UInt8('"')), (UInt8('"'), UInt8('"'), UInt8('\\')), (UInt8('{'), UInt8('}'), UInt8('\\')))
        for (i, case) in enumerate(testcases)
            for S in (Parsers.PosLen, Parsers.PosLen31)
                # println("testing string case i = $i, case = $case, useio = $useio, oq = `$(Char(oq))`, cq = `$(Char(cq))`, e = `$(Char(e))`")
                str = replace(replace(replace(case.str, '{'=>Char(oq)), '}'=>Char(cq)), '\\'=>Char(e))
                source = useio ? IOBuffer(str) : str
                res = Parsers.xparse(String, source, S; openquotechar=oq, closequotechar=cq, escapechar=e, case.kwargs...)
                x, code, tlen = res.val, res.code, res.tlen
                if !Parsers.invalidquotedfield(code)
                    @test x.pos == case.vpos
                    @test x.len == case.vlen
                    @test tlen == case.tlen
                end
            end
        end
    end
end

# escaped value
res = Parsers.xparse(String, "\"123 \\\\ 456\""; escapechar=UInt8('\\'))
@test res.val.pos == 2
@test res.val.escapedvalue
res = Parsers.xparse(String, "\"123 \\\\ 456\"", Parsers.PosLen31; escapechar=UInt8('\\'))
@test res.val.pos == 2
@test res.val.escapedvalue

# tab delim, still strip whitespace
res = Parsers.xparse(Int64, " 123 \t 456 "; delim=UInt8('\t'))
@test res.val == 123
@test res.tlen == 6
@test res.code == (OK | DELIMITED)

# multiple space sentinels
res = Parsers.xparse(Int64, "1\n"; sentinel=["", " ", "  "])
@test res.val == 1
@test res.tlen == 2
@test res.code == (OK | EOF | NEWLINE)

# #140, #142
res = Parsers.xparse(String, "NA"; sentinel=["NA"])
@test res.code == (SENTINEL | EOF)
res = Parsers.xparse(String, "NA", Parsers.PosLen31; sentinel=["NA"])
@test res.code == (SENTINEL | EOF)

# stripwhitespace
for S in (Parsers.PosLen, Parsers.PosLen31)
    res = Parsers.xparse(String, "{{hey there}}", S; openquotechar="{{", closequotechar="}}", stripwhitespace=true)
    @test res.val.pos == 3 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there}", S; openquotechar='{', closequotechar='}', stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, "{{hey there }}", S; openquotechar="{{", closequotechar="}}", stripwhitespace=true)
    @test res.val.pos == 3 && res.val.len == 10
    res = Parsers.xparse(String, "{hey there }", S; openquotechar='{', closequotechar='}', stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 10
    res = Parsers.xparse(String, "{hey there },", S; openquotechar='{', closequotechar='}', delim=',', stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 10
    res = Parsers.xparse(String, "{hey there } ,", S; openquotechar='{', closequotechar='}', delim=',', stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 10
    res = Parsers.xparse(String, "{hey there } a,", S; openquotechar='{', closequotechar='}', delim=',', stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 10 && Parsers.invaliddelimiter(res.code)
    res = Parsers.xparse(String, "{hey there } a ", S; openquotechar='{', closequotechar='}', delim=nothing, stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 10 && res.tlen == 13
    res = Parsers.xparse(String, "hey there ,", S; delim=',', stripwhitespace=true)
    @test res.val.pos == 1 && res.val.len == 9
    res = Parsers.xparse(String, " hey there ", S; stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, " hey there ", S; delim=nothing, stripwhitespace=true)
    @test res.val.pos == 2 && res.val.len == 9

    res = Parsers.xparse(String, "{{hey there}}", S; openquotechar="{{", closequotechar="}}", stripquoted=true)
    @test res.val.pos == 3 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there}", S; openquotechar='{', closequotechar='}', stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, "{{hey there }}", S; openquotechar="{{", closequotechar="}}", stripquoted=true)
    @test res.val.pos == 3 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there }", S; openquotechar='{', closequotechar='}', stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there },", S; openquotechar='{', closequotechar='}', delim=',', stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there } ,", S; openquotechar='{', closequotechar='}', delim=',', stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, "{hey there } a,", S; openquotechar='{', closequotechar='}', delim=',', stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9 && Parsers.invaliddelimiter(res.code)
    res = Parsers.xparse(String, "{hey there } a ", S; openquotechar='{', closequotechar='}', delim=nothing, stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9 && res.tlen == 13
    res = Parsers.xparse(String, "hey there ,", S; delim=',', stripquoted=true)
    @test res.val.pos == 1 && res.val.len == 9
    res = Parsers.xparse(String, " hey there ", S; stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    res = Parsers.xparse(String, " hey there ", S; delim=nothing, stripquoted=true)
    @test res.val.pos == 2 && res.val.len == 9
    # `stripquoted=true` should always override `stripwhitespace` to `true`
    res = Parsers.xparse(String, " hey there ", S; delim=nothing, stripquoted=true, stripwhitespace=false)
    @test res.val.pos == 2 && res.val.len == 9

    # https://github.com/JuliaData/Parsers.jl/issues/115
    res = Parsers.xparse(String, "{hey there } ", S; openquotechar='{', closequotechar='}', stripquoted=true, delim=' ')
    @test res.val.pos == 2 && res.val.len == 9
    @test Parsers.delimited(res.code)
    @test res.tlen == 13
end
end # @testset "Core Parsers.xparse"

@testset "ints" begin

@testset "groupmark" begin
    # `parse` is used for parsing inputs with a single value in them,
    # so when delims==groupmarks, we assume what we see are groupmarks
    @testset "Parsers.parse" begin
        groupmark(c::Char) = Parsers._get_default_options(groupmark=UInt8(c))
        @testset "$T" for T in (Int32, Int64)
            # comma
            @test Parsers.parse(T, "100,000,000", groupmark(',')) == 100_000_000
            @test Parsers.parse(T, "1,0,0,0,0,0,0,0,0", groupmark(',')) == 100_000_000
            @test Parsers.parse(T, "2,1,4,7,4,8,3,6,4,7", groupmark(',')) == 2147483647
            if T == Int64
                @test Parsers.parse(T, "9,2,2,3,3,7,2,0,3,6,8,5,4,7,7,5,8,0,7", groupmark(',')) == 9223372036854775807
            end
            # space
            @test Parsers.parse(T, "100 000 000", groupmark(' ')) == 100_000_000
            @test Parsers.parse(T, "1 0 0 0 0 0 0 0 0", groupmark(' ')) == 100_000_000
            @test Parsers.parse(T, "2 1 4 7 4 8 3 6 4 7", groupmark(' ')) == 2147483647
            if T == Int64
                @test Parsers.parse(T, "9 2 2 3 3 7 2 0 3 6 8 5 4 7 7 5 8 0 7", groupmark(' ')) == 9223372036854775807
            end
        end
    end
    ### NOTE: for `xparse` by default `delim=','`, so when we also test `groupmark=','`
    ### we are testing the case where `delim==groupmark`.
    ### In these cases `,` is interpreted as `groupmark` only appear inside a quoted value.
    @testset "Int64" begin
    @test Parsers.xparse(Int64, "100,000,000"; groupmark=',').val == 100
    @test Parsers.xparse(Int64, "\"100,000,000\""; groupmark=',').val == 100_000_000
    @test Parsers.xparse(Int64, "100_000_000"; groupmark='_').val == 100_000_000
    @test Parsers.xparse(Int64, "1_0_0_0_0_0_0_0_0"; groupmark='_').val == 100_000_000
    @test Parsers.xparse(Int64, "100000000"; groupmark=',').val == 100_000_000
    @test Parsers.xparse(Int64, "100000000"; groupmark='_').val == 100_000_000

    @test Parsers.xparse(Int64, "9223372036854775807"; groupmark=',').val == 9223372036854775807
    @test Parsers.xparse(Int64, "9,2,2,3,3,7,2,0,3,6,8,5,4,7,7,5,8,0,7"; groupmark=',').val == 9
    @test Parsers.xparse(Int64, "9_2_2_3_3_7_2_0_3_6_8_5_4_7_7_5_8_0_7"; groupmark='_').val == 9223372036854775807
    @test Parsers.xparse(Int64, "9 2 2 3 3 7 2 0 3 6 8 5 4 7 7 5 8 0 7"; groupmark=' ').val == 9223372036854775807

    @test Parsers.xparse(Int64, "\"100,000,000\",100"; groupmark=',', openquotechar='"', closequotechar='"') == Parsers.Result{Int64}(Int16(13), 14, 100_000_000)
    @test Parsers.xparse(Int32, "\"100_000_000\",100"; groupmark='_', openquotechar='"', closequotechar='"') == Parsers.Result{Int32}(Int16(13), 14, 100_000_000)
    @test Parsers.xparse(Int64, "100,000,000,aaa"; groupmark=',').val == 100
    @test Parsers.xparse(Int64, "100_000_000,aaa"; groupmark='_').val == 100_000_000
    res = Parsers.xparse(Int64, "100_000_000_aaa"; groupmark='_')
    @test res.code == EOF | INVALID | INVALID_DELIMITER
    @test res.tlen == 15
    end # Int64

    @testset "Int32" begin
    @test Parsers.xparse(Int32, "100_000_000"; groupmark='_').val == 100_000_000
    @test Parsers.xparse(Int32, "1_0_0_0_0_0_0_0_0"; groupmark='_').val == 100_000_000
    @test Parsers.xparse(Int32, "100000000"; groupmark='_').val == 100_000_000

    @test Parsers.xparse(Int32, "2147483647"; groupmark='_').val == 2147483647
    @test Parsers.xparse(Int32, "2_1_4_7_4_8_3_6_4_7"; groupmark='_').val == 2147483647
    @test Parsers.xparse(Int32, "2 1 4 7 4 8 3 6 4 7"; groupmark=' ').val == 2147483647

    @test Parsers.xparse(Int32, "\"100,000,000\",100"; groupmark=',', openquotechar='"', closequotechar='"') == Parsers.Result{Int32}(Int16(13), 14, 100_000_000)
    @test Parsers.xparse(Int32, "\"100_000_000\",100"; groupmark='_', openquotechar='"', closequotechar='"') == Parsers.Result{Int32}(Int16(13), 14, 100_000_000)
    @test Parsers.xparse(Int64, "100,000,000,aaa"; groupmark=',').val == 100
    @test Parsers.xparse(Int64, "100_000_000,aaa"; groupmark='_').val == 100_000_000
    res = Parsers.xparse(Int64, "100_000_000_aaa"; groupmark='_')
    @test res.code == EOF | INVALID | INVALID_DELIMITER
    @test res.tlen == 15
    res = Parsers.xparse(Int32, "100_000_000_aaa"; groupmark='_')
    @test res.code == EOF | INVALID | INVALID_DELIMITER
    @test res.tlen == 15
    end # Int32

    @testset "$T error cases" for T in (Int32, Int64)
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark=',', quoted=false, delim=',')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark=',', quoted=false, delim=UInt8(','))
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark=',', decimal=',')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark=',', decimal=UInt8(','))
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='0')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark=UInt8('0'))
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='9')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='"', openquotechar='"')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='"', openquotechar=UInt8('"'))
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='"', closequotechar='"')
        @test_throws ArgumentError Parsers.xparse(T, "42"; groupmark='"', closequotechar=UInt8('"'))
    end

    @testset "$T groupmark=$(repr(g))" for g in (',',' '), T in (Int32, Int64)
        xgroupmark(c::Char) = Parsers._get_default_xoptions(groupmark=UInt8(c))
        for (input, expected_vals) in [
            ("1000,0000,2000,3000" => (1000,0,2000,3000,)),
            ("\"1000\",\"0000\",\"2000\",\"3000\"" => (1000,0,2000,3000,)),
            ("\"1$(g)0$(g)0$(g)0\",0000,\"2$(g)0$(g)0$(g)0\",3000" => (1000,0,2000,3000,)),
            ("1000,\"0$(g)0$(g)0$(g)0\",2000,\"3$(g)0$(g)0$(g)0\"" => (1000,0,2000,3000,)),
        ]
            pos = 1
            len = length(input)
            local res
            for expected in expected_vals
                res = Parsers.xparse(T, input, pos, len, xgroupmark(g))
                @test res.val == expected
                @test Parsers.ok(res.code)
                pos += res.tlen
            end
            @test Parsers.ok(res.code)
            @test Parsers.eof(res.code)
        end
    end

    # #168
    res = Parsers.parse(Int, "1,729", Parsers._get_default_options(groupmark=UInt8(',')))
    @test res == 1729

    @test_throws ArgumentError Parsers.xparse(Int, "3.14", groupmark='.', decimal=UInt8('.'), quoted=false)
    @test_throws ArgumentError Parsers.xparse(Int, "3.14", groupmark=UInt8('.'), decimal='.', quoted=false)
    @test_throws ArgumentError Parsers.xparse(Int, "3.14", groupmark=UInt8('.'), decimal=UInt8('.'), quoted=false)
    @test_throws ArgumentError Parsers.xparse(Int, "3.14", groupmark='.', decimal='.', quoted=false)
end

# test lots of ints
@time for i in typemin(Int64):100_000_000_000_000:typemax(Int64)
    str = string(i)
    res = Parsers.xparse(Int64, str)
    x, code, tlen = res.val, res.code, res.tlen
    @test string(x) == str
    @test code == OK | EOF
    @test tlen == length(str)
end

# test some critical ints Issue #44
for i in [typemin(Int64):typemin(Int64)+20; typemax(Int)-20:typemax(Int)]
    str = string(i)
    res = Parsers.xparse(Int64, str)
    x, code, tlen = res.val, res.code, res.tlen
    @test string(x) == str
    @test code == OK | EOF
    @test tlen == length(str)
end

end # @testset "ints"

@testset "bools" begin

trues1 = ["T"]
falses1 = ["F"]
trues2 = ["truthy"]
falses2 = ["falsy"]

testcases = [
    (str="", kwargs=(), x=false, code=(INVALID | EOF), tlen=0),
    (str="t", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=1),
    (str="tr", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=2),
    (str="tru", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=3),
    (str="true", kwargs=(), x=true, code=(OK | EOF), tlen=4),

    (str="f", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=1),
    (str="fa", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=2),
    (str="fal", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=3),
    (str="fals", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | EOF), tlen=4),
    (str="false", kwargs=(), x=false, code=(OK | EOF), tlen=5),

    (str="t,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=2),
    (str="tr,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=3),
    (str="tru,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=4),
    (str="true,", kwargs=(), x=true, code=(OK | DELIMITED), tlen=5),

    (str="f,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=2),
    (str="fa,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=3),
    (str="fal,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=4),
    (str="fals,", kwargs=(), x=false, code=(INVALID | INVALID_DELIMITER | DELIMITED), tlen=5),
    (str="false,", kwargs=(), x=false, code=(OK | DELIMITED), tlen=6),

    (str="0", kwargs=(), x=false, code=(OK | EOF), tlen=1),
    (str="1", kwargs=(), x=true, code=(OK | EOF), tlen=1),
    (str="001", kwargs=(), x=true, code=(OK | EOF), tlen=3),
    (str="2", kwargs=(), x=false, code=(INVALID | EOF | INVALID_DELIMITER), tlen=1),

    (str="t", kwargs=(trues=trues1, falses=falses1,), x=false, code=(INVALID | EOF | INVALID_DELIMITER), tlen=1),
    (str="T", kwargs=(trues=trues1, falses=falses1,), x=true, code=(OK | EOF), tlen=1),
    (str="T,", kwargs=(trues=trues1, falses=falses1,), x=true, code=(OK | DELIMITED), tlen=2),
    (str="Tr", kwargs=(trues=trues1, falses=falses1,), x=true, code=(OK | EOF | INVALID_DELIMITER), tlen=2),
    (str="F", kwargs=(trues=trues1, falses=falses1,), x=false, code=(OK | EOF), tlen=1),
    (str="truthy", kwargs=(trues=trues2, falses=falses2,), x=true, code=(OK | EOF), tlen=6),
    (str="truthyfalsy", kwargs=(trues=trues2, falses=falses2,), x=true, code=(OK | EOF | INVALID_DELIMITER), tlen=11),
    (str="falsytruthy", kwargs=(trues=trues2, falses=falses2,), x=false, code=(OK | EOF | INVALID_DELIMITER), tlen=11),
];

for useio in (false, true)
    for (i, case) in enumerate(testcases)
        # println("testing bool case i = $i, case = $case")
        res = Parsers.xparse(Bool, useio ? IOBuffer(case.str) : case.str; case.kwargs...)
        x, code, tlen = res.val, res.code, res.tlen
        if !Parsers.invalid(code) && !Parsers.sentinel(code)
            @test x == case.x
        end
        @test code == case.code
        @test tlen == case.tlen
    end
end

res = Parsers.xparse(Bool, "\"\""; sentinel=missing)
@test Parsers.sentinel(res.code)
res = Parsers.xparse(Bool, "\"\","; sentinel=missing)
@test Parsers.sentinel(res.code)
res = Parsers.xparse(Bool, "t,"; sentinel=missing)
@test !Parsers.sentinel(res.code)

end # @testset "bools"

@testset "regex delim" begin
    res = Parsers.xparse(Int, "123,456"; delim=r",")
    @test res.val == 123
    @test res.code == (OK | DELIMITED)
    @test res.tlen == 4
end

@testset "misc" begin

# additional tests for full xparse branch coverage
oq = UInt8('{')
cq = UInt8('}')
e = UInt8('\\')
str=" {\\"
res = Parsers.xparse(Int64, str; openquotechar=oq, closequotechar=cq, escapechar=e)
x, code, tlen = res.val, res.code, res.tlen
@test code == QUOTED | ESCAPED_STRING | EOF | INVALID_QUOTED_FIELD
@test tlen == 3

@test Parsers.parse(Int, "101") === 101
@test Parsers.parse(Float64, "101,101", Parsers.Options(decimal=',')) === 101.101
@test Parsers.parse(Bool, IOBuffer("true")) === true
@test_throws Parsers.Error Parsers.parse(Int, "abc")

@test Parsers.tryparse(Int, "abc") === nothing
@test Parsers.tryparse(Float32, IOBuffer("101,101"), Parsers.Options(decimal=',')) === Float32(101.101)
@test Parsers.parse(Date, "01/20/2018", Parsers.Options(dateformat="mm/dd/yyyy")) === Date(2018, 1, 20)

# https://github.com/JuliaData/CSV.jl/issues/345
res = Parsers.xparse(String, "\"DALLAS BLACK DANCE THEATRE\",")
x, code, tlen = res.val, res.code, res.tlen
@test x.pos == 2
@test x.len == 26
@test tlen == 29
@test code == OK | QUOTED | DELIMITED

# https://github.com/JuliaData/CSV.jl/issues/344
str = "1,2,null,4"
pos = 1
res = Parsers.xparse(Int, str; pos=pos, sentinel=["null"])
x, code, tlen = res.val, res.code, res.tlen
pos += tlen
@test x === 1
@test code === OK | DELIMITED
@test pos == 3
res = Parsers.xparse(Int, str; pos=pos, sentinel=["null"])
x, code, tlen = res.val, res.code, res.tlen
pos += tlen
@test x === 2
@test code === OK | DELIMITED
@test pos == 5
res = Parsers.xparse(Int, str; pos=pos, sentinel=["null"])
x, code, tlen = res.val, res.code, res.tlen
pos += tlen
@test code === SENTINEL | DELIMITED
@test pos == 10
res = Parsers.xparse(Int, str; pos=pos, sentinel=["null"])
x, code, tlen = res.val, res.code, res.tlen
pos += tlen
@test x === 4
@test code === OK | EOF
@test pos == 11

@test Parsers.parse(Int, SubString("101")) === 101
@test Parsers.parse(Float64, SubString("101,101"), Parsers.Options(decimal=',')) === 101.101

@test Parsers.asciival(' ')

@test_throws ArgumentError Parsers.Options(sentinel=[" "], stripwhitespace=true)
@test_throws ArgumentError Parsers.Options(sentinel=["\""])
@test_throws ArgumentError Parsers.Options(sentinel=[","], delim=',')
@test_throws ArgumentError Parsers.Options(sentinel=[","], delim=",")
@test_throws ArgumentError Parsers.Options(delim=r"\"")
@test_throws ArgumentError Parsers.Options(openquotechar="aaa", delim=r"a+")
@test_throws ArgumentError Parsers.Options(openquotechar=r"a+", delim="aaa")
@test_throws ArgumentError Parsers.Options(escapechar=UInt8('a'), delim="a")
@test_throws ArgumentError Parsers.Options(escapechar='a', delim=r"a")
@test_throws ArgumentError Parsers.Options(decimal='α')
@test_throws ArgumentError Parsers.Options(decimal='1')
@test_throws ArgumentError Parsers.Options(groupmark='α')
@test_throws ArgumentError Parsers.Options(groupmark='1')
@test_throws ArgumentError Parsers.Options(groupmark='α')
@test_throws ArgumentError Parsers.Options(groupmark=' ', decimal=' ')

@test Parsers.checkdelim!(UInt8[], 1, 0, Parsers.OPTIONS) == 1
@test Parsers.checkdelim!(codeunits(","), 1, 1, Parsers.XOPTIONS) == 2
@test Parsers.checkdelim!(codeunits("::"), 1, 2, Parsers.Options(delim="::")) == 3
@test Parsers.checkdelim!(codeunits(",,"), 1, 2, Parsers.Options(ignorerepeated=true, delim=',')) == 3
@test Parsers.checkdelim!(codeunits("::::"), 1, 4, Parsers.Options(delim="::", ignorerepeated=true)) == 5

e = Parsers.Error(Vector{UInt8}("hey"), Int64, INVALID | EOF, 1, 3)
io = IOBuffer()
showerror(io, e)
@test String(take!(io)) == "Parsers.Error (INVALID: EOF ):\ninitial value parsing failed, reached EOF\nattempted to parse Int64 from: \"hey\"\n"
e2 = Parsers.Error(IOBuffer("hey"), Int64, INVALID | EOF, 1, 3)
showerror(io, e2)
@test String(take!(io)) == "Parsers.Error (INVALID: EOF ):\ninitial value parsing failed, reached EOF\nattempted to parse Int64 from: \"hey\"\n"

@test Parsers.invalid(INVALID_DELIMITER)
@test Parsers.sentinel(SENTINEL)
@test !Parsers.sentinel(OK)
@test Parsers.quoted(QUOTED)
@test !Parsers.quoted(INVALID_DELIMITER)
@test Parsers.delimited(DELIMITED)
@test !Parsers.delimited(OK)
@test Parsers.newline(NEWLINE)
@test !Parsers.newline(DELIMITED)
@test Parsers.escapedstring(ESCAPED_STRING)
@test !Parsers.escapedstring(OK)
@test Parsers.invalidquotedfield(INVALID_QUOTED_FIELD)
@test !Parsers.invalidquotedfield(INVALID_DELIMITER)
@test Parsers.invaliddelimiter(INVALID_DELIMITER)
@test !Parsers.invaliddelimiter(INVALID_QUOTED_FIELD)
@test Parsers.overflow(OVERFLOW)
@test !Parsers.overflow(OK)
@test Parsers.quotednotescaped(QUOTED)
@test !Parsers.quotednotescaped(QUOTED | ESCAPED_STRING)

# https://github.com/JuliaData/CSV.jl/issues/454
res = Parsers.xparse(Float64, "\"\"", 1, 2)
@test Parsers.sentinel(res.code)

# #138
res = Parsers.xparse(String, "\"\"", 1, 2)
@test !Parsers.sentinel(res.code)

# #38
@test Parsers.parse(Date, "25JUL1985", Parsers.Options(dateformat="dduuuyyyy")) == Date(1985, 7, 25)

# https://github.com/JuliaIO/JSON.jl/issues/296
@test Parsers.parse(Float64, "99233885.0302231276962159466369304902338091026") === 9.923388503022313e7

# Int8 -1 parsed as UInt8 0xff
@test Parsers.parse(Int8, "-1") === Int8(-1)

# parsing am/pm issue
@test Parsers.parse(DateTime, "7/22/1998 4:37:01.500 PM", Parsers.Options(dateformat="m/d/yyyy I:M:S.s p")) == DateTime(1998, 7, 22, 16, 37, 1, 500)

# #55
# Parsers.parse must consume entire string
@test_throws Parsers.Error Parsers.parse(Int, "10a")
# but with IO will just consume until non digit
@test Parsers.parse(Int, IOBuffer("10a")) == 10

# #65
@test Parsers.parse(Char, "a") === 'a'
@test Parsers.parse(Char, "漢") === '漢'
@test Parsers.parse(Symbol, "a") === :a
@test Parsers.parse(Symbol, "漢") === :漢

res = Parsers.xparse(Char, codeunits("a"), 1, 1, Parsers.XOPTIONS)
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == 'a'
res = Parsers.xparse(Char, codeunits("漢"))
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == '漢'
res = Parsers.xparse(Symbol, codeunits("a"), 1, 1, Parsers.XOPTIONS)
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == :a
res = Parsers.xparse(Symbol, IOBuffer("a"), 1, 1, Parsers.XOPTIONS)
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == :a
res = Parsers.xparse(CustomType, codeunits("a"), 1, 1, Parsers.XOPTIONS)
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == CustomType("a")
res = Parsers.xparse(CustomType, IOBuffer("a"), 1, 1, Parsers.XOPTIONS)
@test res.code == (Parsers.EOF | Parsers.OK)
@test res.val == CustomType("a")

# 67
@test Parsers.parse(CustomType, "hey there", Parsers.XOPTIONS) == CustomType("hey there")

# https://github.com/JuliaData/CSV.jl/issues/780
missings = ["na"]
opts = Parsers.Options(sentinel=missings, trues=["true"])
@test missings == ["na"]

# reported from Slack via CSV.jl
res = Parsers.xparse(String, ""; sentinel=["NULL"])
@test res == Parsers.Result{PosLen}(OK | EOF, 0, Base.bitcast(PosLen, 0x0000000000100000))
res = Parsers.xparse(String, "", Parsers.PosLen31; sentinel=["NULL"])
@test res == Parsers.Result{Parsers.PosLen31}(OK | EOF, 0, Base.bitcast(Parsers.PosLen31, 0x0000000080000000))

# Parsers.getstring
@test Parsers.getstring(b"hey there", Parsers.PosLen(5, 5), 0x00) == "there"
@test Parsers.getstring(IOBuffer("hey there"), Parsers.PosLen(5, 5), 0x00) == "there"
@test Parsers.getstring("hey there", Parsers.PosLen(5, 5), 0x00) == "there"
@test Parsers.getstring("hey \"\" there", Parsers.PosLen(1, 12, false, true), UInt8('"')) == "hey \" there"
@test Parsers.getstring(IOBuffer("hey \"\" there"), Parsers.PosLen(1, 12, false, true), UInt8('"')) == "hey \" there"
@test Parsers.getstring(b"hey there", Parsers.PosLen31(5, 5), 0x00) == "there"
@test Parsers.getstring(IOBuffer("hey there"), Parsers.PosLen31(5, 5), 0x00) == "there"
@test Parsers.getstring("hey there", Parsers.PosLen31(5, 5), 0x00) == "there"
@test Parsers.getstring("hey \"\" there", Parsers.PosLen31(1, 12, false, true), UInt8('"')) == "hey \" there"
@test Parsers.getstring(IOBuffer("hey \"\" there"), Parsers.PosLen31(1, 12, false, true), UInt8('"')) == "hey \" there"

# PosLen
@test_throws ArgumentError Parsers.PosLen(Parsers._max_pos(Parsers.PosLen) + 1, 0)
@test_throws ArgumentError Parsers.PosLen(1, Parsers._max_len(Parsers.PosLen) + 1)
@test_throws ArgumentError Parsers.PosLen(1, 1).invalidproperty
@test_throws ArgumentError Parsers.PosLen31(Parsers._max_pos(Parsers.PosLen31) + 1, 0)
@test_throws ArgumentError Parsers.PosLen31(1, Parsers._max_len(Parsers.PosLen31) + 1)
@test_throws ArgumentError Parsers.PosLen31(1, 1).invalidproperty
# TODO: validate withlen and poslen

# test invalid fallback parsing
@test_throws Parsers.Error Parsers.parse(Complex{Float64}, "NaN+NaN*im")
@test Parsers.tryparse(Complex{Float64}, "NaN+NaN*im") === nothing

# test we parse and return the correct value up to an invalid delimiter
# https://github.com/JuliaData/Parsers.jl/issues/93
for (T, str, val) in (
    (Float64, "1.0 /", 1.0),
    (Float64, "1.0 /[ 2.0 ]/", 1.0),
    (Int, "2 _", 2),
    (Date, "2021-10-20 *", Date("2021-10-20")),
    (Bool, "false^", false),
)
    res = Parsers.xparse(T, str)
    @test Parsers.invaliddelimiter(res.code)
    @test res.val === val
end

# test `getstring` does not change the position of a stream
source = IOBuffer("\"str1\" \"str2\"")
opt = Parsers.Options(; delim=nothing, quoted=true)
res = Parsers.xparse(String, source, 1, 0, opt)
@test Parsers.getstring(source, res.val, opt.e) == "str1"
res = Parsers.xparse(String, source, 1 + res.tlen, 0, opt)
@test Parsers.getstring(source, res.val, opt.e) == "str2"
source = IOBuffer("\"str1\" \"str2\"")
opt = Parsers.Options(; delim=nothing, quoted=true)
res = Parsers.xparse(String, source, 1, 0, opt, Parsers.PosLen31)
@test Parsers.getstring(source, res.val, opt.e) == "str1"
res = Parsers.xparse(String, source, 1 + res.tlen, 0, opt, Parsers.PosLen31)
@test Parsers.getstring(source, res.val, opt.e) == "str2"

# checkdelim!
buf = UInt8[0x20, 0x20, 0x41, 0x20, 0x20, 0x42, 0x0a, 0x20, 0x20, 0x31, 0x20, 0x20, 0x32, 0x0a, 0x20, 0x20, 0x31, 0x31, 0x20, 0x32, 0x32]
@test Parsers.checkdelim!(buf, 1, 21, Parsers.Options(delim=' ', ignorerepeated=true)) == 3

# #150
@test 0x22 == Parsers.Token(0x22)
@test 0x22 != Parsers.Token(0x00)
@test Parsers.Token(0x22) == 0x22
@test Parsers.Token(0x22) != 0x00

# Char doesn't match delim
for delim in (',', ",", r",")
    res = Parsers.xparse(Char, ",,345", 1, 5, Parsers.Options(sentinel=missing, delim=delim))
    @test res.code == Parsers.SENTINEL | Parsers.DELIMITED
    @test res.tlen == 1
    if !isa(delim, Regex) # Regex matching not supported on IOBuffer
        res = Parsers.xparse(Char, IOBuffer(",,345"), 1, 5, Parsers.Options(sentinel=missing, delim=delim))
        @test res.code == Parsers.SENTINEL | Parsers.DELIMITED
        @test res.tlen == 1
    end
    res = Parsers.xparse(Char, ",,", 2, 2, Parsers.Options(sentinel=missing, delim=delim))
    @test res.code == Parsers.SENTINEL | Parsers.DELIMITED
    @test res.tlen == 1
    res = Parsers.xparse(Char, ",,", 3, 2, Parsers.Options(sentinel=missing, delim=delim))
    @test res.code == Parsers.SENTINEL | Parsers.EOF
    @test res.tlen == 0
end

end # @testset "misc"

include("floats.jl")
include("dates.jl")
include("hexadecimal.jl")


@testset "Aqua.jl" begin
    Aqua.test_all(Parsers)
end

@testset "parse(Number, x)" begin
    @test Parsers.parse(Number, "1") === Int64(1)
    @test Parsers.parse(Number, "1.0") === 1.0
    @test Parsers.parse(Number, "1.0f0") === 1.0f0
    @test Parsers.parse(Number, "1.0e0") === 1.0e0
    @test Parsers.parse(Number, "1.") === 1.0
    @test Parsers.parse(Number, "-1.") === -1.0
    @test Parsers.parse(Number, "9223372036854775807") === 9223372036854775807
    @test Parsers.parse(Number, "170141183460469231731687303715884105727") === 170141183460469231731687303715884105727
    @test Parsers.parse(Number, "0e348") == big"0.0"
    # Int128 literal
    @test Parsers.parse(Number, "9223372036854775808") === 9223372036854775808
    # BigInt
    @test Parsers.parse(Number, "170141183460469231731687303715884105728") == 170141183460469231731687303715884105728
    # BigFloat promotion
    @test Parsers.parse(Number, "1e310") == Base.parse(BigFloat, "1e310")
    @test Parsers.parse(Number, "1.7976931348623157e310") == big"1.7976931348623157e310"
    # error case
    @test_throws Parsers.Error Parsers.parse(Number, "-")
end

# https://github.com/JuliaData/CSV.jl/issues/1063
@testset "Serialization" begin
    tempfile = tempname()
    Serialization.serialize(tempfile, Parsers.Options())
    @test Serialization.deserialize(tempfile).flags == Parsers.Options().flags
end

end # @testset "Parsers"

include("trim_compile_tests.jl")

using PrecompileTools

@setup_workload begin
    # Putting some things in `setup` can reduce the size of the
    # precompile file and potentially make loading faster.
    options = Parsers.Options()
    pos = 1
    int_val = "123"
    float_val = "123.45"
    bool_val = "true"
    @compile_workload begin
        # all calls in this block will be precompiled, regardless of whether
        # they belong to your package or not (on Julia 1.8 and higher)
        for (T, val) in ((String, int_val), (Int32, int_val), (Int64, int_val), (Float64, float_val), (Bool, bool_val))
            len = length(val)
            for buf in (codeunits(val), Vector(codeunits(val)))
                Parsers.xparse(T, buf, pos, len, options)
                Parsers.xparse(T, buf, pos, len, options, Any)
            end
        end

        for (T, val) in ((Int32, int_val), (Int64, int_val), (Float64, float_val), (Bool, bool_val))
            for buf in (val, Vector(codeunits(val)))
                try
                    Parsers.parse(T, buf, options)
                catch
                end
                Parsers.tryparse(T, buf, options)
            end
        end
    end
end

using Test

const _TRIM_SAFE_ERROR_BUDGET = 0
const _TRIM_JULIA_SUPPORTED = VERSION >= v"1.12.0-rc1"
const _TRIM_HOST_SUPPORTED = Sys.WORD_SIZE == 64
const _TRIM_PRE_RELEASE = !isempty(VERSION.prerelease)
const _TRIM_COMPILE_TIMEOUT_S = Sys.iswindows() ? 600.0 : 120.0
const _TRIM_EXECUTABLE_TIMEOUT_S = Sys.iswindows() ? 120.0 : 30.0
const _TRIM_USE_BUNDLE = Sys.iswindows()
const _JULIAC_ENTRYPOINT_EXPR = "using JuliaC; if isdefined(JuliaC, :main); JuliaC.main(ARGS); else JuliaC._main_cli(ARGS); end"

# Pkg.test() sets JULIA_LOAD_PATH restrictively, which prevents subprocesses
# from finding stdlib packages like Pkg.  Remove it so subprocesses get the
# default load path.
function _clean_cmd(cmd::Cmd)
    env = Dict{String,String}(k => v for (k, v) in ENV if k != "JULIA_LOAD_PATH")
    return setenv(cmd, env)
end

function _setup_trim_env()
    # JuliaC requires Julia 1.12+ and can't be in [extras] without breaking
    # Pkg.test() on older Julia versions.  Create a temp project that dev's
    # Parsers from the local checkout and adds JuliaC.
    pkg_path = normpath(joinpath(@__DIR__, ".."))
    env_path = mktempdir()
    julia = joinpath(Sys.BINDIR, Base.julia_exename())
    setup_script = joinpath(env_path, "setup.jl")
    write(setup_script, """
    import Pkg
    Pkg.develop(path=$(repr(pkg_path)))
    Pkg.add("JuliaC")
    """)
    println("[trim] setting up temp environment with JuliaC...")
    flush(stdout)
    exit_code, output, timed_out = _run_command_with_timeout(
        _clean_cmd(`$julia --startup-file=no --history-file=no --project=$env_path $setup_script`);
        timeout_s = 120.0, log_label = "setup"
    )
    rm(setup_script; force = true)
    if exit_code != 0 || timed_out
        println("[trim] setup FAILED (exit=$exit_code, timed_out=$timed_out)")
        println(output)
        error("failed to set up trim test environment")
    end
    # the trim workload must build against the trim-specialized machinery —
    # the default (fast-TTFX) forms are intentionally not verifier-resolvable
    write(joinpath(env_path, "LocalPreferences.toml"), "[StructUtils]\ntrim_specialize = true\n")
    println("[trim] temp environment ready")
    return env_path
end

function _run_trim_compile(project_path::String, script_path::String, output_name::String; timeout_s::Float64 = _TRIM_COMPILE_TIMEOUT_S, bundle_dir::Union{Nothing, String} = nothing)
    julia_exe = joinpath(Sys.BINDIR, Base.julia_exename())
    cmd = if bundle_dir === nothing
        _clean_cmd(`$julia_exe --startup-file=no --history-file=no --code-coverage=none --project=$project_path -e $(_JULIAC_ENTRYPOINT_EXPR) -- --output-exe $output_name --project=$project_path --experimental --trim=safe $script_path`)
    else
        _clean_cmd(`$julia_exe --startup-file=no --history-file=no --code-coverage=none --project=$project_path -e $(_JULIAC_ENTRYPOINT_EXPR) -- --output-exe $output_name --bundle $bundle_dir --project=$project_path --experimental --trim=safe $script_path`)
    end
    return _run_command_with_timeout(cmd; timeout_s = timeout_s, log_label = "compile")
end

function _run_command_with_timeout(cmd::Cmd; timeout_s::Float64, log_label::String)
    output_path = tempname()
    out = open(output_path, "w")
    exit_code = -1
    timed_out = false
    try
        proc = run(pipeline(ignorestatus(cmd), stdout = out, stderr = out); wait = false)
        timed_out = _wait_process_with_timeout!(proc; timeout_s = timeout_s, log_label = log_label)
        exit_code = something(proc.exitcode, -1)
    finally
        close(out)
    end
    output = try
        read(output_path, String)
    catch
        ""
    finally
        rm(output_path; force = true)
    end
    return exit_code, output, timed_out
end

function _wait_process_with_timeout!(proc::Base.Process; timeout_s::Float64, log_label::String)
    started_at = time()
    next_log_at = started_at + 10.0
    timed_out = false
    while Base.process_running(proc)
        now = time()
        if now - started_at >= timeout_s
            timed_out = true
            try; kill(proc); catch; end
            break
        end
        if now >= next_log_at
            elapsed = round(now - started_at; digits = 1)
            println("[trim] $(log_label) WAIT $(elapsed)s")
            flush(stdout)
            next_log_at = now + 10.0
        end
        sleep(0.1)
    end
    try; wait(proc); catch; end
    return timed_out
end

function _parse_trim_verify_totals(output::String)
    m = match(r"Trim verify finished with\s+(\d+)\s+errors,\s+(\d+)\s+warnings\.", output)
    m === nothing && return nothing
    return parse(Int, m.captures[1]), parse(Int, m.captures[2])
end

function _run_trim_case(project_path::String, script_file::String, output_name::String)
    script_path = joinpath(@__DIR__, script_file)
    @test isfile(script_path)
    println("[trim] compile START $(script_file)")
    start_t = time()
    mktempdir() do tmpdir
        cd(tmpdir) do
            bundle_dir = _TRIM_USE_BUNDLE ? joinpath(tmpdir, "bundle") : nothing
            exit_code, output, timed_out = _run_trim_compile(project_path, script_path, output_name; bundle_dir = bundle_dir)
            if timed_out
                println("[trim] compile TIMED OUT for $(script_file)")
                println(output)
                @test false
                return
            end
            totals = _parse_trim_verify_totals(output)
            trim_errors, trim_warnings = if totals === nothing
                exit_code == 0 ? (0, 0) : error("failed to parse trim verifier summary:\n$output")
            else
                totals
            end
            if trim_errors > 0 || trim_warnings > 0
                println("---- trim compile output ($(script_file)) ----")
                println(output)
                println("---- end output ----")
            end
            @test trim_errors <= _TRIM_SAFE_ERROR_BUDGET
            @test trim_warnings == 0
            output_path = Sys.iswindows() ? "$(output_name).exe" : output_name
            if trim_errors == 0
                run_path = bundle_dir === nothing ? output_path : joinpath(bundle_dir, "bin", output_path)
                @test exit_code == 0
                @test isfile(run_path)
                run_cmd = `$(abspath(run_path))`
                run_exit, run_output, run_timed_out = _run_command_with_timeout(run_cmd; timeout_s = _TRIM_EXECUTABLE_TIMEOUT_S, log_label = "run")
                if run_timed_out
                    println("[trim] executable TIMED OUT for $(script_file)")
                    println(run_output)
                end
                if run_exit != 0
                    println("---- trim executable output ($(script_file)) ----")
                    println(run_output)
                    println("---- end output ----")
                end
                @test !run_timed_out
                @test run_exit == 0
            else
                @test exit_code != 0
            end
        end
    end
    println("[trim] compile DONE $(script_file) ($(round(time() - start_t; digits = 2))s)")
    return nothing
end

@testset "Trim compile" begin
    if !_TRIM_JULIA_SUPPORTED
        println("[trim] skip Julia < 1.12: JuliaC trim compilation is unavailable")
        @test true
    elseif !_TRIM_HOST_SUPPORTED
        println("[trim] skip 32-bit host: JuliaC requires a compatible 32-bit C toolchain")
        @test true
    elseif _TRIM_PRE_RELEASE
        println("[trim] skip prerelease Julia: trim verifier behavior is not stable yet")
        @test true
    else
        project_path = _setup_trim_env()
        trim_workloads = [
            ("parsers_trim_workload.jl", "parsers_trim_workload"),
        ]
        for (script_file, output_name) in trim_workloads
            _run_trim_case(project_path, script_file, output_name)
        end
    end
end

# Trim-compile workload: exercises the float parse paths, in particular every
# rung of the overflow-widening ladder (UInt64 → UInt128 → BigInt) that the
# trim fix makes statically reachable — under the old Base.inferencebarrier
# form these calls were verifier errors AND the widened instances were absent
# from trimmed binaries (wide-mantissa parses would fail at runtime). Compiled
# by test/trim_compile_tests.jl with `juliac --trim=safe` (error budget zero),
# then executed so the value assertions prove runtime rounding too.
using Parsers

function _assert_float_basics()::Nothing
    Parsers.parse(Float64, "1.5") === 1.5 || error("float basic")
    Parsers.parse(Float64, "-2.25e3") === -2250.0 || error("float exponent")
    Parsers.parse(Float64, "0.1") === 0.1 || error("float rounding")
    Parsers.parse(Float64, "0") === 0.0 || error("float zero")
    Parsers.parse(Float32, "1.5") === 1.5f0 || error("float32")
    Parsers.parse(Float16, "0.5") === Float16(0.5) || error("float16")
    return nothing
end

# the widening ladder itself: mantissas that overflow UInt64 (first rung) and
# UInt128 (second rung, into BigInt). Expected values are Base.parse results —
# Parsers must agree bit-for-bit.
function _assert_widening_ladder()::Nothing
    # 21 significant digits: overflows UInt64 accumulation -> UInt128
    Parsers.parse(Float64, "123456789012345678901.5") === 1.234567890123456789015e20 ||
        error("UInt128 rung")
    # 45 significant digits: overflows UInt128 -> BigInt
    Parsers.parse(Float64, "123456789012345678901234567890123456789012345.0") ===
        1.2345678901234567e44 || error("BigInt rung")
    # wide fractional digits take the _parsefrac widening path
    Parsers.parse(Float64, "0.123456789012345678901234567890123456789012345") ===
        0.12345678901234568 || error("frac widening")
    # widening in the presence of an exponent (_parseexp path)
    Parsers.parse(Float64, "123456789012345678901234567890e-10") ===
        1.2345678901234568e19 || error("exp widening")
    return nothing
end

function _assert_float_edges()::Nothing
    Parsers.parse(Float64, "1e310") === Inf || error("overflow Inf")
    Parsers.parse(Float64, "-1e310") === -Inf || error("overflow -Inf")
    Parsers.parse(Float64, "5e-324") === 5.0e-324 || error("denormal")
    Parsers.parse(Float64, "1.7976931348623157e308") === floatmax(Float64) || error("floatmax")
    isnan(Parsers.parse(Float64, "NaN")) || error("nan")
    Parsers.parse(Float64, "Inf") === Inf || error("inf literal")
    return nothing
end

function _assert_non_floats()::Nothing
    Parsers.parse(Int, "12345") === 12345 || error("int")
    Parsers.parse(Int, "-7") === -7 || error("negative int")
    Parsers.tryparse(Float64, "abc") === nothing || error("tryparse miss")
    t = Parsers.tryparse(Float64, "2.5")
    (t isa Float64 && t === 2.5) || error("tryparse hit")
    Parsers.parse(Bool, "true") === true || error("bool")
    return nothing
end

function run_parsers_trim_workload()::Nothing
    _assert_float_basics()
    _assert_widening_ladder()
    _assert_float_edges()
    _assert_non_floats()
    return nothing
end

function @main(args::Vector{String})::Cint
    _ = args
    run_parsers_trim_workload()
    return 0
end

Base.Experimental.entrypoint(main, (Vector{String},))

using Dates

@testset "Date.TimeTypes" begin

res = Parsers.xparse(Date, "")
x, code = res.val, res.code
@test code == INVALID | EOF
res = Parsers.xparse(Date, "2018-01-01")
x, code = res.val, res.code
@test x === Date(2018, 1, 01)
@test code == OK | EOF
res = Parsers.xparse(DateTime, "2018-01-01")
x, code = res.val, res.code
@test x === DateTime(2018, 1, 01)
@test code == OK | EOF
res = Parsers.xparse(Time, "01:02:03")
x, code = res.val, res.code
@test x === Time(1, 2, 3)
@test code == OK | EOF

res = Parsers.xparse(Time, codeunits("01:02:03"), 1, 8, Parsers.XOPTIONS)
x, code = res.val, res.code
@test x === Time(1, 2, 3)
@test code == OK | EOF

res = Parsers.xparse(Date, "")
x, code = res.val, res.code
@test code == INVALID | EOF
res = Parsers.xparse(Date, "\"\"")
x, code = res.val, res.code
@test code == QUOTED | INVALID | EOF
res = Parsers.xparse(Date, "2018-01-01")
x, code = res.val, res.code
@test x === Date(2018, 1, 01)
@test code == OK | EOF
res = Parsers.xparse(Date, "\"2018-01-01\"")
x, code = res.val, res.code
@test x === Date(2018, 1, 01)
@test code == QUOTED | OK | EOF
res = Parsers.xparse(DateTime, "\"2018-01-01")
x, code = res.val, res.code
@test code == OK | QUOTED | EOF | INVALID_QUOTED_FIELD
res = Parsers.xparse(Date, "\"abcd\"")
x, code = res.val, res.code
@test code == QUOTED | INVALID | EOF

res = Parsers.xparse(Date, "NA", sentinel=["NA"])
x, code = res.val, res.code
@test code === SENTINEL | EOF
res = Parsers.xparse(Date, "\\N", sentinel=["\\N"])
x, code = res.val, res.code
@test code === SENTINEL | EOF
res = Parsers.xparse(Date, "NA2", sentinel=["NA"])
x, code = res.val, res.code
@test code === SENTINEL | INVALID_DELIMITER | EOF
res = Parsers.xparse(Date, "-", sentinel=["-"])
x, code = res.val, res.code
@test code === SENTINEL | EOF
res = Parsers.xparse(Date, "£", sentinel=["£"])
x, code = res.val, res.code
@test code === SENTINEL | EOF
res = Parsers.xparse(Date, "null")
x, code = res.val, res.code
@test code === INVALID_DELIMITER | EOF
res = Parsers.xparse(Date, ",")
x, code = res.val, res.code
@test code === INVALID | DELIMITED
res = Parsers.xparse(Date, "1,")
x, code = res.val, res.code
@test x === Date(1)
@test code === OK | DELIMITED

res = Parsers.xparse(Date, "\"\""; sentinel=missing)
@test Parsers.sentinel(res.code)
res = Parsers.xparse(Date, "\"\","; sentinel=missing)
@test Parsers.sentinel(res.code)
res = Parsers.xparse(Date, "abc,"; sentinel=missing)
@test !Parsers.sentinel(res.code)

@test Parsers.parse(DateTime, "1996/Feb/15", Parsers.Options(dateformat="yy/uuu/dd")) === DateTime(1996, 2, 15)
@test Parsers.parse(DateTime, "1996, Jan, 15", Parsers.Options(dateformat="yyyy, uuu, dd")) === DateTime(1996, 1, 15)

@test_throws Parsers.Error Parsers.parse(Date, "2020-05-32")
@test_throws Parsers.Error Parsers.parse(DateTime, "2020-05-32")
@test_throws Parsers.Error Parsers.parse(Time, "25:00:00")
@test_throws Parsers.Error Parsers.parse(DateTime, "2020-05-05T00:00:60")

end

@testset "Date.TimeTypes IO" begin

    res = Parsers.xparse(Date, IOBuffer(""))
    x, code = res.val, res.code

    @test code == INVALID | EOF
    res = Parsers.xparse(Date, IOBuffer("2018-01-01"))
    x, code = res.val, res.code
    @test x === Date(2018, 1, 01)
    @test code == OK | EOF
    res = Parsers.xparse(DateTime, IOBuffer("2018-01-01"))
    x, code = res.val, res.code
    @test x === DateTime(2018, 1, 01)
    @test code == OK | EOF
    res = Parsers.xparse(Time, IOBuffer("01:02:03"))
    x, code = res.val, res.code
    @test x === Time(1, 2, 3)
    @test code == OK | EOF

    res = Parsers.xparse(Date, IOBuffer("\"\""))
    x, code = res.val, res.code

    @test code == QUOTED | INVALID | EOF
    res = Parsers.xparse(Date, IOBuffer("\"2018-01-01\""))
    x, code = res.val, res.code
    @test x === Date(2018, 1, 01)
    @test code == QUOTED | OK | EOF
    res = Parsers.xparse(DateTime, IOBuffer("\"2018-01-01"))
    x, code = res.val, res.code
    @test code == OK | QUOTED | EOF | INVALID_QUOTED_FIELD
    res = Parsers.xparse(Date, IOBuffer("\"abcd\""))
    x, code = res.val, res.code

    @test code == QUOTED | INVALID | EOF

    res = Parsers.xparse(Date, IOBuffer("NA"), sentinel=["NA"])
    x, code = res.val, res.code

    @test code === SENTINEL | EOF
    res = Parsers.xparse(Date, IOBuffer("\\N"), sentinel=["\\N"])
    x, code = res.val, res.code

    @test code === SENTINEL | EOF
    res = Parsers.xparse(Date, IOBuffer("NA2"), sentinel=["NA"])
    x, code = res.val, res.code

    @test code === SENTINEL | INVALID_DELIMITER | EOF
    res = Parsers.xparse(Date, IOBuffer("-"), sentinel=["-"])
    x, code = res.val, res.code

    @test code === SENTINEL | EOF
    res = Parsers.xparse(Date, IOBuffer("£"), sentinel=["£"])
    x, code = res.val, res.code

    @test code === SENTINEL | EOF
    res = Parsers.xparse(Date, IOBuffer("null"))
    x, code = res.val, res.code

    @test code === INVALID_DELIMITER | EOF
    res = Parsers.xparse(Date, IOBuffer(","))
    x, code = res.val, res.code

    @test code === INVALID | DELIMITED
    res = Parsers.xparse(Date, IOBuffer("1,"))
    x, code = res.val, res.code
    @test x === Date(1)
    @test code === OK | DELIMITED

    @test Parsers.parse(DateTime, IOBuffer("1996/Feb/15"), Parsers.Options(dateformat="yy/uuu/dd")) === DateTime(1996, 2, 15)
    @test Parsers.parse(DateTime, IOBuffer("1996, Jan, 15"), Parsers.Options(dateformat="yyyy, uuu, dd")) === DateTime(1996, 1, 15)

    @test_throws Parsers.Error Parsers.parse(Date, IOBuffer("2020-05-32"))
    @test_throws Parsers.Error Parsers.parse(DateTime, IOBuffer("2020-05-32"))
    @test_throws Parsers.Error Parsers.parse(Time, IOBuffer("25:00:00"))
    @test_throws Parsers.Error Parsers.parse(DateTime, IOBuffer("2020-05-05T00:00:60"))

end

@test_throws Parsers.Error Parsers.parse(DateTime, "a02/15/1996 25:00", Parsers.Options(dateformat=Parsers.Format("mm/dd/yyyy HH:MM")))
@test_throws Parsers.Error Parsers.parse(DateTime, "02/15/1996 25:00", Parsers.Options(dateformat=Parsers.Format("mm/dd/yyyy HH:MM")))
@test_throws Parsers.Error Parsers.parse(DateTime, "1996-Jan-15", Parsers.Options(dateformat="yy-mm-dd"))
@test_throws Parsers.Error Parsers.parse(DateTime, "96/2/15", Parsers.Options(dateformat="yy/uuu/dd"))
@test_throws Parsers.Error Parsers.parse(DateTime, "2017-Mar-17 00:00:00.1234", Parsers.Options(dateformat="y-u-d H:M:S.s"))
@test_throws Parsers.Error Parsers.parse(DateTime, "96/2/15", Parsers.Options(dateformat="yy𒀱uuu/dd"))

@test_throws Parsers.Error Parsers.parse(Time, "24:00")  # invalid hours
@test_throws Parsers.Error Parsers.parse(Time, "00:60")  # invalid minutes
@test_throws Parsers.Error Parsers.parse(Time, "00:00:60")  # invalid seconds
@test_throws Parsers.Error Parsers.parse(Time, "20:03:20", Parsers.Options(dateformat="HH:MM"))  # too much precision
@test_throws Parsers.Error Parsers.parse(Time, "10:33:51", Parsers.Options(dateformat="yyyy-mm-dd HH:MM:SS"))  # Time can't hold year/month/day
@test Parsers.parse(Time, "2021-06-26 10:33:51", Parsers.Options(dateformat="yyyy-mm-dd HH:MM:SS")) == Time(10, 33, 51)

Dates.LOCALES["french"] = Dates.DateLocale(
    ["janvier", "février", "mars", "avril", "mai", "juin",
        "juillet", "août", "septembre", "octobre", "novembre", "décembre"],
    ["janv", "févr", "mars", "avril", "mai", "juin",
        "juil", "août", "sept", "oct", "nov", "déc"],
    ["lundi", "mardi", "mercredi", "jeudi", "vendredi", "samedi", "dimanche"],
    [""],
)

Dates.LOCALES["gobblygook"] = Dates.DateLocale(
    ["𒀱"],
    ["𒀱"],
    [""],
    [""],
)

testcases = [
    ("yy-mm-dd", "96-01-15", Dates.DateTime(96, 1, 15)),
    ("yy-mm-dd", "96-1-15", Dates.DateTime(96, 1, 15)),
    ("yy-mm-dd", "96-1-1", Dates.DateTime(96, 1, 1)),
    ("yy-mm-dd", "1996-1-15", Dates.DateTime(1996, 1, 15)),
    ("yy/uuu/dd", "96/Feb/15", Dates.DateTime(96, 2, 15)),
    ("yy/uuu/dd", "1996/Feb/15", Dates.DateTime(1996, 2, 15)),
    ("yy/uuu/dd", "96/Feb/1", Dates.DateTime(96, 2, 1)),

    ("yyyy, uuu, dd", "1996, Jan, 15", Dates.DateTime(1996, 1, 15)),
    ("yyyy.U.dd", "1996.February.15", Dates.DateTime(1996, 2, 15)),
    ("yyyymmdd", "19960315", Dates.DateTime(1996, 3, 15)),
    ("yyyy-mm-dd HH:MM:SS", "1996-12-15 10:00:00", Dates.DateTime(1996, 12, 15, 10)),
    ("ymd", "999", Dates.DateTime(9, 9, 9)),
    ("/yyyy/m/d", "/1996/5/15", Dates.DateTime(1996, 5, 15)),
    ("yyyy年mm月dd日", "2009年12月01日", Dates.DateTime(2009, 12, 1)),
    ("yyyy𒀱mm𒀱dd", "2021𒀱6𒀱28", Dates.Date(2021, 6, 28)),

    (Parsers.Format("dd uuuuu YYYY", "french"), "28 mai 2014", Dates.DateTime(2014, 5, 28)),
    (Parsers.Format("dd uuuuu yyyy", "french"), "28 févr 2014", Dates.DateTime(2014, 2, 28)),
    (Parsers.Format("dd uuuuu yyyy", "french"), "28 août 2014", Dates.DateTime(2014, 8, 28)),
    (Parsers.Format("dd u yyyy", "french"), "28 avril 2014", Dates.DateTime(2014, 4, 28)),
    (Parsers.Format("dduuuuyyyy", "french"), "28mai2014", Dates.DateTime(2014, 5, 28)),
    (Parsers.Format("dduuuuyyyy", "french"), "28août2014", Dates.DateTime(2014, 8, 28)),
    (Parsers.Format("dd uuuuu YYYY", "gobblygook"), "28 𒀱 2014", Dates.DateTime(2014, 1, 28)),

    ("[HH:MM:SS.sss]", "[14:51:00.118]", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),
    ("HH:MM:SS.sss", "14:51:00.118", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),
    ("[HH:MM:SS.sss?", "[14:51:00.118?", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),
    ("?HH:MM:SS.sss?", "?14:51:00.118?", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),
    ("xHH:MM:SS.sss]", "x14:51:00.118]", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),
    ("HH:MM:SS.sss]", "14:51:00.118]", Dates.DateTime(1, 1, 1, 14, 51, 0, 118)),

    (Dates.RFC1123Format, "Sat, 23 Aug 2014 17:22:15", Dates.DateTime(2014, 8, 23, 17, 22, 15)),
    ("E, dd u yyyy HH:MM:SS", "Saturday, 23 Aug 2014 17:22:15", Dates.DateTime(2014, 8, 23, 17, 22, 15)),
    # milliseconds
    ("y-u-d H:M:S.s", "2017-Mar-17 00:00:00.0000", Dates.DateTime(2017, 3, 17, 0, 0, 0, 0)),
    ("y-u-d H:M:S.s", "2017-Mar-17 00:00:00.1", Dates.DateTime(2017, 3, 17, 0, 0, 0, 100)),
    ("y-u-d H:M:S.s", "2017-Mar-17 00:00:00.12", Dates.DateTime(2017, 3, 17, 0, 0, 0, 120)),
    ("y-u-d H:M:S.s", "2017-Mar-17 00:00:00.123", Dates.DateTime(2017, 3, 17, 0, 0, 0, 123)),
    ("y-u-d H:M:S.s", "2017-Mar-17 00:00:00.1230", Dates.DateTime(2017, 3, 17, 0, 0, 0, 123)),
]

for useio in (true, false)
    for case in testcases
        fmt, str, dt = case
        @test Parsers.parse(typeof(dt), useio ? IOBuffer(str) : str, Parsers.Options(dateformat=fmt)) == dt
    end
end

res = Parsers.xparse(DateTime, "2017-Mar-17 00:00:00.1231", dateformat="y-u-d H:M:S.s", rounding=nothing)
@test res.code == EOF | INEXACT
res = Parsers.xparse(DateTime, "2017-Mar-17 00:00:00.1231", dateformat="y-u-d H:M:S.s", rounding=RoundNearest)
@test res.code == EOF | OK
@test res.val == Dates.DateTime(2017, 3, 17, 0, 0, 0, 123)
res = Parsers.xparse(DateTime, "2017-Mar-17 00:00:00.1231", dateformat="y-u-d H:M:S.s", rounding=RoundUp)
@test res.code == EOF | OK
@test res.val == Dates.DateTime(2017, 3, 17, 0, 0, 0, 124)

@static if VERSION >= v"1.3-DEV"
@testset "AM/PM" begin
    for (t12,t24) in (("12:00am","00:00"), ("12:07am","00:07"), ("01:24AM","01:24"),
                    ("12:00pm","12:00"), ("12:15pm","12:15"), ("11:59PM","23:59"))
        d = DateTime("2018-01-01T$t24:00")
        t = Time("$t24:00")
        for HH in ("HH","II")
            @test Parsers.parse(DateTime, "2018-01-01 $t12", Parsers.Options(dateformat="yyyy-mm-dd $HH:MMp")) == d
            @test Parsers.parse(Time, "$t12", Parsers.Options(dateformat="$HH:MMp")) == t
        end
    end
    for bad in ("00:24am", "00:24pm", "13:24pm", "2pm", "12:24p.m.", "12:24 pm", "12:24pµ")
        @test_throws Parsers.Error Parsers.parse(Time, bad, Parsers.Options(dateformat="II:MMp"))
    end
    # if am/pm is missing, defaults to 24-hour clock
    @test Parsers.parse(Time, "13:24", Parsers.Options(dateformat="II:MMp")) == Parsers.parse(Time, "13:24", Parsers.Options(dateformat="HH:MM"))
end
end

struct Error <: Exception
    str::String
    T
    code
end

Error(buf::AbstractString, T, code, pos, tlen) = Error(buf, T, code)
Error(buf::AbstractVector{UInt8}, T, code, pos, tlen) = Error(String(buf[pos:(pos + tlen - 1)]), T, code)

function Error(buf::IO, T, code, pos, tlen)
    fastseek!(buf, pos - 1)
    bytes = read(buf, tlen)
    return Error(String(bytes), T, code)
end

function Base.showerror(io::IO, e::Error)
    c = e.code
    println(io, "Parsers.Error ($(codes(c))):")
    println(io, text(c))
    println(io, "attempted to parse $(e.T) from: \"$(escape_string(e.str))\"")
end

# backwards compat
neededdigits(::Type{Float64}) = 309 + 17
neededdigits(::Type{Float32}) = 39 + 9 + 2
neededdigits(::Type{Float16}) = 9 + 5 + 9

"""
A bitmask value, with various bits corresponding to different parsing signals and scenarios.

`Parsers.xparse` returns a `code` value with various bits set according to the various scenarios
encountered while parsing a value.

* `INVALID`: there are a number of invalid parsing states, all include the INVALID bit set (check via `Parsers.invalid(code)`)
* `OK`: signals specifically that a valid value of type `T` was parsed (check via `Parsers.ok(code)`)
* `SENTINEL`: signals that a valid sentinel value was detected while parsing, passed via the `sentinel` keyword argument to `Parsers.Options` (check via `Parsers.sentinel(code)`)
* `QUOTED`: a `openquotechar` from `Parsers.Options` was detected at the beginning of parsing (check via `Parsers.quoted(code)`)
* `DELIMITED`: a `delim` character or string from `Parsers.Options` was detected while parsing (check via `Parsers.delimited(code)`)
* `NEWLINE`: a non-quoted newline character (`'\\n'`), return character (`'\\r'`), or CRLF (`"\\r\\n"`) was detected while parsing (check via `Parsers.newline(code)`)
* `EOF`: the end of file was reached while parsing
* `ESCAPED_STRING`: an `escapechar` from `Parsers.Options` was encountered while parsing (check via `Parsers.escapedstring(code)`)
* `INVALID_QUOTED_FIELD`: a `openquotechar` were detected when parsing began, but no corresponding `closequotechar` were found to correctly close a quoted field, this is usually a fatal parsing error because parsing will continue until EOF to look for the close quote character (check via `Parsers.invalidquotedfield(code)`)
* `INVALID_DELIMITER`: a `delim` character or string were eventually detected, but not at the expected position (directly after parsing a valid value), indicating there are extra, invalid characters between a valid value and the expected delimiter (check via `Parsers.invaliddelimiter(code)`)
* `OVERFLOW`: overflow occurred while parsing a type, like `Integer`, that have limits on valid values (check via `Parsers.overflow(code)`)

One additional convenience function is provided, `Parsers.quotednotescaped(code)`, which checks if a value was quoted,
but didn't contain any escape characters, useful to indicate if a string may be used "as-is", instead of needing to be unescaped.
"""
const ReturnCode = Int16

const SUCCESS = 0b0000000000000000 % ReturnCode
const INVALID = 0b1000000000000000 % ReturnCode

# success flags
const OK                   = 0b0000000000000001 % ReturnCode
const SENTINEL             = 0b0000000000000010 % ReturnCode

# property flags
const QUOTED               = 0b0000000000000100 % ReturnCode
const DELIMITED            = 0b0000000000001000 % ReturnCode
const NEWLINE              = 0b0000000000010000 % ReturnCode
const EOF                  = 0b0000000000100000 % ReturnCode
const ESCAPED_STRING       = 0b0000001000000000 % ReturnCode
const SPECIAL_VALUE        = 0b0000010000000000 % ReturnCode

# invalid flags
const INVALID_QUOTED_FIELD = 0b1000000001000000 % ReturnCode
const INVALID_DELIMITER    = 0b1000000010000000 % ReturnCode
const OVERFLOW             = 0b1000000100000000 % ReturnCode
const INVALID_TOKEN        = 0b1000010000000000 % ReturnCode
const INEXACT              = 0b1000100000000000 % ReturnCode

valueok(x::ReturnCode) = (x & OK) == OK
ok(x::ReturnCode) = (x & (OK | INVALID)) == OK
invalid(x::ReturnCode) = x < SUCCESS
sentinel(x::ReturnCode) = (x & SENTINEL) == SENTINEL
quoted(x::ReturnCode) = (x & QUOTED) == QUOTED
delimited(x::ReturnCode) = (x & DELIMITED) == DELIMITED
newline(x::ReturnCode) = (x & NEWLINE) == NEWLINE
escapedstring(x::ReturnCode) = (x & ESCAPED_STRING) == ESCAPED_STRING
specialvalue(x::ReturnCode) = (x & SPECIAL_VALUE) == SPECIAL_VALUE
invalidquotedfield(x::ReturnCode) = (x & INVALID_QUOTED_FIELD) == INVALID_QUOTED_FIELD
invaliddelimiter(x::ReturnCode) = (x & INVALID_DELIMITER) == INVALID_DELIMITER
overflow(x::ReturnCode) = (x & OVERFLOW) == OVERFLOW
inexact(x::ReturnCode) = (x & INEXACT) == INEXACT
quotednotescaped(x::ReturnCode) = (x & (QUOTED | ESCAPED_STRING)) == QUOTED
invalidtoken(x::ReturnCode) = (x & INVALID_TOKEN) == INVALID_TOKEN
eof(x::ReturnCode) = (x & EOF) == EOF

memcmp(a::Ptr{UInt8}, b::Ptr{UInt8}, len::Int) = ccall(:memcmp, Cint, (Ptr{UInt8}, Ptr{UInt8}, Csize_t), a, b, len) == 0

struct RegexAndMatchData
    re::Regex
    data::Ptr{Cvoid}
end

function mkregex(re::Regex)
    Base.compile(re)
    return RegexAndMatchData(re, Base.PCRE.create_match_data(re.regex))
end

const ByteStringRegex = Union{UInt8, String, RegexAndMatchData}

struct Token
    token::ByteStringRegex
end
import Base: ==
function ==(a::Token, b::Token)
    t1 = a.token
    t2 = b.token
    if t1 isa UInt8 && t2 isa UInt8
        return t1 == t2
    elseif t1 isa String && t2 isa String
        return t1 == t2
    elseif t1 isa RegexAndMatchData && t2 isa RegexAndMatchData
        return t1.re == t2.re
    else
        return false
    end
end
==(a::Token, b::UInt8) = a.token isa UInt8 && a.token == b
==(a::UInt8, b::Token) = (b == a)

# methods for `_contains(::Token, ::String)`:
_contains(a::Token, str::String) = _contains(a.token, str)
_contains(a::UInt8, str::String) = a == UInt8(str[1])
_contains(a::Char, str::String) = a == str[1]
_contains(a::RegexAndMatchData, str::String) = contains(a.re.pattern, str)
_contains(a::Token, char::Char) = _contains(a.token, char)
_contains(a::UInt8, char::Char) = ncodeunits(char) == 1 && (Base.zext_int(UInt32, a) << 24) == Base.bitcast(UInt32, char)
_contains(a::Char, char::Char) = a == char
_contains(a::RegexAndMatchData, char::Char) = contains(a.re.pattern, char)

_contains(a, b::UInt8) = _contains(a, Char(b))
_contains(a, b) = _contains(a, string(b))
_contains(a, b::Nothing) = false
_contains(a::String, str::String) = contains(a, str)
# methods for `_contains(::String, ::MaybeToken)`:
_contains(a::String, b::UInt8) = _contains(a, Char(b))
_contains(a::String, b::Char) = _contains(a, string(b))
_contains(a::String, b::Regex) = contains(a, b.pattern)
_contains(a::String, b::Nothing) = false

function Base.isempty(x::Token)
    t = x.token
    return t isa String && isempty(t)
end

@noinline notsupported() = throw(ArgumentError("Regex matching not supported on this input type"))

function checktoken(source, pos, len, b, token::Token)
    tok = token.token
    if tok isa UInt8
        check = tok == b
        check && incr!(source)
        return check, pos + check
    elseif tok isa String
        if source isa Vector{UInt8}
            # specialize common case
            return checktoken(source, pos, len, b, tok)
        else
            return checktoken(source, pos, len, b, tok)
        end
    elseif tok isa RegexAndMatchData
        if source isa Vector{UInt8} || source isa Base.CodeUnits{UInt8, String} || source isa AbstractVector{UInt8}
            return checktoken(source, pos, len, b, tok)
        else
            notsupported()
        end
    else
        error() # unreachable
    end
end

function checktoken(source, pos, len, b, tok::UInt8)
    check = tok == b
    check && incr!(source)
    return check, pos + check
end

function checktoken(source::AbstractVector{UInt8}, pos, len, b, tok::RegexAndMatchData)
    rc = ccall((:pcre2_match_8, Base.PCRE.PCRE_LIB), Cint,
        (Ptr{Cvoid}, Ptr{UInt8}, Csize_t, Csize_t, UInt32, Ptr{Cvoid}, Ptr{Cvoid}),
        tok.re.regex, source, len, pos - 1, tok.re.match_options, tok.data, Base.PCRE.get_local_match_context())
    rc < -2 && error("PCRE.exec error: $(Base.PCRE.err_message(rc))")
    check = rc >= 0
    return check, pos + (!check ? 0 : Base.PCRE.substring_length_bynumber(tok.data, 0))
end

function checktoken(source::AbstractVector{UInt8}, pos, len, b, tok::String)
    sz = sizeof(tok)
    check = (pos + sz - 1) <= len && memcmp(pointer(source, pos), pointer(tok), sz)
    return check, pos + (check * sz)
end

function checktoken(source::IO, pos, len, b, tok::String)
    bytes = codeunits(tok)
    startpos = pos
    blen = length(bytes)
    for i = 1:blen
        @inbounds b2 = bytes[i]
        if b2 != b
            fastseek!(source, startpos - 1)
            return false, startpos
        end
        pos += 1
        incr!(source)
        i == blen && break
        if eof(source, pos, len)
            fastseek!(source, startpos - 1)
            return false, startpos
        end
        b = peekbyte(source, pos)
    end
    return true, pos
end

function checktokens(source, pos, len, b, tokens::Union{Vector{String}, Vector{Token}}, consume=false)
    if source isa IO && !consume
        origpos = position(source)
    end
    for token in tokens
        check, pos = checktoken(source, pos, len, b, token)
        if check
            source isa IO && !consume && fastseek!(source, origpos)
            return true, pos
        end
    end
    source isa IO && !consume && fastseek!(source, origpos)
    return false, pos
end

function checkcmtemptylines(source, pos, len, cmt, ignoreemptylines)
    while !eof(source, pos, len)
        skipped = false
        if ignoreemptylines
            b = peekbyte(source, pos)
            if b == UInt8('\n')
                pos += 1
                incr!(source)
                skipped = true
            elseif b == UInt8('\r')
                pos += 1
                incr!(source)
                if !eof(source, pos, len) && peekbyte(source, pos) == UInt8('\n')
                    pos += 1
                    incr!(source)
                end
                skipped = true
            end
        end
        matched = false
        if !isempty(cmt) && !eof(source, pos, len)
            b = peekbyte(source, pos)
            matched, pos = checktoken(source, pos, len, b, cmt)
            if matched
                eof(source, pos, len) && break
                b = peekbyte(source, pos)
                while true
                    # consume the rest of the line/row until we hit the newline
                    if b == UInt8('\n')
                        pos += 1
                        incr!(source)
                        break
                    elseif b == UInt8('\r')
                        pos += 1
                        incr!(source)
                        if !eof(source, pos, len) && peekbyte(source, pos) == UInt8('\n')
                            pos += 1
                            incr!(source)
                        end
                        break
                    end
                    pos += 1
                    incr!(source)
                    eof(source, pos, len) && break
                    b = peekbyte(source, pos)
                end
            end
        end
        (skipped | matched) || break
    end
    return pos
end

"""
    Parsers.fastseek!(io::IO, n::Integer)

    Without valididty checks, seek an `IO` to desired byte position `n`. Used in Parsers.jl to
    seek back to a previous location already parsed.
"""
function fastseek! end

fastseek!(io::IO, n::Integer) = seek(io, n)
function fastseek!(io::IOBuffer, n::Integer)
    io.ptr = n + 1
    return
end
fastseek!(io::Union{AbstractVector{UInt8}, AbstractString}, n::Integer) = nothing

"""
    Parsers.readbyte(io::IO)::UInt8

    Consume a single byte from an `IO` without checking `eof(io)`.
"""
function readbyte end

"""
    Parsers.peekbyte(io::IO)::UInt8

    Return, but do not consume, the next byte from an `IO` without checking `eof(io)`.
"""
function peekbyte end

incr!(io::IO) = readbyte(io)
readbyte(from::IO) = Base.read(from, UInt8)
peekbyte(from::IO) = UInt8(Base.peek(from))

function readbyte(from::IOBuffer)
    i = from.ptr
    @inbounds byte = from.data[i]
    from.ptr = i + 1
    return byte
end

function peekbyte(from::IOBuffer)
    @inbounds byte = from.data[from.ptr]
    return byte
end

function incr!(from::IOBuffer)
    from.ptr += 1
    return
end

incr!(::Union{AbstractVector{UInt8}, AbstractString}) = nothing
peekbyte(from::IO, pos) = peekbyte(from)
function peekbyte(from::AbstractVector{UInt8}, pos)
    @inbounds b = from[pos]
    return b
end
function peekbyte(from::AbstractString, pos)
    @inbounds b = codeunit(from, pos)
    return b
end

eof(::AbstractVector{UInt8}, pos::Integer, len::Integer) = pos > len
eof(::AbstractString, pos::Integer, len::Integer) = pos > len
eof(source::IO, pos::Integer, len::Integer) = Base.eof(source)
eof(io::Base.GenericIOBuffer, pos::Integer, len::Integer) = (io.ptr - 1) >= io.size

function text(r)
    str = ""
    if r & QUOTED > 0
        str = "encountered an opening quote character, initial value parsing "
    else
        str = "initial value parsing "
    end
    if r & OK > 0
        str *= "succeeded"
    else
        str *= "failed"
    end
    if r & (~INVALID & OVERFLOW) > 0
        str *= ", value overflowed"
    end
    if r & (~INVALID & INEXACT) > 0
        str *= ", value is inexactly represented"
    end
    if r & SENTINEL > 0
        str *= ", a sentinel value was parsed"
    end
    if r & SPECIAL_VALUE > 0
        str *= ", a special value was parsed"
    end
    if r & ESCAPED_STRING > 0
        str *= ", encountered escape character"
    end
    if r & (~INVALID & INVALID_QUOTED_FIELD) > 0
        str *= ", invalid quoted value"
    end
    if r & DELIMITED > 0
        str *= ", a valid delimiter was parsed"
    end
    if r & NEWLINE > 0
        str *= ", a newline was encountered"
    end
    if r & EOF > 0
        str *= ", reached EOF"
    end
    if r & (~INVALID & INVALID_DELIMITER) > 0
        str *= ", invalid delimiter"
    end
    return str
end

codes(r) = chop(chop(string(
    ifelse(r > 0, "SUCCESS: ", "INVALID: "),
    ifelse(r & OK > 0, "OK | ", ""),
    ifelse(r & SENTINEL > 0, "SENTINEL | ", ""),
    ifelse(r & QUOTED > 0, "QUOTED | ", ""),
    ifelse(r & ESCAPED_STRING > 0, "ESCAPED_STRING | ", ""),
    ifelse(r & DELIMITED > 0, "DELIMITED | ", ""),
    ifelse(r & NEWLINE > 0, "NEWLINE | ", ""),
    ifelse(r & EOF > 0, "EOF | ", ""),
    ifelse(r & SPECIAL_VALUE > 0, "SPECIAL_VALUE | ", ""),
    ifelse(r & (~INVALID & INVALID_QUOTED_FIELD) > 0, "INVALID_QUOTED_FIELD | ", ""),
    ifelse(r & (~INVALID & INVALID_DELIMITER) > 0, "INVALID_DELIMITER | ", ""),
    ifelse(r & (~INVALID & OVERFLOW) > 0, "OVERFLOW | ", ""),
    ifelse(r & (~INVALID & INEXACT) > 0, "INEXACT | ", ""),
)))

"""
    PosLen(pos, len, ismissing, escaped)

A custom 64-bit primitive that allows efficiently storing the byte position
and length of a value within a byte array, along with whether a sentinel
value was parsed, and whether the parsed value includes escaped characters.
Specifically, the use of 64-bits is:
  * 1 bit to indicate whether a sentinel value was encountered while parsing
  * 1 bit to indicate whether the escape character was encountered while parsing
  * 42 bits to note the byte position as an integer where a value is located in a byte array (max array size ~4.4TB)
  * 20 bits to note the length of a parsed value (max length of ~1MB)

These individual "fields" can be retrieved via dot access, like `PosLen.missingvalue`, `PosLen.escapedvalue`,
`PosLen.pos`, `PosLen.len`.

`Parsers.xparse(String, buf, pos, len, opts)` returns `Parsers.Result{PosLen}`, where the `x.val` is a `PosLen`.
"""
primitive type PosLen 64 end
primitive type PosLen31 64 end

const MISSING_BIT = Base.bitcast(Int64, 0x8000000000000000)
const ESCAPE_BIT = Base.bitcast(Int64, 0x4000000000000000)
_pos_shift(::Union{PosLen,Type{PosLen}}) = 20
_max_pos(::Union{PosLen,Type{PosLen}}) = 4398046511104
_max_len(::Union{PosLen,Type{PosLen}}) = 1048575
_pos_bits(::Union{PosLen,Type{PosLen}}) = Base.bitcast(Int64, 0x3ffffffffff00000)
_len_bits(::Union{PosLen,Type{PosLen}}) = Base.bitcast(Int64, 0x00000000000fffff)

_pos_shift(::Union{PosLen31,Type{PosLen31}}) = 31
_max_pos(::Union{PosLen31,Type{PosLen31}}) = Int64(2147483648)
_max_len(::Union{PosLen31,Type{PosLen31}}) = Int64(2147483647)
_pos_bits(::Union{PosLen31,Type{PosLen31}}) = Base.bitcast(Int64, 0x3fffffff80000000)
_len_bits(::Union{PosLen31,Type{PosLen31}}) = Base.bitcast(Int64, 0x000000007fffffff)

@noinline postoolarge(::Type{T}, pos) where {T} =
    throw(ArgumentError("position argument to $T ($pos) is too large; max position allowed is $(_max_pos(T))"))
@noinline lentoolarge(::Type{T}, len) where {T} =
    throw(ArgumentError("length argument to $T ($len) is too large; max length allowed is $(_max_len(T))"))

for T in (:PosLen, :PosLen31)
    @eval function $T(pos::Integer, len::Integer, ismissing=false, escaped=false)
        pos > _max_pos($T) && postoolarge($T, pos)
        len > _max_len($T) && lentoolarge($T, len)
        @assert pos >= 0
        @assert len >= 0
        pos = Int64(pos) << _pos_shift($T)
        pos |= ifelse(ismissing, MISSING_BIT, 0)
        pos |= ifelse(escaped, ESCAPE_BIT, 0)
        return Base.bitcast($T, pos | Int64(len))
    end

    @eval @noinline invalidproperty(::Type{$T}, nm) = throw(ArgumentError("invalid property $nm for $($T)"))
    @eval function Base.getproperty(x::$T, nm::Symbol)
        y = Base.bitcast(Int64, x)
        nm === :pos && return (y & _pos_bits($T)) >> _pos_shift($T)
        nm === :len && return y & _len_bits($T)
        nm === :missingvalue && return (y & MISSING_BIT) == MISSING_BIT
        nm === :escapedvalue && return (y & ESCAPE_BIT) == ESCAPE_BIT
        invalidproperty($T, nm)
    end
    @eval Base.propertynames(::$T) = (:pos, :len, :missingvalue, :escapedvalue)
    @eval Base.show(io::IO, x::$T) = print(io, "$($T)(pos=$(x.pos), len=$(x.len), missingvalue=$(x.missingvalue), escapedvalue=$(x.escapedvalue))")
end

poslen(pos::Integer, len::Integer) = poslen(PosLen, pos, len)
poslen(::Type{T}, pos::Integer, len::Integer) where {T} = Base.bitcast(PosLen,   (Int64(pos) << _pos_shift(PosLen))   | Int64(len))
poslen(::Type{PosLen31}, pos::Integer, len::Integer)    = Base.bitcast(PosLen31, (Int64(pos) << _pos_shift(PosLen31)) | Int64(len))

withlen(pl::T, len::Integer) where {T<:Union{PosLen,PosLen31}} = Base.bitcast(T, (Base.bitcast(Int64, pl) & (~_max_len(T))) | Int64(len))
withmissing(pl::T) where {T<:Union{PosLen,PosLen31}} = Base.or_int(pl, Base.bitcast(T, MISSING_BIT))
withescaped(pl::T) where {T<:Union{PosLen,PosLen31}} = Base.or_int(pl, Base.bitcast(T, ESCAPE_BIT))

"""
    Parsers.getstring(buf_or_io, poslen::PosLen, e::UInt8) => String

When calling `Parsers.xparse` with a `String` type argument, a `Parsers.Result{PosLen}` is returned, which has 3 fields:
  * `val`: a [`PosLen`](@ref) value which stores the starting byte position and length of the parsed string value
  * `code`: a parsing return code indicating success/failure
  * `tlen`: the total number of bytes parsed, which may differ from `val.len` if delimiters or open/close quotes were parsed

If the actual parsed `String` _is_ needed, however, you can pass your source and the `res.val::PosLen` to `Parsers.getstring`
to get the actual parsed `String` value.
"""
function getstring end

_unsafe_string(p, len) = ccall(:jl_pchar_to_string, Ref{String}, (Ptr{UInt8}, Int), p, len)

getstring(source::Union{IO, AbstractVector{UInt8}}, x::Union{PosLen,PosLen31}, e::Token) =
    getstring(source, x, e.token::UInt8)

function getstring(source::Union{IO, AbstractVector{UInt8}}, x::Union{PosLen,PosLen31}, e::UInt8)
    x.escapedvalue && return unescape(source, x, e)
    if source isa AbstractVector{UInt8}
        return _unsafe_string(pointer(source, x.pos), x.len)
    else
        pos = position(source)
        vpos, vlen = x.pos, x.len
        fastseek!(source, vpos - 1)
        str = Base.StringVector(vlen)
        readbytes!(source, str, vlen)
        fastseek!(source, pos) # reset IO to earlier position
        return String(str)
    end
end

getstring(str::AbstractString, pl::Union{PosLen,PosLen31}, e::UInt8) = getstring(codeunits(str), pl, e)

# if a cell value of a csv file has escape characters, we need to unescape it
@noinline function unescape(origbuf, x::Union{PosLen,PosLen31}, e)
    n = x.len
    if origbuf isa AbstractVector{UInt8}
        source = view(origbuf, x.pos:(x.pos + x.len - 1))
    else
        origpos = position(origbuf)
        fastseek!(origbuf, x.pos - 1)
        source = origbuf
    end
    out = Base.StringVector(n)
    len = 1
    i = 1
    @inbounds begin
        while i <= n
            b = peekbyte(source, i)
            if b == e
                incr!(source)
                i += 1
                b = peekbyte(source, i)
            end
            out[len] = b
            len += 1
            incr!(source)
            i += 1
        end
    end
    if origbuf isa IO
        fastseek!(origbuf, origpos)
    end
    resize!(out, len - 1)
    return String(out)
end

using BenchmarkTools, Parsers, Dates

# tryparse
@benchmark Parsers.parse(Int64, "-86706967560385154")
@benchmark Parsers.tryparse(Int64, "-86706967560385154")

# xparse
@benchmark Parsers.xparse(Int64, "\"-86706967560385154\",", 1, 21)
@benchmark Parsers.xparse(Int64, "-86706967560385154", 1, 18, Parsers.XOPTIONS, Int64)

const ff = Parsers.Result(Parsers.emptysentinel(options)(Parsers.delimiter(options)(Parsers.whitespace(options)(
    Parsers.quoted(options)(Parsers.whitespace(options)(Parsers.sentinel(options)(Parsers.typeparser(options)
)))))))
const buf = Vector{UInt8}("\"-86706967560385154\",")
@benchmark ff(String, buf, 1, 21, Parsers.PosLen)

# String
@benchmark Parsers.xparse(String, "\"-86706967560385154\",", 1, 21)
@benchmark Parsers.xparse(String, "-86706967560385154", 1, 18, Parsers.XOPTIONS, Parsers.PosLen)

# Int
@benchmark Parsers.parse(Int64, "10")
@benchmark Base.parse(Int64, "10")
@benchmark Parsers.parse(Int64, "-86706967560385154")
@benchmark Base.parse(Int64, "-86706967560385154")

# Float64
@benchmark Parsers.parse(Float64, "10")
@benchmark Base.parse(Float64, "10")
@benchmark Parsers.parse(Float64, "-86706967560385154")
@benchmark Base.parse(Float64, "-86706967560385154")
@benchmark Parsers.parse(Float64, "NaN")
@benchmark Base.parse(Float64, "NaN")
@benchmark Parsers.parse(Float64, "0.0017138347201173243")
@benchmark Base.parse(Float64, "0.0017138347201173243")
@benchmark Parsers.parse(Float64, "2.2250738585072011e-308")
@benchmark Base.parse(Float64, "2.2250738585072011e-308")

# Date
#TODO
const ffff = Parsers.Result(Parsers.typeparser(Parsers.OPTIONS))
const src = Vector{UInt8}("2019-01-01")
@benchmark ffff(Date, src, 1, 10, Date)
@benchmark Parsers._xparse2(Date, src, 1, 10, Parsers.OPTIONS, Date)
@benchmark Parsers.parse(Date, "2019-01-01")
@benchmark Base.parse(Date, "2019-01-01")

@benchmark Parsers.parse(DateTime, "2019-01-01")
@benchmark Base.parse(DateTime, "2019-01-01")

@benchmark Parsers.parse(DateTime, "2019-01-01T01:02:03")
@benchmark Base.parse(DateTime, "2019-01-01T01:02:03")

using Test
using UUIDs
using Parsers


@testset "Hexadecimal" begin
    _OPTIONS = Parsers.Options(delim=',', quoted=true)

    swapchar(s, i, c) = s[1:i-1] * c * s[i+1:end]

    @testset "UUID" begin
        us = "01234567-abcd-ef01-2345-6789ABCDEF01"
        u = UUID(us)
        for i in 1:35
            res = Parsers.xparse(UUID, us, 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(UUID, IOBuffer(us), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(UUID, view(us, 1:i), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(UUID, IOBuffer(view(us, 1:i)), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)
        end
        res = Parsers.xparse(UUID, us, 1, 36, _OPTIONS)
        @test Parsers.ok(res.code)
        @test res.val == u

        res = Parsers.xparse(UUID, IOBuffer(us), 1, 36, _OPTIONS)
        @test Parsers.ok(res.code)
        @test res.val == u

        for i in 1:36
            bad_input = swapchar(us, i, 'g')
            res = Parsers.xparse(UUID, bad_input, 1, 36, _OPTIONS)
            @test Parsers.invalid(res.code)
            res = Parsers.xparse(UUID, IOBuffer(bad_input), 1, 36, _OPTIONS)
            @test Parsers.invalid(res.code)
        end

        res = Parsers.xparse(UUID, us * "1", 1, 37, _OPTIONS)
        @test Parsers.invalid(res.code)
        res = Parsers.xparse(UUID, IOBuffer(us * "1"), 1, 37, _OPTIONS)
        @test Parsers.invalid(res.code)
    end

    @testset "SHA1" begin
        ss = "0123456789abcdef0123456789ABCDEF01234567"
        s = Parsers.SHA1((0x01234567, 0x89abcdef, 0x01234567, 0x89abcdef, 0x01234567))

        @test string(s) == lowercase(ss)

        for i in 1:39
            res = Parsers.xparse(Parsers.SHA1, ss, 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(Parsers.SHA1, IOBuffer(ss), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(Parsers.SHA1, view(ss, 1:i), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(Parsers.SHA1, IOBuffer(view(ss, 1:i)), 1, i, _OPTIONS)
            @test Parsers.invalid(res.code)
        end
        res = Parsers.xparse(Parsers.SHA1, ss, 1, 40, _OPTIONS)
        @test Parsers.ok(res.code)
        @test res.val == s

        res = Parsers.xparse(Parsers.SHA1, IOBuffer(ss), 1, 40, _OPTIONS)
        @test Parsers.ok(res.code)
        @test res.val == s

        for i in 1:40
            bad_input = swapchar(ss, i, 'g')
            res = Parsers.xparse(Parsers.SHA1, bad_input, 1, 40, _OPTIONS)
            @test Parsers.invalid(res.code)

            res = Parsers.xparse(Parsers.SHA1, IOBuffer(bad_input), 1, 40, _OPTIONS)
            @test Parsers.invalid(res.code)
        end

        res = Parsers.xparse(Parsers.SHA1, ss * "1", 1, 41, _OPTIONS)
        @test Parsers.invalid(res.code)
        res = Parsers.xparse(Parsers.SHA1, IOBuffer(ss * "1"), 1, 41, _OPTIONS)
        @test Parsers.invalid(res.code)
    end
end

overflows(::Type{T}) where {T} = true
overflows(::Type{BigInt}) = false
overflowval(::Type{T}) where {T <: Integer} = div(typemax(T) - T(9), T(10))
# if we eventually support non-base 10
# overflowval(::Type{T}, base) where {T <: Integer} = div(typemax(T) - base + 1, base)

@inline function typeparser(::AbstractConf{T}, source, pos, len, b, code, pl, opts) where {T <: Integer}
    x = zero(T)
    neg = false
    has_groupmark = _has_groupmark(opts, code)
    groupmark0 = something(opts.groupmark, 0xff) - UInt8('0')
    # start actual int parsing
    neg = b == UInt8('-')
    if neg || b == UInt8('+')
        pos += 1
        incr!(source)
    end
    if eof(source, pos, len)
        code |= INVALID | EOF
        @goto done
    end
    b = peekbyte(source, pos) - UInt8('0')
    if b > 0x09
        # character isn't a digit, INVALID value
        code |= INVALID
        @goto done
    end
    prev_b0 = b
    while true
        if b <= 0x09
            overflows(T) && x > overflowval(T) && break
            x = T(10) * x + unsafe_trunc(T, b)
            pos += 1
            incr!(source)
            if eof(source, pos, len)
                x = ifelse(neg, -x, x)
                code |= OK | EOF
                @goto done
            end
        elseif has_groupmark && b == groupmark0
            prev_b0 == groupmark0 && (code |= INVALID; @goto done) # two groupmarks in a row
            pos += 1
            Parsers.incr!(source)
            Parsers.eof(source, pos, len) && (code |= INVALID | EOF; @goto done) # groupmark at end of input
        else
            # detected a non-digit, time to bail on value parsing
            x = ifelse(neg, -x, x)
            # Cannot end on a groupmark
            (has_groupmark && prev_b0 == groupmark0) ? (code |= INVALID) : (code |= OK)
            @goto done
        end
        prev_b0 = b
        b = peekbyte(source, pos) - UInt8('0')
    end
    # extra loop because we got too close to overflowing while parsing digits
    x = ifelse(neg, -x, x)
    while true
        if b <= 0x09
            x, ov_mul = Base.mul_with_overflow(x, T(10))
            x, ov_add = Base.add_with_overflow(x, ifelse(neg, -T(b), T(b)))
            if ov_mul | ov_add
                # we overflowed, mark as OVERFLOW
                code |= OVERFLOW
                # in this case, we know b is a digit that caused us
                # to overflow, so we don't really want to consider it for
                # a close quote character or delimiter, so if b is the last character
                # let's just bail as eof
                pos += 1
                incr!(source)
                if eof(source, pos, len)
                    code |= EOF
                end
                @goto done
            end
            pos += 1
            incr!(source)
            if eof(source, pos, len)
                code |= OK | EOF
                @goto done
            end
        elseif has_groupmark && b == groupmark0
            prev_b0 == groupmark0 && (code |= INVALID; @goto done) # two groupmarks in a row
            pos += 1
            Parsers.incr!(source)
            Parsers.eof(source, pos, len) && (code |= INVALID | EOF; @goto done) # groupmark at end of input
        else
            # detected a non-digit, time to bail on value parsing
            x = ifelse(neg, -x, x)
            # Cannot end on a groupmark
            (has_groupmark && prev_b0 == groupmark0) ? (code |= INVALID) : (code |= OK)
            @goto done
        end
        prev_b0 = b
        b = peekbyte(source, pos) - UInt8('0')
    end

@label done
    return pos, code, PosLen(pl.pos, pos - pl.pos), x
end

function typeparser(::AbstractConf{Number}, source, pos, len, b, code, pl, opts)
    x = Ref{Number}()
    pos, code = parsenumber(source, pos, len, b, y -> (x[] = y), opts)
    return pos, code, PosLen(pl.pos, pos - pl.pos), isdefined(x, :x) ? x[] : (0::Number)
end

function parsenumber(source, pos, len, b, f::F, opts=OPTIONS) where {F}
    startpos = pos
    code = startcode = SUCCESS
    # begin parsing
    neg = b == UInt8('-')
    if neg || b == UInt8('+')
        pos += 1
        incr!(source)
    end
    if eof(source, pos, len)
        code |= INVALID | EOF
        @goto done
    end
    b = peekbyte(source, pos)
    # parse rest of number
    _, code, pos = parsedigits(DefaultConf{Number}(), source, pos, len, b, code, OPTIONS, Int64(0), neg, startpos, true, 0, f)
    if invalid(code)
        # by default, parsedigits only has up to Float64 precision; if we overflow
        # let's try BigFloat
        pos, code, _, x = typeparser(DefaultConf{BigFloat}(), source, startpos, len, b, startcode, poslen(pos, 0), opts)
        if ok(code)
            f(x)
        end
    end

@label done
    return pos, code
end

# All bytes that are not hex digits are 0x0000FFFF
const _HEX_LUT = UInt32[
    b in UInt8('0'):UInt8('9') ? UInt32(b - UInt8('0')) :
        b in UInt8('a'):UInt8('f') ? UInt32(b - UInt8('a') + 0x0a) :
        b in UInt8('A'):UInt8('F') ? UInt32(b - UInt8('A') + 0x0a) :
        0xFFFF
    for b
    in UInt8(0):UInt8(255)
]

const _HEX_LUT_INV = UInt8.((
    '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f',
))

### SHA1 ###

struct SHA1
    h::NTuple{5,UInt32}
end

function Base.string(s::SHA1)
    out = Base.StringVector(40)
    i = 40
    @inbounds for j in 5:-1:1
        h = s.h[j]
        for _ in 1:8
            out[i] = _HEX_LUT_INV[0x01 + (h & 0x0f)]
            h >>= 4
            i -= 1
        end
    end
    return String(out)
end

# give SHA1 scalar behavior in broadcasting
Base.broadcastable(x::SHA1) = Ref(x)

supportedtype(::Type{SHA1}) = true

_set_tup5_at(t::NTuple{5,UInt32}, i, x::UInt32) = ntuple(j -> j == i ? x : t[j], 5)

function typeparser(::AbstractConf{SHA1}, source, pos, len, b, code, pl, options)
    if len - pos + 1 < 40
        @inbounds while pos <= len && _HEX_LUT[peekbyte(source, pos) + 0x01] != 0xFFFF
            pos += 1
            incr!(source)
        end
        eof(source, pos, len) && (code |= EOF)
        return (pos, code | INVALID, poslen(pl.pos, pos - pl.pos), SHA1((0,0,0,0,0)))
    end

    check = UInt32(0)
    out = ntuple(j -> UInt32(0), 5)
    @inbounds for i in 1:5
        h = UInt32(0)
        for _ in 0:7 # Maybe unroll?
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            h = ((h << 4) | c)
            pos += 1
            incr!(source)
        end
        # Only check validity every 8 bytes to hopefully enable some vectorization
        if check == 0xFFFF
            pos -= 8 # Backtrack to the start of the invalid hex
            fastseek!(source, pos - 1)
            while _HEX_LUT[peekbyte(source, pos) + 0x01] != 0xFFFF
                pos += 1
                incr!(source)
            end
            return pos, code | INVALID, poslen(pl.pos, pos - pl.pos), SHA1(out)
        end
        out = _set_tup5_at(out, i, h)
    end
    eof(source, pos, len) && (code |= EOF)
    return (pos, code | OK, poslen(pl.pos, pos - pl.pos), SHA1(out))
end

### UUID ###

supportedtype(::Type{UUID}) = true

function typeparser(::AbstractConf{UUID}, source, pos, len, b, code, pl, options)
    check = UInt32(0)
    hi = UInt64(0)
    lo = UInt64(0)

    @inbounds begin
        if len - pos + 1 < 36
            while (_HEX_LUT[b + 0x01] != 0xFFFF || b == UInt8('-'))
                pos += 1
                incr!(source)
                pos <= len || break
                b = peekbyte(source, pos)
            end
            eof(source, pos, len) && (code |= EOF)
            return (pos, code | INVALID, poslen(pl.pos, pos - pl.pos), UUID((hi, lo)))
        end

        segment_len = 8
        for _ in 1:segment_len
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            hi = ((hi << 4) | c)
            pos += 1
            incr!(source)
        end
        check != 0xFFFF || (return _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl))
        peekbyte(source, pos) == UInt8('-') || @goto error

        pos += 1
        incr!(source)
        segment_len = 4
        for _ in 1:segment_len
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            hi = ((hi << 4) | c)
            pos += 1
            incr!(source)
        end
        check != 0xFFFF || (return _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl))
        peekbyte(source, pos) == UInt8('-') || @goto error

        pos += 1
        incr!(source)
        segment_len = 4
        for _ in 1:segment_len
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            hi = ((hi << 4) | c)
            pos += 1
            incr!(source)
        end
        check != 0xFFFF || (return _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl))
        peekbyte(source, pos) == UInt8('-') || @goto error

        pos += 1
        incr!(source)
        segment_len = 4
        for _ in 1:segment_len
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            lo = ((lo << 4) | c)
            pos += 1
            incr!(source)
        end
        check != 0xFFFF || (return _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl))
        peekbyte(source, pos) == UInt8('-') || @goto error

        pos += 1
        incr!(source)
        segment_len = 12
        for _ in 1:segment_len
            b = peekbyte(source, pos)
            c = _HEX_LUT[b + 0x01]
            check |= c
            lo = ((lo << 4) | c)
            pos += 1
            incr!(source)
        end
        check != 0xFFFF || (return _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl))
    end # @inbounds

    eof(source, pos, len) && (code |= EOF)
    return (pos, code | OK, poslen(pl.pos, pos - pl.pos), UUID((hi, lo)))

    @label error
    eof(source, pos, len) && (code |= EOF)
    return (pos, code | INVALID, poslen(pl.pos, pos - pl.pos), UUID((hi, lo)))
end

@noinline function _backtrack_error(source, pos, len, code, segment_len, hi, lo, pl)
    pos -= segment_len # Backtrack to the start of the invalid hex
    fastseek!(source, pos - 1)
    b = peekbyte(source, pos)
    while (_HEX_LUT[b + 0x01] != 0xFFFF || b == UInt8('-'))
        pos += 1
        incr!(source)
        pos <= len || break
        b = peekbyte(source, pos)
    end
    eof(source, pos, len) && (code |= EOF)
    return (pos, code | INVALID, poslen(pl.pos, pos - pl.pos), UUID((hi, lo)))
end

isgreedy(::Type{T}) where {T <: AbstractString} = true
isgreedy(::Type{Symbol}) = true
isgreedy(T) = false

@inline function typeparser(::AbstractConf{T}, source, pos, len, b, code, pl, opts) where {T <: AbstractString}
    if quoted(code)
        code |= OK
        return findendquoted(T, source, pos, len, b, code, pl, true, opts.cq, opts.e, opts.flags.stripquoted)
    elseif opts.flags.checkdelim
        code |= OK
        return finddelimiter(T, source, pos, len, b, code, pl, opts.delim, opts.flags.ignorerepeated, opts.cmt, opts.flags.ignoreemptylines, opts.flags.stripwhitespace)
    else
        code |= OK
        return findeof(source, pos, len, b, code, pl, opts)
    end
end

function findeof(source, pos, len, b, code, pl, opts)
    # no delimiter, so read until EOF
    # if stripwhitespace, then we need to keep track of the last non-whitespace character
    # in order to strip trailing whitespace
    lastnonwhitepos = pos
    while !eof(source, pos, len)
        b = peekbyte(source, pos)
        wh = iswh(b)
        lastnonwhitepos = opts.flags.stripwhitespace ? (wh ? lastnonwhitepos : pos) : pos
        pos += 1
        incr!(source)
    end
    code |= EOF
    pl = poslen(typeof(pl), pl.pos, (lastnonwhitepos - pl.pos) + 1)
    return pos, code, pl, pl
end

function typeparser(::AbstractConf{Char}, source, pos, len, b, code, pl, opts)
    startpos = pos
    l = 8 * (4 - leading_ones(b))
    c = UInt32(b) << 24
    if eof(source, pos, len)
        code |= INVALID | EOF
        @goto done
    end
    s = 16
    while true
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            code |= EOF
            @goto done
        end
        b = peekbyte(source, pos)
        if l >= 24 || s < l || (b & 0xc0) != 0x80
            @goto done
        end
        c |= UInt32(b) << s
        s -= 8
    end

@label done
    # Char is *almost* not greedy; it's not greedy in that we know how much
    # to parse, independent of parsing stream contents, but we still need
    # to account for the possibility of the Options.delim being a Char
    # and treating that as a delim instead of a successfully parsed Char
    # hence the checkdelim + _contains check before setting OK
    ch = reinterpret(Char, c)
    if Base.isoverlong(ch) || Base.ismalformed(ch)
        code |= INVALID
    elseif opts.flags.checkdelim && _contains(opts.delim, ch)
        code |= INVALID
        code &= ~EOF
        pos = startpos
        fastseek!(source, startpos)
    else
        code |= OK
    end
    return pos, code, PosLen(pl.pos, pos - pl.pos), ch
end

function typeparser(::AbstractConf{Symbol}, source, pos, len, b, code, pl, opts)
    if quoted(code)
        code |= OK
        pos, code, pl, _ = findendquoted(Symbol, source, pos, len, b, code, pl, true, opts.cq, opts.e, opts.stripquoted)
    elseif opts.flags.checkdelim
        code |= OK
        pos, code, pl, _ = finddelimiter(Symbol, source, pos, len, b, code, pl, opts.delim, opts.flags.ignorerepeated, opts.cmt, opts.ignoreemptylines, opts.flags.stripwhitespace)
    else
        code |= OK
        pos, code, pl, _ = findeof(source, pos, len, b, code, pl, opts)
    end
    if source isa AbstractVector{UInt8}
        sym = ccall(:jl_symbol_n, Ref{Symbol}, (Ptr{UInt8}, Int), pointer(source, pl.pos), pl.len)
    else
        sym = Symbol(getstring(source, pl, opts.e))
    end
    return pos, code, pl, sym
end

struct Delim{T} <: Dates.AbstractDateToken
    d::T
end

charactercode(::Dates.DatePart{c}) where {c} = c

function Format(f::AbstractString, locale::Dates.DateLocale=Dates.ENGLISH)
    tokens = Dates.AbstractDateToken[]
    prev = ()
    prev_offset = 1

    letters = String(collect(keys(Dates.CONVERSION_SPECIFIERS)))
    for m in eachmatch(Regex("(?<!\\\\)([\\Q$letters\\E])\\1*"), f)
        tran = replace(f[prev_offset:prevind(f, m.offset)], r"\\(.)" => s"\1")

        if !isempty(prev)
            letter, width = prev
            typ = Dates.CONVERSION_SPECIFIERS[letter]

            push!(tokens, Dates.DatePart{letter}(width, isempty(tran)))
        end

        if !isempty(tran)
            push!(tokens, length(tran) == 1 ? Delim(first(tran)) : Delim(tran))
        end

        letter = f[m.offset]
        width = length(m.match)

        prev = (letter, width)
        prev_offset = m.offset + width
    end

    tran = replace(f[prev_offset:lastindex(f)], r"\\(.)" => s"\1")

    if !isempty(prev)
        letter, width = prev
        typ = Dates.CONVERSION_SPECIFIERS[letter]

        push!(tokens, Dates.DatePart{letter}(width, false))
    end

    if !isempty(tran)
        push!(tokens, length(tran) == 1 ? Delim(first(tran)) : Delim(tran))
    end

    return Format(tokens, locale)
end

function Format(f::AbstractString, locale::AbstractString)
    Format(f, Dates.LOCALES[locale])
end

function Format(df::Dates.DateFormat{S, T}) where {S, T}
    N = fieldcount(T)
    dftokens = df.tokens
    tokens = Vector{Dates.AbstractDateToken}(undef, fieldcount(T))
    Base.@nexprs 15 i -> begin
        if i <= N
            @inbounds tok = dftokens[i]
            @inbounds tokens[i] = tok isa Dates.Delim ? Delim(tok.d) : dftokens[i]
        end
    end
    if N > 15
        for i = 16:N
            @inbounds tok = dftokens[i]
            @inbounds tokens[i] = tok isa Dates.Delim ? Delim(tok.d) : dftokens[i]
        end
    end
    return Format(tokens, df.locale)
end

function Base.show(io::IO, df::Format)
    print(io, "Parsers.dateformat\"")
    for t in df.tokens
        _show_content(io, t)
    end
    print(io, '"')
end
Base.Broadcast.broadcastable(x::Format) = Ref(x)

function _show_content(io::IO, d::Dates.DatePart{c}) where c
    for i = 1:d.width
        print(io, c)
    end
end

function _show_content(io::IO, d::Delim{<:AbstractChar})
    if d.d in keys(Dates.CONVERSION_SPECIFIERS)
        for i = 1:1
            print(io, '\\', d.d)
        end
    else
        for i = 1:1
            print(io, d.d)
        end
    end
end

function _show_content(io::IO, d::Delim)
    for c in d.d
        if c in keys(Dates.CONVERSION_SPECIFIERS)
            print(io, '\\')
        end
        print(io, c)
    end
end

function Base.show(io::IO, d::Delim)
    print(io, "Delim(")
    _show_content(io, d)
    print(io, ")")
end

macro dateformat_str(str)
    Format(str)
end

# Standard formats
const ISODateTimeFormat = Format("yyyy-mm-dd\\THH:MM:SS.s")
const ISODateFormat = Format("yyyy-mm-dd")
const ISOTimeFormat = Format("HH:MM:SS.s")
const RFC1123Format = Format("e, dd u yyyy HH:MM:SS")

default_format(::Type{DateTime}) = ISODateTimeFormat
default_format(::Type{Date}) = ISODateFormat
default_format(::Type{Time}) = ISOTimeFormat

maxdigits(d::Dates.DatePart) = d.fixed ? d.width : typemax(Int64)

for c in "yYmdHIMS"
    @eval begin
        function tryparsenext(d::Dates.DatePart{$c}, source, pos, len, b, code)
            return tryparsenext_base10(source, pos, len, b, code, maxdigits(d))
        end
    end
end

function tryparsenext_base10(source, pos, len, b, code, maxdigits)
    x::Int64 = 0
    b -= UInt8('0')
    if b > 0x09
        # character isn't a digit, INVALID value
        code |= INVALID
        b += UInt8('0')
        @goto done
    end
    ndigits = 0
    @inbounds while true
        x = Int64(10) * x + Int64(b)
        ndigits += 1
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            code |= EOF
            @goto done
        end
        b = peekbyte(source, pos) - UInt8('0')
        if b > 0x09 || ndigits == maxdigits
            b += UInt8('0')
            @goto done
        end
    end
    @label done
    return x, pos, b, code
end

ascii_lc(c::UInt8) = c in UInt8('A'):UInt8('Z') ? c + 0x20 : c

function tryparsenext(d::Dates.DatePart{'p'}, source, pos, len, b, code)
    ap = ascii_lc(b)
    pos += 1
    incr!(source)
    if !(ap == UInt8('a') || ap == UInt8('p')) || eof(source, pos, len)
        code |= INVALID_TOKEN
    else
        b = peekbyte(source, pos)
        if ascii_lc(b) != UInt8('m')
            code |= INVALID_TOKEN
        end
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            code |= EOF
        else
            b = peekbyte(source, pos)
        end
    end
    return ap == UInt8('a') ? Dates.AM : Dates.PM, pos, b, code
end

function nextchar(source, pos, len, b)
    u = UInt32(b) << 24
    if !Base.between(b, 0x80, 0xf7)
        pos += 1
        incr!(source)
        return reinterpret(Char, u), pos
    end
    return nextchar_continued(source, pos, len, u)
end

function nextchar_continued(source, pos, len, u)
    u < 0xc0000000 && (pos += 1; incr!(source); @goto ret)
    # first continuation byte
    pos += 1
    incr!(source)
    eof(source, pos, len) && @goto ret
    b = peekbyte(source, pos)
    b & 0xc0 == 0x80 || @goto ret
    u |= UInt32(b) << 16
    # second continuation byte
    pos += 1
    incr!(source)
    (eof(source, pos, len)) | (u < 0xe0000000) && @goto ret
    b = peekbyte(source, pos)
    b & 0xc0 == 0x80 || @goto ret
    u |= UInt32(b) << 8
    # third continuation byte
    pos += 1
    incr!(source)
    (eof(source, pos, len)) | (u < 0xf0000000) && @goto ret
    b = peekbyte(source, pos)
    b & 0xc0 == 0x80 || @goto ret
    u |= UInt32(b); pos += 1; incr!(source)
@label ret
    return reinterpret(Char, u), pos
end

for (tok, fn) in zip("uUeE", Any[Dates.monthabbr_to_value, Dates.monthname_to_value, Dates.dayabbr_to_value, Dates.dayname_to_value])
    @eval function tryparsenext(d::Dates.DatePart{$tok}, source, pos, len, b, code, locale)
        startpos = pos
        while true
            c, pos = nextchar(source, pos, len, b)
            if !isletter(c) || eof(source, pos, len)
                pos -= 1
                break
            end
            b = peekbyte(source, pos)
        end
        val = 0
        if startpos == pos
            code |= INVALID_TOKEN
        else
            if source isa AbstractVector{UInt8}
                word = unsafe_string(pointer(source, startpos), pos - startpos)
            else # source isa IO
                fastseek!(source, startpos - 1)
                word = String(read(source, pos - startpos))
            end
            val = $fn(word, locale)
            if val == 0
                code |= INVALID_TOKEN
            end
        end
        return Int64(val), pos, b, code
    end
end

function tryparsenext(d::Dates.DatePart{'s'}, source, pos, len, b, code, options)
    ms0, newpos, b, code = tryparsenext_base10(source, pos, len, b, code, maxdigits(d))
    invalid(code) && return ms0, newpos, b, code
    rounding = options.rounding
    len = newpos - pos
    if len > 3
        if rounding === nothing
            ms, r = divrem(ms0, Int64(10) ^ (len - 3))
            if r != 0
                code |= INEXACT
            end
        elseif rounding === RoundNearest
            ms = div(ms0, Int64(10) ^ (len - 3), RoundNearest)
        elseif rounding === RoundToZero
            ms = div(ms0, Int64(10) ^ (len - 3), RoundToZero)
        else
            ms = div(ms0, Int64(10) ^ (len - 3), rounding::RoundingMode)
        end
    else
        ms = ms0 * Int64(10) ^ (3 - len)
    end
    return ms, newpos, b, code
end

function tryparsenext(d::Delim{<:AbstractChar}, source, pos, len, b, code)
    u = bswap(reinterpret(UInt32, d.d))
    while true
        if b != (u & 0x000000ff)
            code |= INVALID_TOKEN
            break
        end
        u >>= 8
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            code |= EOF | (u == UInt32(0) ? SUCCESS : INVALID_TOKEN)
            break
        end
        b = peekbyte(source, pos)
        u == UInt32(0) && break
    end
    return pos, b, code
end

function tryparsenext(d::Delim{String}, source, pos, len, b, code)
    bytes = codeunits(d.d)
    tlen = length(bytes)
    for dpos = 1:tlen
        @inbounds c = bytes[dpos]
        if b != c
            code |= INVALID_TOKEN
            break
        end
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            code |= EOF | (dpos == tlen ? SUCCESS : INVALID_TOKEN)
            break
        end
        b = peekbyte(source, pos)
    end
    return pos, b, code
end

# fallback that would call custom DatePart overloads that are expecting a string
function tryparsenext(tok, source, pos, len, b, code)::Tuple{Any, Int, UInt8, ReturnCode}
    strlen = min(len - pos + 1, 64)
    str = getstring(source, PosLen(pos, strlen), 0x00)
    res = Dates.tryparsenext(tok, str, 1, strlen)
    if res === nothing
        val = nothing
        code |= INVALID_TOKEN
    else
        val, i = res
        pos += i - 1
        if eof(source, pos, len)
            code |= EOF
        else
            b = peekbyte(source, pos)
        end
    end
    return val, pos, b, code
end

@inline function typeparser(::AbstractConf{T}, source::Union{AbstractVector{UInt8}, IO}, pos, len, b, code, pl, options) where {T <: Dates.TimeType}
    fmt = options.dateformat
    df = fmt === nothing ? default_format(T) : fmt
    tokens = df.tokens
    locale::Dates.DateLocale = df.locale
    year = month = day = Int64(1)
    hour = minute = second = millisecond = Int64(0)
    tz = ""
    ampm = Dates.TWENTYFOURHOUR
    extras = nothing
    for tok in tokens
        # @show pos, Char(b), code, typeof(tok)
        eof(code) && break
        if tok isa Delim{Char}
            pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif tok isa Delim{String}
            pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Time && tok isa Dates.DatePart{'y'}
            year, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Time && tok isa Dates.DatePart{'Y'}
            year, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Time && tok isa Dates.DatePart{'m'}
            month, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Time && tok isa Dates.DatePart{'u'}
            month, pos, b, code = tryparsenext(tok, source, pos, len, b, code, locale)
        elseif T !== Time && tok isa Dates.DatePart{'U'}
            month, pos, b, code = tryparsenext(tok, source, pos, len, b, code, locale)
        elseif T !== Time && tok isa Dates.DatePart{'d'}
            day, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Time && tok isa Dates.DatePart{'e'}
            _, pos, b, code = tryparsenext(tok, source, pos, len, b, code, locale)
        elseif T !== Time && tok isa Dates.DatePart{'E'}
            _, pos, b, code = tryparsenext(tok, source, pos, len, b, code, locale)
        elseif T !== Date && tok isa Dates.DatePart{'H'}
            hour, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Date && tok isa Dates.DatePart{'I'}
            hour, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Date && tok isa Dates.DatePart{'M'}
            minute, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Date && tok isa Dates.DatePart{'S'}
            second, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Date && tok isa Dates.DatePart{'p'}
            ampm, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif T !== Date && tok isa Dates.DatePart{'s'}
            millisecond, pos, b, code = tryparsenext(tok, source, pos, len, b, code, options)
        elseif tok isa Dates.DatePart{'z'}
            tz, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        elseif tok isa Dates.DatePart{'Z'}
            tz, pos, b, code = tryparsenext(tok, source, pos, len, b, code)
        else
            # non-Dates defined character code
            # allocate extras if not already and parse
            if extras === nothing
                extras = IdDict{Type, Any}()
            end
            extraval, pos, b, code = tryparsenext(tok, source, pos, len, b, code)::Tuple{Any, Int, UInt8, ReturnCode}
            extras[Dates.CONVERSION_SPECIFIERS[charactercode(tok)]] = extraval
        end
        if invalid(code)
            if invalidtoken(code)
                code &= ~INVALID_TOKEN
            end
            break
        end
        # @show pos, Char(b), code
    end

    if T === Time
        @static if VERSION >= v"1.3-DEV"
            valid = Dates.validargs(T, hour, minute, second, millisecond, Int64(0), Int64(0), ampm)
        else
            valid = Dates.validargs(T, hour, minute, second, millisecond, Int64(0), Int64(0))
        end
    elseif T === Date
        valid = Dates.validargs(T, year, month, day)
    elseif T === DateTime
        @static if VERSION >= v"1.3-DEV"
            valid = Dates.validargs(T, year, month, day, hour, minute, second, millisecond, ampm)
        else
            valid = Dates.validargs(T, year, month, day, hour, minute, second, millisecond)
        end
    elseif T.name.name === :ZonedDateTime
        valid = Dates.validargs(T, year, month, day, hour, minute, second, millisecond, tz)
    else
        # custom TimeType
        if extras === nothing
            extras = IdDict{Type, Any}()
        end
        extras[Year] = year; extras[Month] = month; extras[Day] = day;
        extras[Hour] = hour; extras[Minute] = minute; extras[Second] = second; extras[Millisecond] = millisecond;
        types = Dates.CONVERSION_TRANSLATIONS[T]
        vals = Vector{Any}(undef, length(types))
        for (i, type) in enumerate(types)
            vals[i] = get(extras, type) do
                Dates.CONVERSION_DEFAULTS[type]
            end
        end
        valid = Dates.validargs(T, vals...)
    end
    if invalid(code) || valid !== nothing
        if T.name.name === :ZonedDateTime
            x = T(0, TimeZone("UTC"))
        else
            x = T(0)
        end
        code |= INVALID
    else
        if T === Time
            @static if VERSION >= v"1.3-DEV"
                x = Time(Nanosecond(1000000 * millisecond + 1000000000 * second + 60000000000 * minute + 3600000000000 * (Dates.adjusthour(hour, ampm))))
            else
                x = Time(Nanosecond(1000000 * millisecond + 1000000000 * second + 60000000000 * minute + 3600000000000 * hour))
            end
        elseif T === Date
            x = Date(Dates.UTD(Dates.totaldays(year, month, day)))
        elseif T === DateTime
            @static if VERSION >= v"1.3-DEV"
                x = DateTime(Dates.UTM(millisecond + 1000 * (second + 60 * minute + 3600 * (Dates.adjusthour(hour, ampm)) + 86400 * Dates.totaldays(year, month, day))))
            else
                x = DateTime(Dates.UTM(millisecond + 1000 * (second + 60 * minute + 3600 * hour + 86400 * Dates.totaldays(year, month, day))))
            end
        elseif T.name.name === :ZonedDateTime
            x = T(year, month, day, hour, minute, second, millisecond, tz)
        else
            # custom TimeType
            x = T(vals...)
        end
        code |= OK
    end
    if eof(source, pos, len)
        code |= EOF
    end
    return pos, code, PosLen(pl.pos, pos - pl.pos), x
end

const DEFAULT_TRUE = "true"
const DEFAULT_FALSE = "false"

@inline function typeparser(::AbstractConf{Bool}, source, pos, len, b, code, pl, options::Options)
    x = false
    trues = options.trues
    falses = options.falses
    if trues === nothing
        check, pos = checktoken(source, pos, len, b, DEFAULT_TRUE)
        if check
            x = true
            code |= OK
            eof(source, pos, len) && (code |= EOF)
            @goto done
        else
            intpos, intcode, intpl, intx = typeparser(DefaultConf{UInt8}(), source, pos, len, b, code, pl, options)
            if ok(intcode) && intx < 0x02
                x = intx == 0x01
                code = intcode
                pos = intpos
                pl = intpl
                @goto done
            end
        end
    else
        check, pos = checktokens(source, pos, len, b, trues, true)
        if check
            x = true
            code |= OK
            eof(source, pos, len) && (code |= EOF)
            @goto done
        end
    end
    if falses === nothing
        check, pos = checktoken(source, pos, len, b, DEFAULT_FALSE)
        if check
            x = false
            code |= OK
            eof(source, pos, len) && (code |= EOF)
            @goto done
        end
    else
        check, pos = checktokens(source, pos, len, b, falses, true)
        if check
            x = false
            code |= OK
            eof(source, pos, len) && (code |= EOF)
            @goto done
        end
    end
    code |= INVALID | (eof(source, pos, len) ? EOF : SUCCESS)

@label done
    return pos, code, PosLen(pl.pos, pos - pl.pos), x
end

module Parsers

export PosLen

using Dates
using UUIDs

include("utils.jl")

struct Format
    tokens::Vector{Dates.AbstractDateToken}
    locale::Dates.DateLocale
end

const SupportedFloats = Union{Float16, Float32, Float64, BigFloat}
const SupportedTypes = Union{Integer, SupportedFloats, Dates.TimeType, Bool, AbstractString, Symbol, Char}

supportedtype(::Type{T}) where {T} = T <: SupportedTypes

"""
    Parsers.Result{T}(code::Parsers.ReturnCode, tlen[, val])

Struct for holding the results of a parsing operations, returned from `Parsers.xparse`.
Contains 3 fields:
  * `code`: parsing bitmask with various flags set based on parsing (see [ReturnCode](@ref))
  * `tlen`: the total number of bytes consumed while parsing
  * `val`: the parsed value; note that `val` is optional when constructing; users *MUST* check `!Parsers.invalid(result.code)` before accessing `result.val`; if parsing fails, `result.val` is undefined
"""
struct Result{T}
    code::ReturnCode
    tlen::Int64
    val::T
    Result{T}(code::ReturnCode, tlen::Integer) where {T} = new{T}(code, tlen)
    Result{T}(code::ReturnCode, tlen::Integer, val) where {T} = new{T}(code, tlen, val)
end

Base.show(io::IO, x::Result{T}) where {T} = print(io, "Parsers.Result{$T}(code=`", codes(x.code), "`, tlen=", x.tlen, ", val=", isdefined(x, :val) ? x.val : "#undefined", ")")

# bit flags to hold several Bool options for Options
primitive type Flags 16 end

const SPACEDELIM      = 0b0000000000000001
const TABDELIM        = 0b0000000000000010
const STRIPQUOTED     = 0b0000000000000100
const STRIPWHITESPACE = 0b0000000000001000
const CHECKQUOTED     = 0b0000000000010000
const CHECKSENTINEL   = 0b0000000000100000
const CHECKDELIM      = 0b0000000001000000
const IGNOREREPEATED  = 0b0000000010000000
const IGNOREEMPTY     = 0b0000000100000000

function Flags(spacedelim, tabdelim, stripquoted, stripwhitespace, checkquoted, checksentinel, checkdelim, ignorerepeated, ignoreemptylines)
    x = 0x0000
    spacedelim && (x |= SPACEDELIM)
    tabdelim && (x |= TABDELIM)
    stripquoted && (x |= STRIPQUOTED)
    # stripquoted implies stripwhitespace
    (stripwhitespace || stripquoted) && (x |= STRIPWHITESPACE)
    checkquoted && (x |= CHECKQUOTED)
    checksentinel && (x |= CHECKSENTINEL)
    checkdelim && (x |= CHECKDELIM)
    ignorerepeated && (x |= IGNOREREPEATED)
    ignoreemptylines && (x |= IGNOREEMPTY)
    return Base.bitcast(Flags, x)
end

Base.show(io::IO, x::Flags) = print(io, "Parsers.Flags(spacedelim=", x.spacedelim, ", tabdelim=", x.tabdelim, ", stripquoted=", x.stripquoted, ", stripwhitespace=", x.stripwhitespace, ", checkquoted=", x.checkquoted, ", checksentinel=", x.checksentinel, ", checkdelim=", x.checkdelim, ", ignorerepeated=", x.ignorerepeated, ", ignoreemptylines=", x.ignoreemptylines, ")")

Base.write(io::IO, flag::Flags) = write(io, reinterpret(UInt16, flag))
Base.read(io::IO, ::Type{Flags}) = Base.bitcast(Flags, read(io, UInt16))

function Base.getproperty(x::Flags, nm::Symbol)
    if nm == :spacedelim
        return Base.bitcast(UInt16, x) & SPACEDELIM != 0x00
    elseif nm == :tabdelim
        return Base.bitcast(UInt16, x) & TABDELIM != 0x00
    elseif nm == :stripquoted
        return Base.bitcast(UInt16, x) & STRIPQUOTED != 0x00
    elseif nm == :stripwhitespace
        return Base.bitcast(UInt16, x) & STRIPWHITESPACE != 0x00
    elseif nm == :checkquoted
        return Base.bitcast(UInt16, x) & CHECKQUOTED != 0x00
    elseif nm == :checksentinel
        return Base.bitcast(UInt16, x) & CHECKSENTINEL != 0x00
    elseif nm == :checkdelim
        return Base.bitcast(UInt16, x) & CHECKDELIM != 0x00
    elseif nm == :ignorerepeated
        return Base.bitcast(UInt16, x) & IGNOREREPEATED != 0x00
    elseif nm == :ignoreemptylines
        return Base.bitcast(UInt16, x) & IGNOREEMPTY != 0x00
    else
        throw(ArgumentError("unknown Flags property: `$nm`"))
    end
end

"""
    `Parsers.Options` is a structure for holding various parsing settings when calling `Parsers.parse`, `Parsers.tryparse`, and `Parsers.xparse`. They include:

  * `sentinel=nothing`: valid values include: `nothing` meaning don't check for sentinel values; `missing` meaning an "empty field" should be considered a sentinel value; or a `Vector{String}` of the various string values that should each be checked as a sentinel value. Note that sentinels will always be checked longest to shortest, with the longest valid match taking precedence.
  * `openquotechar='"'`: the ascii character that signals a "quoted" field while parsing; subsequent characters will be treated as non-significant until a valid `closequotechar` is detected
  * `closequotechar='"'`: the ascii character that signals the end of a quoted field
  * `escapechar='"'`: an ascii character used to "escape" a `closequotechar` within a quoted field
  * `delim=','`: if `nothing`, no delimiter will be checked for; if a `Char` or `String`, a delimiter will be checked for directly after parsing a value or `closequotechar`; a newline (`\\n`), return (`\\r`), or CRLF (`"\\r\\n"`) are always considered "delimiters", in addition to EOF
  * `decimal='.'`: an ascii character to be used when parsing float values that separates a decimal value
  * `trues=nothing`: if `nothing`, `Bool` parsing will only check for the string `true` or an `Integer` value of `1` as valid values for `true`; as a `Vector{String}`, each string value will be checked to indicate a valid `true` value
  * `falses=nothing`: if `nothing`, `Bool` parsing will only check for the string `false` or an `Integer` value of `0` as valid values for `false`; as a `Vector{String}`, each string value will be checked to indicate a valid `false` value
  * `dateformat=nothing`: if `nothing`, `Date`, `DateTime`, and `Time` parsing will use a default `Dates.DateFormat` object while parsing; a `String` or `Dates.DateFormat` object can be provided for custom format parsing
  * `ignorerepeated=false`: if `true`, consecutive delimiter characters or strings will be consumed until a non-delimiter is encountered; if `false`, only a single delimiter character/string will be consumed. Useful for fixed-width delimited files where fields are padded with delimiters
  * `quoted=true`: whether parsing should check for `openquotechar` and `closequotechar` characters to signal quoted fields
  * `comment=nothing`: a string which, if matched at the start of a line, will make parsing consume the rest of the line
  * `ignoreemptylines=false`: after parsing a value, if a newline is detected, another immediately proceeding newline will be checked for and consumed
  * `stripwhitespace=nothing`: if true, leading and trailing whitespace is stripped from string fields, note that for *quoted* strings however, whitespace is preserved within quotes (but ignored before/after quote characters). To also strip *within* quotes, see `stripquoted`
  * `stripquoted=false`: if true, whitespace is also stripped within quoted strings. If true, `stripwhitespace` is also set to true.
  * `groupmark=nothing`: optionally specify a single-byte character denoting the number grouping mark, this allows parsing of numbers that have, e.g., thousand separators (`1,000.00`). When the `groupmark` is ambiguous with the `delim`, the user must quote the number if it contains group marks.
  * `rounding=RoundNearest`: optionally specify a rounding mode to use when parsing. No rounding means the result will be marked with `INEXACT` code if the value is not exactly representable in the target type.
"""
struct Options
    flags::Flags
    decimal::UInt8
    oq::Token
    cq::Token
    e::UInt8
    sentinel::Vector{Token}
    delim::Token
    cmt::Token
    trues::Union{Nothing, Vector{String}}
    falses::Union{Nothing, Vector{String}}
    dateformat::Union{Nothing, Format}
    groupmark::Union{Nothing,UInt8}
    rounding::Union{Nothing,RoundingMode}
end

# backwards compat
function Base.getproperty(x::Options, nm::Symbol)
    if nm == :ignorerepeated
        return x.flags.ignorerepeated
    elseif nm == :ignoreemptylines
        return x.flags.ignoreemptylines
    else
        return getfield(x, nm)
    end
end

# Get the default options for single-value parsing (i.e. not delimited), used
# by Parsers.parse and Parsers.tryparse via Parser.xparse2
function _get_default_options(;
    flags::Flags=Flags(false, false, false, false, false, false, false, false, false),
    decimal::UInt8=UInt8('.'),
    oq::Token=Token(UInt8('"')),
    cq::Token=Token(UInt8('"')),
    e::UInt8=UInt8('"'),
    sentinel::Vector{Token}=Token[],
    delim::Token=Token(""),
    cmt::Token=Token(""),
    trues::Union{Nothing, Vector{String}}=nothing,
    falses::Union{Nothing, Vector{String}}=nothing,
    dateformat::Union{Nothing, Format}=nothing,
    groupmark::Union{Nothing,UInt8}=nothing,
    rounding::Union{Nothing,RoundingMode}=nothing,
)
    return Options(flags, decimal, oq, cq, e, sentinel, delim, cmt, trues, falses, dateformat, groupmark, rounding)
end

# Get the default options for delimited parsing, used by Parsers.xparse
function _get_default_xoptions(;
    flags::Flags=Flags(false, false, false, false, true, true, true, false, false),
    decimal::UInt8=UInt8('.'),
    oq::Token=Token(UInt8('"')),
    cq::Token=Token(UInt8('"')),
    e::UInt8=UInt8('"'),
    sentinel::Vector{Token}=Token[],
    delim::Token=Token(UInt8(',')),
    cmt::Token=Token(""),
    trues::Union{Nothing, Vector{String}}=nothing,
    falses::Union{Nothing, Vector{String}}=nothing,
    dateformat::Union{Nothing, Format}=nothing,
    groupmark::Union{Nothing,UInt8}=nothing,
    rounding::Union{Nothing,RoundingMode}=nothing,
)
    return Options(flags, decimal, oq, cq, e, sentinel, delim, cmt, trues, falses, dateformat, groupmark, rounding)
end

# What is used by default in Parsers.parse, Parsers.tryparse, Parsers.xparse2
const OPTIONS = _get_default_options()
# What is used by default in Parsers.xparse
const XOPTIONS = _get_default_xoptions()

prepare!(x::Vector) = sort!(x, by=x->sizeof(x), rev=true)
asciival(c::Char) = isascii(c)
asciival(b::UInt8) = b < 0x80

_match(a::T, b::T) where {T<:Union{String,UInt8,Char}} = a == b
_match(a::T, b::S) where {T<:Union{String,UInt8,Char,Regex}, S<:Union{String,UInt8,Char}} = _match(b, a)
_match(a::String, b::Regex) = (m = match(b, a); isnothing(m) ? false : m.match == a)
_match(a::Char, b::Regex) = _match(string(a), b)
_match(a::UInt8, b::Regex) = _match(Char(a), b)
_match(a::UInt8, b::String) = ncodeunits(b) == 1 && Char(a) == first(b)
_match(a::Char, b::String) = ncodeunits(a) == ncodeunits(b) && a == first(b)
_match(a::UInt8, b::Char) = ncodeunits(b) == 1 && a == UInt8(b)
_match(a::Nothing, b) = false
_match(a, b::Nothing) = false
_match(a::Nothing, b::Nothing) = false
# TODO: this is not correct e.g. r"aa{1,1}a" is the same as r"aaa"
# but we won't catch that.
_match(a::Regex, b::Regex) = a == b

_startswith(s::UInt8, prefix::Union{String,Char}) = ncodeunits(prefix) == 1 && Char(s) == first(prefix)
_startswith(s::Char, prefix::Union{String,Char}) = ncodeunits(s) >= ncodeunits(prefix) && s == first(prefix)
_startswith(s::String, prefix::Union{Char,String,Regex}) = startswith(s, prefix)
_startswith(s::String, prefix::UInt8) = startswith(s, Char(prefix))
_startswith(s::Char, prefix::Regex) = startswith(string(s), prefix)
_startswith(s::UInt8, prefix::Regex) = startswith(string(Char(s)), prefix)
_startswith(s::UInt8, prefix::UInt8) = s == prefix
_startswith(s::Char, prefix::UInt8) = codepoint(s) == UInt32(prefix)
_startswith(a::Nothing, b) = false
_startswith(a, b::Nothing) = false
_startswith(a::Nothing, b::Nothing) = false

_nbytes(::UInt8) = 1
_nbytes(x::Char) = ncodeunits(x)

const MaybeToken = Union{Nothing, UInt8, Char, String, Regex}

function Options(
            sentinel::Union{Nothing, Missing, Vector},
            wh1::Union{UInt8, Char},
            wh2::Union{UInt8, Char},
            openquotechar::MaybeToken,
            closequotechar::MaybeToken,
            escapechar::MaybeToken,
            delim::MaybeToken,
            decimal::Union{UInt8, Char},
            trues::Union{Nothing, Vector{String}},
            falses::Union{Nothing, Vector{String}},
            dateformat::Union{Nothing, String, Dates.DateFormat, Format},
            ignorerepeated::Bool,
            ignoreemptylines::Bool,
            comment::MaybeToken,
            quoted::Bool,
            debug::Bool=false,
            stripwhitespace::Bool=false,
            stripquoted::Bool=false,
            groupmark::Union{Nothing,Char,UInt8}=nothing,
            rounding::Union{Nothing,RoundingMode}=nothing,
)
    # backwards compat; users previously had to pass wh1/wh2 as non-wh to avoid stripping
    if wh1 != UInt8(' ') || wh2 != UInt8('\t')
        stripwhitespace = false
    end
    if sentinel isa Vector{String}
        for sent in sentinel
            if stripwhitespace && (_contains(sent, " ") || _contains(sent, "\t"))
                throw(ArgumentError("`sentinel` value isn't allowed to contain ' ' or '\t' characters if `stripwhitespace=true`"))
            end
            if quoted && (_contains(sent, openquotechar) || _contains(sent, closequotechar) || _contains(sent, escapechar))
                throw(ArgumentError("`sentinel` value isn't allowed to contain `openquotechar`, `closequotechar`, or `escapechar` characters"))
            end
            if _contains(sent, delim)
                throw(ArgumentError("`sentinel` value isn't allowed to contain a delimiter character"))
            end
        end
    end

    oq = token(openquotechar, "openquotechar")
    cq = token(closequotechar, "closequotechar")
    e = token(escapechar, "escapechar")
    e.token isa UInt8 || throw(ArgumentError("`escapechar` must be a single ascii character"))
    e = e.token
    quoted && (isempty(oq) || isempty(cq) || isempty(e)) && throw(ArgumentError("quoted=true requires `openquotechar`, `closequotechar`, and `escapechar` to be specified"))
    sent = (sentinel === nothing || sentinel === missing) ? Token[] : map(x -> token(x, "sentinel"), prepare!(sentinel))
    checksentinel = sentinel !== nothing
    quoted && ((_match(openquotechar, delim) || _match(closequotechar, delim)) || _match(escapechar, delim)) &&
        throw(ArgumentError("`delim` argument must be different than `openquotechar`, `closequotechar`, and `escapechar` arguments"))
    del = delim
    delim = token(delim, "delim")
    checkdelim = delim !== nothing && !isempty(delim)
    spacedelim = checkdelim && _contains(delim, " ")
    tabdelim = checkdelim && _contains(delim, "\t")
    if trues !== nothing
        trues = prepare!(trues)
    end
    if falses !== nothing
        falses = prepare!(falses)
    end
    if groupmark !== nothing && (
        _match(groupmark, decimal) ||
        isnumeric(Char(groupmark)) ||
        (_match(del, groupmark) && !quoted) ||
        _match(openquotechar, groupmark) ||
        _match(closequotechar, groupmark) ||
        _nbytes(groupmark) != 1
    )
        throw(ArgumentError("`groupmark` cannot be a number, a quoting char, coincide with `decimal` and `delim` unless `quoted=true`."))
    end
    _nbytes(decimal) == 1 || throw(ArgumentError("`decimal` must be a single ascii character"))
    !isnumeric(Char(decimal)) || throw(ArgumentError("`decimal` cannot be a number"))

    df = dateformat === nothing ? nothing : dateformat isa String ? Format(dateformat) : dateformat isa Dates.DateFormat ? Format(dateformat) : dateformat
    flags = Flags(spacedelim, tabdelim, stripquoted, stripwhitespace, quoted, checksentinel, checkdelim, ignorerepeated, ignoreemptylines)
    return Options(flags, decimal, oq, cq, e, sent, delim, token(comment, "comment"), trues, falses, df, groupmark === nothing ? nothing : groupmark % UInt8, rounding)
end

function token(x::MaybeToken, arg)
    x === nothing && return Token("")
    if x isa UInt8
        asciival(x) || throw(ArgumentError("$arg argument must be ASCII"))
        return Token(x)
    elseif x isa Char
        return Token(asciival(x) ? UInt8(x) : string(x))
    elseif x isa Regex
        return Token(mkregex(x))
    else
        return Token(x)
    end
end

Options(;
    sentinel::Union{Nothing, Missing, Vector}=nothing,
    wh1::Union{UInt8, Char}=UInt8(' '),
    wh2::Union{UInt8, Char}=UInt8('\t'),
    openquotechar::MaybeToken=UInt8('"'),
    closequotechar::MaybeToken=UInt8('"'),
    escapechar::MaybeToken=UInt8('"'),
    delim::MaybeToken=UInt8(','),
    decimal::Union{UInt8, Char}=UInt8('.'),
    trues::Union{Nothing, Vector{String}}=nothing,
    falses::Union{Nothing, Vector{String}}=nothing,
    dateformat::Union{Nothing, String, Dates.DateFormat, Format}=nothing,
    ignorerepeated::Bool=false,
    ignoreemptylines::Bool=false,
    comment::MaybeToken=nothing,
    quoted::Bool=true,
    debug::Bool=false,
    stripwhitespace::Bool=false,
    stripquoted::Bool=false,
    groupmark::Union{Nothing,Char,UInt8}=nothing,
    rounding::Union{Nothing,RoundingMode}=nothing,
) = Options(sentinel, wh1, wh2, openquotechar, closequotechar, escapechar, delim, decimal, trues, falses, dateformat, ignorerepeated, ignoreemptylines, comment, quoted, debug, stripwhitespace, stripquoted, groupmark, rounding)

# "beta" for now, but allows custom types to define their own "Options"-like struct
# that can handle additional type-specific options
abstract type AbstractConf{T} end

struct DefaultConf{T} <: AbstractConf{T} end

conf(::Type{T}, opts::Options; kw...) where {T} = DefaultConf{T}()

result(::Type{T}, res::Result) where {T} = res

include("components.jl")

# high-level convenience functions like in Base
"""
    Parsers.parse(T, source[, options, pos, len]) => T

Parse a value of type `T` from `source`, which may be a byte buffer (`AbstractVector{UInt8}`), string, or `IO`. Optional arguments include `options`, a [`Parsers.Options`](@ref)
struct, `pos` which indicates the byte position where parsing should begin in a byte buffer `source`, and `len` which is the byte position where parsing should stop in a byte
buffer `source`. If parsing fails for any reason, either invalid value or non-value characters encountered before/after a value, an error will be thrown. To return `nothing`
instead of throwing an error, use [`Parsers.tryparse`](@ref).
"""
function parse(::Type{T}, buf::Union{AbstractVector{UInt8}, AbstractString, IO}, options=OPTIONS, pos::Integer=1, len::Integer=buf isa IO ? 0 : sizeof(buf)) where {T}
    res = xparse2(T, buf isa AbstractString ? codeunits(buf) : buf, pos, len, options)
    code = res.code
    tlen = res.tlen
    fin = buf isa IO || (tlen == (len - pos + 1))
    return ok(code) && fin ? (res.val::T) : throw(Error(buf, T, code, pos, tlen))
end

"""
    Parsers.tryparse(T, source[, options, pos, len]) => Union{T, Nothing}

Parse a value of type `T` from `source`, which may be a byte buffer (`AbstractVector{UInt8}`), string, or `IO`. Optional arguments include `options`, a [`Parsers.Options`](@ref)
struct, `pos` which indicates the byte position where parsing should begin in a byte buffer `source`, and `len` which is the byte position where parsing should stop in a byte
buffer `source`. If parsing fails for any reason, either invalid value or non-value characters encountered before/after a value, `nothing` will be returned. To instead throw
an error, use [`Parsers.parse`](@ref).
"""
function tryparse(::Type{T}, buf::Union{AbstractVector{UInt8}, AbstractString, IO}, options=OPTIONS, pos::Integer=1, len::Integer=buf isa IO ? 0 : sizeof(buf)) where {T}
    res = xparse2(T, buf isa AbstractString ? codeunits(buf) : buf, pos, len, options)
    fin = buf isa IO || (res.tlen == (len - pos + 1))
    return ok(res.code) && fin ? (res.val::T) : nothing
end

"""
    Parsers.xparse(T, buf, pos, len, options) => Parsers.Result{T}

The core parsing function for any type `T`. Takes a `buf`, which can be an `AbstractVector{UInt8}`, `AbstractString`,
or an `IO`. `pos` is the byte position to begin parsing at. `len` is the total # of bytes in `buf` (signaling eof).
`options` is an instance of `Parsers.Options`.

A [`Parsers.Result`](@ref) struct is returned, with the following fields:
* `res.val` is a value of type `T`, but only if parsing succeeded; for parsed `String`s, no string is returned to avoid excess allocating; if you'd like the actual parsed string value, you can call [`Parsers.getstring`](@ref)
* `res.code` is a bitmask of parsing codes, use `Parsers.codes(code)` or `Parsers.text(code)` to see the various bit values set. See [`Parsers.ReturnCode`](@ref) for additional details on the various parsing codes
* `res.tlen`: the total # of bytes consumed while parsing a value, including any quote or delimiter characters; this can be added to the starting `pos` to allow calling `Parsers.xparse` again for a subsequent field/value
"""
function xparse end

const SourceType = Union{AbstractVector{UInt8}, AbstractString, IO}

returntype(::Type{T}) where {T <: AbstractString} = PosLen
returntype(::Type{Number}) = Union{Int64, Int128, BigInt, Float32, Float64, BigFloat}
returntype(::Type{T}) where {T} = T

# for testing purposes only, it's much too slow to dynamically create Options for every xparse call
xparse(::Type{T}, source::SourceType, S=nothing; pos::Integer=1, len::Integer=source isa IO ? 0 : sizeof(source), kw...) where {T} =
    S === nothing ? xparse(T, source, pos, len, Options(; kw...)) : xparse(T, source, pos, len, Options(; kw...), S)

_xparse(conf::AbstractConf{T}, source::Union{AbstractVector{UInt8}, IO}, pos, len, options::Options=XOPTIONS, ::Type{S}=returntype(T)) where {T, S} =
    Result(emptysentinel(options)(delimiter(options)(whitespace(options)(
        quoted(options)(whitespace(options)(sentinel(options)(typeparser(options)
    )))))))(conf, source, pos, len, S)

xparse(::Type{T}, source::SourceType, pos, len, options=XOPTIONS, ::Type{S}=returntype(T)) where {T, S} =
    result(T, xparse(conf(T, options), source, pos, len, options, S))

function xparse(conf::AbstractConf{T}, source::SourceType, pos, len, options=XOPTIONS, ::Type{S}=returntype(T)) where {T, S}
    buf = source isa AbstractString ? codeunits(source) : source
    if T === Number || supportedtype(T)
        return _xparse(conf, buf, pos, len, options, S)
    else
        # generic fallback calls Base.tryparse
        res = _xparse(DefaultConf{String}(), source, pos, len, options)
        code = res.code
        pl = res.val
        if !Parsers.invalid(code) && !Parsers.sentinel(code)
            str = getstring(source, pl, options.e)
            x = Base.tryparse(T, str)
            if x === nothing
                return Result{S}(code | INVALID, res.tlen)
            else
                return Result{S}(code, res.tlen, x)
            end
        else
            return Result{S}(code, res.tlen)
        end
    end
end

# condensed version of xparse that doesn't worry about quoting or delimiters; called from Parsers.parse/Parsers.tryparse
_xparse2(conf::AbstractConf{T}, source::Union{AbstractVector{UInt8}, IO}, pos, len, opts::Options=OPTIONS, ::Type{S}=returntype(T)) where {T, S} =
    Result(whitespace(false, false, false, true)(typeparser(opts)))(conf, source, pos, len, S)

xparse2(::Type{T}, source::SourceType, pos, len, options=OPTIONS, ::Type{S}=returntype(T)) where {T, S} =
    result(T, xparse2(conf(T, options), source, pos, len, options, S))

function xparse2(conf::AbstractConf{T}, source::SourceType, pos, len, options=OPTIONS, ::Type{S}=returntype(T)) where {T, S}
    buf = source isa AbstractString ? codeunits(source) : source
    if T === Number || supportedtype(T)
        return _xparse2(conf, buf, pos, len, options, S)
    else
        # generic fallback calls Base.tryparse
        res = _xparse2(DefaultConf{String}(), source, pos, len, options)
        code = res.code
        pl = res.val
        if !Parsers.invalid(code) && !Parsers.sentinel(code)
            str = getstring(source, pl, options.e)
            x = Base.tryparse(T, str)
            if x === nothing
                return Result{S}(code | INVALID, res.tlen)
            else
                return Result{S}(code, res.tlen, x)
            end
        else
            return Result{S}(code, res.tlen)
        end
    end
end

function checkdelim!(source::AbstractVector{UInt8}, pos, len, options::Options)
    eof(source, pos, len) && return pos
    delim = options.delim
    b = peekbyte(source, pos)
    if !options.flags.ignorerepeated
        # we're checking for a single appearance of a delimiter
        match, pos = checktoken(source, pos, len, b, delim)
    else
        # keep parsing as long as we keep matching delim
        while true
            match, pos = checktoken(source, pos, len, b, delim)
            (match && !eof(source, pos, len)) || break
            b = peekbyte(source, pos)
        end
    end
    return pos
end

function _has_groupmark(opts::Options, code::ReturnCode)
    if opts.groupmark !== nothing
        isquoted = (code & QUOTED) != 0
        if isquoted || (opts.groupmark != opts.delim)
            return true
        end
    end
    return false
end


if isdefined(Base, :OncePerTask)
    const _get_bigint = OncePerTask{BigInt}(() -> BigInt(; nbits=256))
    # Note: This uses `() -> BigFloat()` instead of just `BigFloat` for --trim compatibility
    const _get_bigfloats = OncePerTask{BigFloat}(() -> BigFloat())
else
    # N.B This code is not thread safe in the presence of thread migration
    const BIGINT = BigInt[]
    const BIGFLOATS = BigFloat[]

    _get_bigfloats() = access_threaded(BigFloat, BIGFLOATS)
    _get_bigint() = access_threaded(() -> (@static VERSION > v"1.5" ? BigInt(; nbits=256) : BigInt()), BIGINT)

    function access_threaded(f, v::Vector)
        tid = Threads.threadid()
        0 < tid <= length(v) || _length_assert()
        if @inbounds isassigned(v, tid)
            @inbounds x = v[tid]
        else
            x = f()
            @inbounds v[tid] = x
        end
        return x
    end
    @noinline _length_assert() =  @assert false "0 < tid <= v"

    function __init__()
        nt = isdefined(Base.Threads, :maxthreadid) ? Threads.maxthreadid() : Threads.nthreads()
        resize!(empty!(BIGINT), nt)
        resize!(empty!(BIGFLOATS), nt)
        return
    end
end

include("ints.jl")
include("floats.jl")
include("strings.jl")
include("bools.jl")
include("dates.jl")
include("hexadecimal.jl")
include("precompile.jl")

end # module

using Base.MPFR, Base.GMP, Base.GMP.MPZ

_widen(x::UInt64) = UInt128(x)
_widen(x::Int64) = Int128(x)
_unwiden(x::UInt128) = x % UInt64
_unwiden(x::Int128) = x % Int64
_unwiden(x::BigInt) = x % Int128

function _widen(v::T) where {T <: Union{Int128, UInt128}}
    x = _get_bigint()
    ccall((:__gmpz_import, :libgmp), Int32,
        (Ref{BigInt}, Csize_t, Cint, Csize_t, Cint, Csize_t, Ref{T}),
        x, 1, 1, 16, 0, 0, v)
    return x
end

# Base.exponent_max(T) + Base.significand_bits(T) + 3 # "-0."
maxdigits(::Type{Float64}) = 1079
maxdigits(::Type{Float32}) = 154
maxdigits(::Type{Float16}) = 29
maxdigits(T) = typemax(Int64)

ten(::Type{T}) where {T} = T(10)
const TEN = BigInt(10)
ten(::Type{BigInt}) = TEN

_muladd(ten, digits, b) = ten * digits + b

function _muladd(ten, digits::BigInt, b)
    Base.GMP.MPZ.mul!(digits, ten)
    Base.GMP.MPZ.add_ui!(digits, b)
    return digits
end

@enum FloatType FLOAT16 FLOAT32 FLOAT64 BIGFLOAT

# for non SupportedFloat Reals, parse as Float64, then convert
function typeparser(conf::AbstractConf{T}, source, pos, len, b, code, pl, options) where {T <: Real}
    pos, code, pl, x = typeparser(DefaultConf{Float64}(), source, pos, len, b, code, pl, options)
    return pos, code, pl, T(x)
end

function _copy_nulterminated(source::AbstractVector{UInt8}, pos, len)
    vlen = max(0, len)
    buf = Vector{UInt8}(undef, vlen + 1)
    vlen > 0 && copyto!(buf, 1, source, pos, vlen)
    @inbounds buf[vlen + 1] = 0x00
    return buf
end

@inline _contiguous(source) = false
@inline _contiguous(source::StridedVector{UInt8}) = stride(source, 1) == 1
@inline _writable_contiguous(source) = false
@inline _writable_contiguous(source::Vector{UInt8}) = true
@inline _writable_contiguous(source::SubArray{UInt8,1}) =
    parent(source) isa Vector{UInt8} && _contiguous(source)

@inline _nulterminated(source, len) = false
@inline _nulterminated(source::String, len) = len == sizeof(source)
@inline _nulterminated(source::Base.CodeUnits{UInt8,String}, len) = len == length(source)
@inline function _nulterminated(source::AbstractVector{UInt8}, len)
    return _contiguous(source) && len < length(source) && @inbounds(source[len + 1]) == 0x00
end

@inline function _ends_on_delimiter(source::AbstractVector{UInt8}, len, options)
    0 < len <= length(source) || return false
    @inbounds b = source[len]
    return b == UInt8('\n') || b == UInt8('\r') || (options.flags.checkdelim && options.delim == b)
end

function _bigfloat_buffer(source::AbstractVector{UInt8}, pos, len, b, code, options)
    _, _, pl, _ = typeparser(DefaultConf{String}(), source, pos, len, b, code, poslen(pos, 0), options)
    return _copy_nulterminated(source, pl.pos, pl.len)
end

_bigfloat_buffer(source::AbstractString, pos, len, b, code, options) =
    _bigfloat_buffer(codeunits(source), pos, len, b, code, options)

function _bigfloat_buffer(source::IO, pos, len, b, code, options)
    _, _, pl, _ = typeparser(DefaultConf{String}(), source, pos, len, b, code, poslen(pos, 0), options)
    vlen = max(0, pl.len)
    buf = Vector{UInt8}(undef, vlen + 1)
    fastseek!(source, pl.pos - 1)
    readbytes!(source, buf, vlen)
    @inbounds buf[vlen + 1] = 0x00
    fastseek!(source, pos - 1)
    return buf
end

@inline function _mpfr_strtofr(z, ptr, endptr, base, rounding)
    return ccall((:mpfr_strtofr, :libmpfr), Int32, (Ref{BigFloat}, Cstring, Ref{Ptr{UInt8}}, Int32, Base.MPFR.MPFRRoundingMode), z, ptr, endptr, base, rounding)
end

@inline function _finish_bigfloat(source, pos, code, pl, z, ptr, base, rounding)
    endptr = Ref{Ptr{UInt8}}()
    err = _mpfr_strtofr(z, ptr, endptr, base, rounding)
    code |= endptr[] == ptr ? INVALID : OK
    pos += Int(endptr[] - ptr)
    source isa IO && fastseek!(source, pos - 1)
    return pos, code, PosLen(pl.pos, max(0, pos - pl.pos)), z
end

function typeparser(::AbstractConf{BigFloat}, source, pos, len, b, code, pl, options)
    base = 0
    rounding = Base.MPFR.ROUNDING_MODE[]
    z = BigFloat(precision=Base.MPFR.DEFAULT_PRECISION[])
    if _nulterminated(source, len)
        GC.@preserve source begin
            return _finish_bigfloat(source, pos, code, pl, z, pointer(source, pos), base, rounding)
        end
    elseif _writable_contiguous(source)
        nulpos = if _ends_on_delimiter(source, len, options)
            len
        else
            _, _, strpl, _ = typeparser(DefaultConf{String}(), source, pos, len, b, code, poslen(pos, 0), options)
            strpl.pos + strpl.len
        end
        if nulpos <= length(source)
            @inbounds byte = source[nulpos]
            @inbounds source[nulpos] = 0x00
            try
                GC.@preserve source begin
                    return _finish_bigfloat(source, pos, code, pl, z, pointer(source, pos), base, rounding)
                end
            finally
                @inbounds source[nulpos] = byte
            end
        else
            _, _, strpl, _ = typeparser(DefaultConf{String}(), source, pos, len, b, code, poslen(pos, 0), options)
            buf = _copy_nulterminated(source, strpl.pos, strpl.len)
            GC.@preserve buf begin
                return _finish_bigfloat(source, pos, code, pl, z, pointer(buf), base, rounding)
            end
        end
    else
        buf = _bigfloat_buffer(source, pos, len, b, code, options)
        GC.@preserve buf begin
            return _finish_bigfloat(source, pos, code, pl, z, pointer(buf), base, rounding)
        end
    end
end

@inline function typeparser(conf::AbstractConf{T}, source, pos, len, b, code, pl, options) where {T <: SupportedFloats}
    # keep track of starting pos in case of invalid, we can rewind to start of parsing
    startpos = pos
    x = zero(T)
    neg = b == UInt8('-')
    if neg || b == UInt8('+')
        pos += 1
        incr!(source)
    end
    if eof(source, pos, len)
        # invalid because input is empty or contained only '-' or '+'
        code |= INVALID | EOF
        @goto done
    end
    b = peekbyte(source, pos)
    if b != options.decimal && (b - UInt8('0')) > 0x09
        # character isn't a digit or decimal point, check for special values, otherwise INVALID
        if b == UInt8('n') || b == UInt8('N')
            pos += 1
            incr!(source)
            if eof(source, pos, len)
                code |= EOF
                @goto invalid
            end
            b = peekbyte(source, pos)
            if b == UInt8('a') || b == UInt8('A')
                pos += 1
                incr!(source)
                if eof(source, pos, len)
                    code |= EOF
                    @goto invalid
                end
                b = peekbyte(source, pos)
                if b == UInt8('n') || b == UInt8('N')
                    x = T(NaN)
                    pos += 1
                    incr!(source)
                    if eof(source, pos, len)
                        code |= EOF
                    end
                    code |= OK | SPECIAL_VALUE
                    @goto done
                end
            end
        elseif b == UInt8('i') || b == UInt8('I')
            pos += 1
            incr!(source)
            if eof(source, pos, len)
                code |= EOF
                @goto invalid
            end
            b = peekbyte(source, pos)
            if b == UInt8('n') || b == UInt8('N')
                pos += 1
                incr!(source)
                if eof(source, pos, len)
                    code |= EOF
                    @goto invalid
                end
                b = peekbyte(source, pos)
                if b == UInt8('f') || b == UInt8('F')
                    x = ifelse(neg, T(-Inf), T(Inf))
                    code |= OK | SPECIAL_VALUE
                    pos += 1
                    incr!(source)
                    if eof(source, pos, len)
                        code |= EOF
                        @goto done
                    end
                    b = peekbyte(source, pos)
                    if b == UInt8('i') || b == UInt8('I')
                        pos += 1
                        incr!(source)
                        if eof(source, pos, len)
                            code |= EOF
                            @goto done
                        end
                        b = peekbyte(source, pos)
                        if b == UInt8('n') || b == UInt8('N')
                            pos += 1
                            incr!(source)
                            if eof(source, pos, len)
                                code |= EOF
                                @goto done
                            end
                            b = peekbyte(source, pos)
                            if b == UInt8('i') || b == UInt8('I')
                                pos += 1
                                incr!(source)
                                if eof(source, pos, len)
                                    code |= EOF
                                    @goto done
                                end
                                b = peekbyte(source, pos)
                                if b == UInt8('t') || b == UInt8('T')
                                    pos += 1
                                    incr!(source)
                                    if eof(source, pos, len)
                                        code |= EOF
                                        @goto done
                                    end
                                    b = peekbyte(source, pos)
                                    if b == UInt8('y') || b == UInt8('Y')
                                        pos += 1
                                        incr!(source)
                                        if eof(source, pos, len)
                                            code |= EOF
                                        end
                                        @goto done
                                    end
                                end
                            end
                        end
                    end
                    @goto done
                end
            end
        else
        end
@label invalid
        fastseek!(source, startpos - 1)
        pos = startpos
        code |= INVALID
        @goto done
    end

    # start parsing digits or decimal point; we start digits as UInt64(0) and can _widen type if needed
    x, code, pos = parsedigits(conf, source, pos, len, b, code, options, UInt64(0), neg, startpos)
    if !isfinite(x)
        code |= SPECIAL_VALUE
    end

@label done
    return pos, code, PosLen(pl.pos, pos - pl.pos), x
end

function handlef(x::T, f::F) where {T, F}
    if f === nothing
        return x
    else
        f(x)
        return nothing
    end
end

rettype(::Type{T}) where {T} = T === Number ? Nothing : T

# when a function is passed to apply to the parsed value, we have to be really careful that the `x`
# returned from parsedigits is `Nothing`, otherwise we end up with an overall return type like
# `Tuple{Union{Nothing, T}, ReturnCode, Int}`, which can cause dynamic dispatches/inlining issues
# for callers. The rule to follow is that before any call to `@goto done`, we need to ensure `x`
# has been "handled" properly: either applied or in error cases, set to `nothing`
getx(x, f) = f === nothing ? x : nothing

# if we need to _widen the type due to `digits` overflow, we want a non-inlined version so base case compilation doesn't get out of control.
# NOTE: the widened recursive calls deliberately do NOT use `Base.inferencebarrier` — the
# widening ladder is bounded in type space (UInt64 → UInt128 → BigInt, where
# `overflows(BigInt) == false` ends the recursion), and a barrier makes the widened
# continuation reachable only through runtime dispatch: fine under the JIT, but in a
# statically compiled (`juliac --trim`) binary the widened instance doesn't exist, so
# parsing a wide-digit float would fail at runtime. The `@noinline` wrappers keep each
# ladder step compiling separately, which is what bounds base-case compilation.
@noinline _parsedigits(conf::AbstractConf{T}, source, pos, len, b, code, options, digits::IntType, neg::Bool, startpos, overflow_invalid::Bool, ndigits::Int, f::F) where {T, IntType, F} =
    parsedigits(conf, source, pos, len, b, code, options, digits, neg, startpos, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}

@inline function parsedigits(conf::AbstractConf{T}, source, pos, len, b, code, options, digits::IntType, neg::Bool, startpos, overflow_invalid::Bool=false, ndigits::Int=0, f::F=nothing) where {T, IntType, F}
    x = zero(T)
    anydigits = false
    has_groupmark = _has_groupmark(options, code)
    groupmark0 = something(options.groupmark, 0xff) - UInt8('0')

    # we already previously checked if `b` was decimal or a digit, so don't need to check explicitly again
    if b != options.decimal
        b -= UInt8('0')
        prev_b0 = b
        anydigits = b <= 0x09
        while true
            if b <= 0x09
                if overflows(IntType) && digits > overflowval(IntType)
                    return _parsedigits(conf, source, pos, len, b + UInt8('0'), code, options, _widen(digits), neg, startpos, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}
                elseif ndigits > maxdigits(T)
                    # if input is way too big, just bail
                    fastseek!(source, startpos - 1)
                    pos = startpos
                    code |= INVALID
                    x = getx(x, f)
                    @goto done
                end
                digits = _muladd(ten(IntType), digits, b)
                pos += 1
                incr!(source)
                ndigits += (!iszero(ndigits) || !iszero(b)) # only accumulate digits without leading zeros
                if eof(source, pos, len)
                    # input is integer, like "1"
                    if T === Number && IntType != Int64 && digits <= _unwiden(digits)
                        # if T is Number, let's do a quick check if we tripped the
                        # overflow and can actually unwiden
                        y = _unwiden(digits)
                        x = handlef(ifelse(neg, -y, y), f)
                    else
                        x, code = noscale(conf, digits, neg, code, ndigits, f, options)
                    end
                    code |= OK | EOF
                    @goto done
                end
            elseif has_groupmark && b == groupmark0
                prev_b0 == groupmark0 && (code |= INVALID; x = getx(x, f); @goto done) # two groupmarks in a row
                pos += 1
                Parsers.incr!(source)
                Parsers.eof(source, pos, len) && (code |= INVALID | EOF; x = getx(x, f); @goto done) # groupmark at end of input
            else
                # if `b` isn't a digit or a groupmark, time to break out of digit parsing while loop
                ((has_groupmark && prev_b0 == groupmark0) || !anydigits) && (code |= INVALID; x = getx(x, f); @goto done) # ended with groupmark
                break
            end
            prev_b0 = b
            b = peekbyte(source, pos) - UInt8('0')
        end
        # b wasn't a digit, so add back '0' to recover original Char value
        b += UInt8('0')
    end
    if b == options.decimal
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            # if input is "." then invalid, otherwise ok, like "1."
            if T === Number
                x = handlef(ifelse(neg, -Float64(digits), Float64(digits)), f)
            else
                x, code = noscale(conf, digits, neg, code, ndigits, f, options)
            end
            code |= ((startpos + 1) == pos ? INVALID : OK) | EOF
            @goto done
        end
        b = peekbyte(source, pos)
        if b - UInt8('0') > 0x09 && !(b == UInt8('e') || b == UInt8('E') || b == UInt8('f') || b == UInt8('F'))
            # if the next byte after decimal point isn't a digit or exponent char ('e', 'E', 'f', 'F')
            # and we haven't parsed any digits, like ".a", then invalid
            # otherwise ok, like "1.a" (only "1." is parsed)
            if !anydigits
                code |= INVALID
                x = getx(x, f)
                @goto done
            else
                if T === Number
                    x = handlef(ifelse(neg, -Float64(digits), Float64(digits)), f)
                else
                    x, code = noscale(conf, digits, neg, code, ndigits, f, options)
                end
                code |= OK
                @goto done
            end
        end
    end

    # we've parsed any digits preceding decimal point and consumed decimal point if any
    # now we parse any digits following decimal point (if any); start `frac` at UInt64(0)
    # `digits` still receives any fractional digits, `frac` just keeps track of how many digits
    # were parsed to combine with any "e123" exponent numbers to determine final exponent value
    if overflows(IntType) && digits > overflowval(IntType)
        x, code, pos = _parsefrac(conf, source, pos, len, b, code, options, _widen(digits), neg, startpos, UInt64(0), overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}
    else
        x, code, pos = parsefrac(conf, source, pos, len, b, code, options, digits, neg, startpos, UInt64(0), overflow_invalid, ndigits, f)
    end

@label done
    return x, code, pos
end

# same as above; if digits overflows, we want a non-inlined version to call with a wider type
# note that we never expect `frac` to overflow, since it's just keep track of the # of digits
# we parse post-decimal point
@noinline _parsefrac(conf::AbstractConf{T}, source, pos, len, b, code, options, digits::IntType, neg::Bool, startpos, frac, overflow_invalid, ndigits, f::F) where {T, IntType, F} =
    parsefrac(conf, source, pos, len, b, code, options, digits, neg, startpos, frac, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}

@inline function parsefrac(conf::AbstractConf{T}, source, pos, len, b, code, options, digits::IntType, neg::Bool, startpos, frac, overflow_invalid, ndigits, f::F) where {T, IntType, F}
    x = zero(T)
    parsedanyfrac = false
    FT = FLOAT64
    # check if `b` is a digit
    if b - UInt8('0') < 0x0a
        b -= UInt8('0')
        parsedanyfrac = true
        # if so, parse fractional digits
        while true
            digits = _muladd(ten(IntType), digits, b)
            ndigits += (!iszero(ndigits) || !iszero(b)) # only accumulate digits without leading zeros
            pos += 1
            incr!(source)
            frac += UInt64(1)
            if eof(source, pos, len)
                # input is simple non-scientific-notation floating number, like "1.1"
                if overflow_invalid && -signed(frac) > 308
                    code |= INVALID
                    x = getx(x, f)
                else
                    x, code = scale(conf, FT, digits, -signed(frac), neg, code, ndigits, f, options)
                    code |= OK | EOF
                end
                @goto done
            end
            b = peekbyte(source, pos) - UInt8('0')
            b > 0x09 && break
            if overflows(IntType) && digits > overflowval(IntType)
                return _parsefrac(conf, source, pos, len, b + UInt8('0'), code, options, _widen(digits), neg, startpos, frac, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}
            end
        end
        b += UInt8('0')
    end
    # check for exponent notation
    if b == UInt8('e') || b == UInt8('E') || b == UInt8('f') || b == UInt8('F')
        if b == UInt8('f') || b == UInt8('F')
            FT = FLOAT32
        end
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            # it's an error to have a "dangling" 'e', so input was something like "1.1e"
            code |= INVALID | EOF
            x = getx(x, f)
            @goto done
        end
        b = peekbyte(source, pos)
        # check for plus or minus sign for exponent number
        negexp = b == UInt8('-')
        if negexp || b == UInt8('+')
            pos += 1
            incr!(source)
            if eof(source, pos, len)
                # it's an error to have a "dangling" '-' or '+', so input was something like "1.1e-"
                code |= INVALID | EOF
                x = getx(x, f)
                @goto done
            end
            b = peekbyte(source, pos)
        end
        b -= UInt8('0')
        if b > 0x09
            # invalid to have a "dangling" 'e'
            code |= INVALID
            x = getx(x, f)
            @goto done
        end

        # at this point, we've parsed X and Y in "X.YeZ", but not Z in a scientific notation exponent number
        # we start our exponent number at UInt64(0)
        return parseexp(conf, source, pos, len, b, code, options, digits, neg, startpos, frac, UInt64(0), negexp, FT, overflow_invalid, ndigits, f)
    else
        # if no scientific notation, we're done, so scale digits + frac and return
        if parsedanyfrac
            if overflow_invalid && -signed(frac) > 308
                code |= INVALID
                x = getx(x, f)
                @goto done
            else
                x, code = scale(conf, FT, digits, -signed(frac), neg, code, ndigits, f, options)
            end
        else
            x, code = noscale(conf, digits, neg, code, ndigits, f, options)
        end
        code |= OK
    end

@label done
    return x, code, pos
end

# same no-inline story, but this time for exponent number; probably even more rare to overflow the exponent number
# compared to pre/post decimal digits, but we account for it all the same (a lot of float parsers don't account for this)
@noinline _parseexp(conf::AbstractConf{T}, source, pos, len, b, code, options, digits, neg::Bool, startpos, frac, exp::ExpType, negexp, FT, overflow_invalid, ndigits, f::F) where {T, ExpType, F} =
    parseexp(conf, source, pos, len, b, code, options, digits, neg, startpos, frac, exp, negexp, FT, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}

@inline function parseexp(conf::AbstractConf{T}, source, pos, len, b, code, options, digits, neg::Bool, startpos, frac, exp::ExpType, negexp, FT, overflow_invalid, ndigits, f::F) where {T, ExpType, F}
    x = zero(T)
    # note that `b` has already had `b - UInt8('0')` applied to it for parseexp
    while true
        exp = ExpType(10) * exp + b
        pos += 1
        incr!(source)
        if eof(source, pos, len)
            # we finished parsing input like "1.1e1"
            ee = ifelse(negexp, -signed(exp), signed(exp)) - signed(frac)
            if overflow_invalid && ee > 308
                code |= INVALID
                x = getx(x, f)
            else
                x, code = scale(conf, FT, digits, ee, neg, code, ndigits, f, options)
                code |= OK | EOF
            end
            @goto done
        end
        b = peekbyte(source, pos) - UInt8('0')
        # if we encounter a non-digit, that must mean we're done
        if b > 0x09
            ee = ifelse(negexp, -signed(exp), signed(exp)) - signed(frac)
            if overflow_invalid && ee > 308
                code |= INVALID
                x = getx(x, f)
            else
                x, code = scale(conf, FT, digits, ifelse(negexp, -signed(exp), signed(exp)) - signed(frac), neg, code, ndigits, f, options)
                code |= OK
            end
            @goto done
        end
        if overflows(ExpType) && exp > overflowval(ExpType)
            return _parseexp(conf, source, pos, len, b, code, options, digits, neg, startpos, frac, _widen(exp), negexp, FT, overflow_invalid, ndigits, f)::Tuple{rettype(T), ReturnCode, Int}
        end
    end
@label done
    return x, code, pos
end

# utilities for calculating final float value
maxsig(::Type{Float16}) = 2048
maxsig(::Type{Float32}) = 16777216
maxsig(::Type{Float64}) = 9007199254740992
maxsig(::Type{BigFloat}) = 9007199254740992

ceillog5(::Type{Float16}) = 5
ceillog5(::Type{Float32}) = 11
ceillog5(::Type{Float64}) = 23
ceillog5(::Type{BigFloat}) = 23

const F16_SHORT_POWERS = [exp10(Float16(x)) for x = 0:ceillog5(Float16)-1]
const F32_SHORT_POWERS = [exp10(Float32(x)) for x = 0:ceillog5(Float32)-1]
const F64_SHORT_POWERS = [exp10(Float64(x)) for x = 0:ceillog5(Float64)-1]

pow10(::Type{Float16}, e) = (@inbounds v = F16_SHORT_POWERS[e+1]; return v)
pow10(::Type{Float32}, e) = (@inbounds v = F32_SHORT_POWERS[e+1]; return v)
pow10(::Type{Float64}, e) = (@inbounds v = F64_SHORT_POWERS[e+1]; return v)
pow10(::Type{BigFloat}, e) = (@inbounds v = F64_SHORT_POWERS[e+1]; return v)

_unsigned(x::BigInt) = x
_unsigned(x) = unsigned(x)

# No fractional part or exponent, digits in `v` are already scaled
function noscale(::AbstractConf{T}, v::Integer, neg::Bool, code, ndigits, f::F, ::Options) where {T, F}
    return handlef(ifelse(neg, -T(v), T(v)), f), code
end

# Digits in `v` need to be scaled by `exp`
function scale(::AbstractConf{T}, FT::FloatType, v, exp, neg, code, ndigits, f::F, ::Options) where {T, F}
    if T === Float64
        return handlef(__scale(Float64, _unsigned(v), exp, neg), f), code
    elseif T === Float32
        return handlef(__scale(Float32, _unsigned(v), exp, neg), f), code
    elseif T === Float16
        return handlef(__scale(Float16, _unsigned(v), exp, neg), f), code
    elseif FT == FLOAT64
        f64 = __scale(Float64, _unsigned(v), exp, neg)
        if isfinite(f64)
            return handlef(f64, f), code
        else
            code |= INVALID
            return nothing, code
        end
    elseif FT == FLOAT32
        f32 = __scale(Float32, _unsigned(v), exp, neg)
        if isfinite(f32)
            return handlef(f32, f), code
        else
            code |= INVALID
            return nothing, code
        end
    elseif FT == FLOAT16
        f16 = __scale(Float16, _unsigned(v), exp, neg)
        if isfinite(f16)
            return handlef(f16, f), code
        else
            code |= INVALID
            return nothing, code
        end
    else
        error("invalid float type for scale: `$T`")
    end
end

function __scale(::Type{T}, v, exp, neg) where {T}
    ms = maxsig(T)
    cl = ceillog5(T)
    if v < ms
        # fastest path
        if 0 <= exp < cl
            x = T(v) * pow10(T, exp)
            return ifelse(neg, -x, x)
        elseif -cl < exp < 0
            x = T(v) / pow10(T, -exp)
            return ifelse(neg, -x, x)
        end
    end
    v == 0 && return zero(T)
    if exp > 308 && T != BigFloat
        return T(neg ? -Inf : Inf)
    elseif exp < -326
        # https://github.com/JuliaData/Parsers.jl/issues/83
        return _scale(T, UInt128(v), exp, neg)
    end
    return _scale(T, v, exp, neg)
end

function _scale(::Type{T}, v::UInt64, exp, neg) where {T}
    mant, pow = pow10spl(exp + 326)
    lz = leading_zeros(v)
    newv = v << lz
    upper, lower = two_prod(newv, mant)
    if upper & 0x1FF == 0x1FF && (lower + newv < lower)
        mant_low = mant128(exp + 325)
        product_middle2, product_low = two_prod(newv, mant_low)
        product_middle1 = lower
        product_high = upper
        product_middle = product_middle1 + product_middle2
        if product_middle < product_middle1
            product_high += 1 # overflow carry
        end
        if (product_middle + 1 == 0) && (product_high & 0x1FF == 0x1FF) &&
            (product_low + v < product_low)
            return _scale(T, UInt128(v), exp, neg)
        end
        upper = product_high
        lower = product_middle
    end
    upperbit = upper >> 63
    mantissa = upper >> (upperbit + 9)
    lz += xor(1, upperbit)
    if (lower == 0) && upper & 0x1FF == 0 && mantissa & 3 == 1
        return _scale(T, UInt128(v), exp, neg)
    end
    mantissa += mantissa & 1
    mantissa >>= 1
    if mantissa >= UInt64(1) << 53
        mantissa = UInt64(1) << 52
        lz -= 1
    end
    mantissa &= ~(UInt64(1) << 52)
    real_exponent = pow - lz
    if real_exponent < 1 || real_exponent > 2046
        return _scale(T, UInt128(v), exp, neg)
    end
    mantissa |= real_exponent << 52
    mantissa |= (UInt64(neg) << 63)
    return T(Core.bitcast(Float64, mantissa))
end

convert_and_apply_neg(::Type{T}, x, neg) where {T} = neg ? T(-x) : T(x)

# Copied from https://github.com/JuliaLang/julia/blob/c054dbc6d4e03d7168864fed018e3635b546d251/base/mpfr.jl#L1029-L1031
function unalias_bigfloat(x::BigFloat)
    d = x._d
    d′ = GC.@preserve d unsafe_string(pointer(d), sizeof(d)) # creates a definitely-new String
    return Base.MPFR._BigFloat(x.prec, x.sign, x.exp, d′)
end

# need to special-case here because `x` came from thread-local BIGFLOATS array
# so we need to make a copy to get a fresh BigFloat
# # See https://github.com/JuliaData/CSV.jl/issues/938
function convert_and_apply_neg(::Type{BigFloat}, x::BigFloat, neg)
    y = unalias_bigfloat(x)
    if neg
        ccall((:mpfr_neg, :libmpfr), Int32, (Ref{BigFloat}, Ref{BigFloat}, Int32), y, y, MPFR.ROUNDING_MODE[])
    end
    return y
end

function _scale(::Type{T}, v::V, exp, neg) where {T, V <: UInt128}
    if exp == 23
        # special-case concluded from https://github.com/JuliaLang/julia/issues/38509
        x = v * V(1e23)
    elseif 0 <= exp < 290
        x = v * exp10(exp)
    elseif exp < -308 || exp > 308 || v > maxsig(T)
        # if v is too large, we lose precision by just doing
        # v / exp10(-exp) since that only promotes to Float64
        # so detect and re-route to this branch where we widen v
        y = _widen(v)
        return _scale(T, y, exp, neg)
    else
        x = v / exp10(-exp)
    end
    return convert_and_apply_neg(T, x, neg)
end

const BIGEXP10 = [1 / exp10(BigInt(e)) for e = 309:327]
const BIGFLOATEXP10 = [exp10(BigFloat(i; precision=256)) for i = 1:308]

function _scale(::Type{T}, v::V, exp, neg) where {T, V <: BigInt}
    x = _get_bigfloats()

    ccall((:mpfr_set_z, :libmpfr), Int32,
        (Ref{BigFloat}, Ref{BigInt}, Int32),
        x, v, MPFR.ROUNDING_MODE[])
    if exp < -308
        # v * (1 / exp10(-exp))
        if exp < -327
            y = 1 / exp10(BigInt(-exp))
        else
            y = BIGEXP10[-exp - 308]
        end
        ccall((:mpfr_mul, :libmpfr), Int32,
            (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, Int32),
            x, x, y, MPFR.ROUNDING_MODE[])
    elseif exp < 0
        # v / exp10(-exp)
        y = BIGFLOATEXP10[-exp]
        ccall((:mpfr_div, :libmpfr), Int32,
            (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, Int32),
            x, x, y, MPFR.ROUNDING_MODE[])
    else
        # v * exp10(V(exp))
        if exp <= 308
            y = BIGFLOATEXP10[exp]
        else
            y = exp10(BigFloat(exp; precision=256))
        end
        ccall((:mpfr_mul, :libmpfr), Int32,
            (Ref{BigFloat}, Ref{BigFloat}, Ref{BigFloat}, Int32),
            x, x, y, MPFR.ROUNDING_MODE[])
    end
    return convert_and_apply_neg(T, x, neg)
end

function two_prod(a, b)
    x = UInt128(a) * b
    return UInt64(x >> 64), x % UInt64
end

pow10spl(i) = (@inbounds x = POW10SPL[i + 1]; return x)
mant128(i) = (@inbounds x = MANTISSA128[i + 1]; return x)

const POW10SPL = [
    (0xa5ced43b7e3e9188, 7),
    (0xa5ced43b7e3e9188, 7),    (0xcf42894a5dce35ea, 10),
    (0x818995ce7aa0e1b2, 14),   (0xa1ebfb4219491a1f, 17),
    (0xca66fa129f9b60a6, 20),   (0xfd00b897478238d0, 23),
    (0x9e20735e8cb16382, 27),   (0xc5a890362fddbc62, 30),
    (0xf712b443bbd52b7b, 33),   (0x9a6bb0aa55653b2d, 37),
    (0xc1069cd4eabe89f8, 40),   (0xf148440a256e2c76, 43),
    (0x96cd2a865764dbca, 47),   (0xbc807527ed3e12bc, 50),
    (0xeba09271e88d976b, 53),   (0x93445b8731587ea3, 57),
    (0xb8157268fdae9e4c, 60),   (0xe61acf033d1a45df, 63),
    (0x8fd0c16206306bab, 67),   (0xb3c4f1ba87bc8696, 70),
    (0xe0b62e2929aba83c, 73),   (0x8c71dcd9ba0b4925, 77),
    (0xaf8e5410288e1b6f, 80),   (0xdb71e91432b1a24a, 83),
    (0x892731ac9faf056e, 87),   (0xab70fe17c79ac6ca, 90),
    (0xd64d3d9db981787d, 93),   (0x85f0468293f0eb4e, 97),
    (0xa76c582338ed2621, 100),  (0xd1476e2c07286faa, 103),
    (0x82cca4db847945ca, 107),  (0xa37fce126597973c, 110),
    (0xcc5fc196fefd7d0c, 113),  (0xff77b1fcbebcdc4f, 116),
    (0x9faacf3df73609b1, 120),  (0xc795830d75038c1d, 123),
    (0xf97ae3d0d2446f25, 126),  (0x9becce62836ac577, 130),
    (0xc2e801fb244576d5, 133),  (0xf3a20279ed56d48a, 136),
    (0x9845418c345644d6, 140),  (0xbe5691ef416bd60c, 143),
    (0xedec366b11c6cb8f, 146),  (0x94b3a202eb1c3f39, 150),
    (0xb9e08a83a5e34f07, 153),  (0xe858ad248f5c22c9, 156),
    (0x91376c36d99995be, 160),  (0xb58547448ffffb2d, 163),
    (0xe2e69915b3fff9f9, 166),  (0x8dd01fad907ffc3b, 170),
    (0xb1442798f49ffb4a, 173),  (0xdd95317f31c7fa1d, 176),
    (0x8a7d3eef7f1cfc52, 180),  (0xad1c8eab5ee43b66, 183),
    (0xd863b256369d4a40, 186),  (0x873e4f75e2224e68, 190),
    (0xa90de3535aaae202, 193),  (0xd3515c2831559a83, 196),
    (0x8412d9991ed58091, 200),  (0xa5178fff668ae0b6, 203),
    (0xce5d73ff402d98e3, 206),  (0x80fa687f881c7f8e, 210),
    (0xa139029f6a239f72, 213),  (0xc987434744ac874e, 216),
    (0xfbe9141915d7a922, 219),  (0x9d71ac8fada6c9b5, 223),
    (0xc4ce17b399107c22, 226),  (0xf6019da07f549b2b, 229),
    (0x99c102844f94e0fb, 233),  (0xc0314325637a1939, 236),
    (0xf03d93eebc589f88, 239),  (0x96267c7535b763b5, 243),
    (0xbbb01b9283253ca2, 246),  (0xea9c227723ee8bcb, 249),
    (0x92a1958a7675175f, 253),  (0xb749faed14125d36, 256),
    (0xe51c79a85916f484, 259),  (0x8f31cc0937ae58d2, 263),
    (0xb2fe3f0b8599ef07, 266),  (0xdfbdcece67006ac9, 269),
    (0x8bd6a141006042bd, 273),  (0xaecc49914078536d, 276),
    (0xda7f5bf590966848, 279),  (0x888f99797a5e012d, 283),
    (0xaab37fd7d8f58178, 286),  (0xd5605fcdcf32e1d6, 289),
    (0x855c3be0a17fcd26, 293),  (0xa6b34ad8c9dfc06f, 296),
    (0xd0601d8efc57b08b, 299),  (0x823c12795db6ce57, 303),
    (0xa2cb1717b52481ed, 306),  (0xcb7ddcdda26da268, 309),
    (0xfe5d54150b090b02, 312),  (0x9efa548d26e5a6e1, 316),
    (0xc6b8e9b0709f109a, 319),  (0xf867241c8cc6d4c0, 322),
    (0x9b407691d7fc44f8, 326),  (0xc21094364dfb5636, 329),
    (0xf294b943e17a2bc4, 332),  (0x979cf3ca6cec5b5a, 336),
    (0xbd8430bd08277231, 339),  (0xece53cec4a314ebd, 342),
    (0x940f4613ae5ed136, 346),  (0xb913179899f68584, 349),
    (0xe757dd7ec07426e5, 352),  (0x9096ea6f3848984f, 356),
    (0xb4bca50b065abe63, 359),  (0xe1ebce4dc7f16dfb, 362),
    (0x8d3360f09cf6e4bd, 366),  (0xb080392cc4349dec, 369),
    (0xdca04777f541c567, 372),  (0x89e42caaf9491b60, 376),
    (0xac5d37d5b79b6239, 379),  (0xd77485cb25823ac7, 382),
    (0x86a8d39ef77164bc, 386),  (0xa8530886b54dbdeb, 389),
    (0xd267caa862a12d66, 392),  (0x8380dea93da4bc60, 396),
    (0xa46116538d0deb78, 399),  (0xcd795be870516656, 402),
    (0x806bd9714632dff6, 406),  (0xa086cfcd97bf97f3, 409),
    (0xc8a883c0fdaf7df0, 412),  (0xfad2a4b13d1b5d6c, 415),
    (0x9cc3a6eec6311a63, 419),  (0xc3f490aa77bd60fc, 422),
    (0xf4f1b4d515acb93b, 425),  (0x991711052d8bf3c5, 429),
    (0xbf5cd54678eef0b6, 432),  (0xef340a98172aace4, 435),
    (0x9580869f0e7aac0e, 439),  (0xbae0a846d2195712, 442),
    (0xe998d258869facd7, 445),  (0x91ff83775423cc06, 449),
    (0xb67f6455292cbf08, 452),  (0xe41f3d6a7377eeca, 455),
    (0x8e938662882af53e, 459),  (0xb23867fb2a35b28d, 462),
    (0xdec681f9f4c31f31, 465),  (0x8b3c113c38f9f37e, 469),
    (0xae0b158b4738705e, 472),  (0xd98ddaee19068c76, 475),
    (0x87f8a8d4cfa417c9, 479),  (0xa9f6d30a038d1dbc, 482),
    (0xd47487cc8470652b, 485),  (0x84c8d4dfd2c63f3b, 489),
    (0xa5fb0a17c777cf09, 492),  (0xcf79cc9db955c2cc, 495),
    (0x81ac1fe293d599bf, 499),  (0xa21727db38cb002f, 502),
    (0xca9cf1d206fdc03b, 505),  (0xfd442e4688bd304a, 508),
    (0x9e4a9cec15763e2e, 512),  (0xc5dd44271ad3cdba, 515),
    (0xf7549530e188c128, 518),  (0x9a94dd3e8cf578b9, 522),
    (0xc13a148e3032d6e7, 525),  (0xf18899b1bc3f8ca1, 528),
    (0x96f5600f15a7b7e5, 532),  (0xbcb2b812db11a5de, 535),
    (0xebdf661791d60f56, 538),  (0x936b9fcebb25c995, 542),
    (0xb84687c269ef3bfb, 545),  (0xe65829b3046b0afa, 548),
    (0x8ff71a0fe2c2e6dc, 552),  (0xb3f4e093db73a093, 555),
    (0xe0f218b8d25088b8, 558),  (0x8c974f7383725573, 562),
    (0xafbd2350644eeacf, 565),  (0xdbac6c247d62a583, 568),
    (0x894bc396ce5da772, 572),  (0xab9eb47c81f5114f, 575),
    (0xd686619ba27255a2, 578),  (0x8613fd0145877585, 582),
    (0xa798fc4196e952e7, 585),  (0xd17f3b51fca3a7a0, 588),
    (0x82ef85133de648c4, 592),  (0xa3ab66580d5fdaf5, 595),
    (0xcc963fee10b7d1b3, 598),  (0xffbbcfe994e5c61f, 601),
    (0x9fd561f1fd0f9bd3, 605),  (0xc7caba6e7c5382c8, 608),
    (0xf9bd690a1b68637b, 611),  (0x9c1661a651213e2d, 615),
    (0xc31bfa0fe5698db8, 618),  (0xf3e2f893dec3f126, 621),
    (0x986ddb5c6b3a76b7, 625),  (0xbe89523386091465, 628),
    (0xee2ba6c0678b597f, 631),  (0x94db483840b717ef, 635),
    (0xba121a4650e4ddeb, 638),  (0xe896a0d7e51e1566, 641),
    (0x915e2486ef32cd60, 645),  (0xb5b5ada8aaff80b8, 648),
    (0xe3231912d5bf60e6, 651),  (0x8df5efabc5979c8f, 655),
    (0xb1736b96b6fd83b3, 658),  (0xddd0467c64bce4a0, 661),
    (0x8aa22c0dbef60ee4, 665),  (0xad4ab7112eb3929d, 668),
    (0xd89d64d57a607744, 671),  (0x87625f056c7c4a8b, 675),
    (0xa93af6c6c79b5d2d, 678),  (0xd389b47879823479, 681),
    (0x843610cb4bf160cb, 685),  (0xa54394fe1eedb8fe, 688),
    (0xce947a3da6a9273e, 691),  (0x811ccc668829b887, 695),
    (0xa163ff802a3426a8, 698),  (0xc9bcff6034c13052, 701),
    (0xfc2c3f3841f17c67, 704),  (0x9d9ba7832936edc0, 708),
    (0xc5029163f384a931, 711),  (0xf64335bcf065d37d, 714),
    (0x99ea0196163fa42e, 718),  (0xc06481fb9bcf8d39, 721),
    (0xf07da27a82c37088, 724),  (0x964e858c91ba2655, 728),
    (0xbbe226efb628afea, 731),  (0xeadab0aba3b2dbe5, 734),
    (0x92c8ae6b464fc96f, 738),  (0xb77ada0617e3bbcb, 741),
    (0xe55990879ddcaabd, 744),  (0x8f57fa54c2a9eab6, 748),
    (0xb32df8e9f3546564, 751),  (0xdff9772470297ebd, 754),
    (0x8bfbea76c619ef36, 758),  (0xaefae51477a06b03, 761),
    (0xdab99e59958885c4, 764),  (0x88b402f7fd75539b, 768),
    (0xaae103b5fcd2a881, 771),  (0xd59944a37c0752a2, 774),
    (0x857fcae62d8493a5, 778),  (0xa6dfbd9fb8e5b88e, 781),
    (0xd097ad07a71f26b2, 784),  (0x825ecc24c873782f, 788),
    (0xa2f67f2dfa90563b, 791),  (0xcbb41ef979346bca, 794),
    (0xfea126b7d78186bc, 797),  (0x9f24b832e6b0f436, 801),
    (0xc6ede63fa05d3143, 804),  (0xf8a95fcf88747d94, 807),
    (0x9b69dbe1b548ce7c, 811),  (0xc24452da229b021b, 814),
    (0xf2d56790ab41c2a2, 817),  (0x97c560ba6b0919a5, 821),
    (0xbdb6b8e905cb600f, 824),  (0xed246723473e3813, 827),
    (0x9436c0760c86e30b, 831),  (0xb94470938fa89bce, 834),
    (0xe7958cb87392c2c2, 837),  (0x90bd77f3483bb9b9, 841),
    (0xb4ecd5f01a4aa828, 844),  (0xe2280b6c20dd5232, 847),
    (0x8d590723948a535f, 851),  (0xb0af48ec79ace837, 854),
    (0xdcdb1b2798182244, 857),  (0x8a08f0f8bf0f156b, 861),
    (0xac8b2d36eed2dac5, 864),  (0xd7adf884aa879177, 867),
    (0x86ccbb52ea94baea, 871),  (0xa87fea27a539e9a5, 874),
    (0xd29fe4b18e88640e, 877),  (0x83a3eeeef9153e89, 881),
    (0xa48ceaaab75a8e2b, 884),  (0xcdb02555653131b6, 887),
    (0x808e17555f3ebf11, 891),  (0xa0b19d2ab70e6ed6, 894),
    (0xc8de047564d20a8b, 897),  (0xfb158592be068d2e, 900),
    (0x9ced737bb6c4183d, 904),  (0xc428d05aa4751e4c, 907),
    (0xf53304714d9265df, 910),  (0x993fe2c6d07b7fab, 914),
    (0xbf8fdb78849a5f96, 917),  (0xef73d256a5c0f77c, 920),
    (0x95a8637627989aad, 924),  (0xbb127c53b17ec159, 927),
    (0xe9d71b689dde71af, 930),  (0x9226712162ab070d, 934),
    (0xb6b00d69bb55c8d1, 937),  (0xe45c10c42a2b3b05, 940),
    (0x8eb98a7a9a5b04e3, 944),  (0xb267ed1940f1c61c, 947),
    (0xdf01e85f912e37a3, 950),  (0x8b61313bbabce2c6, 954),
    (0xae397d8aa96c1b77, 957),  (0xd9c7dced53c72255, 960),
    (0x881cea14545c7575, 964),  (0xaa242499697392d2, 967),
    (0xd4ad2dbfc3d07787, 970),  (0x84ec3c97da624ab4, 974),
    (0xa6274bbdd0fadd61, 977),  (0xcfb11ead453994ba, 980),
    (0x81ceb32c4b43fcf4, 984),  (0xa2425ff75e14fc31, 987),
    (0xcad2f7f5359a3b3e, 990),  (0xfd87b5f28300ca0d, 993),
    (0x9e74d1b791e07e48, 997),  (0xc612062576589dda, 1000),
    (0xf79687aed3eec551, 1003), (0x9abe14cd44753b52, 1007),
    (0xc16d9a0095928a27, 1010), (0xf1c90080baf72cb1, 1013),
    (0x971da05074da7bee, 1017), (0xbce5086492111aea, 1020),
    (0xec1e4a7db69561a5, 1023), (0x9392ee8e921d5d07, 1027),
    (0xb877aa3236a4b449, 1030), (0xe69594bec44de15b, 1033),
    (0x901d7cf73ab0acd9, 1037), (0xb424dc35095cd80f, 1040),
    (0xe12e13424bb40e13, 1043), (0x8cbccc096f5088cb, 1047),
    (0xafebff0bcb24aafe, 1050), (0xdbe6fecebdedd5be, 1053),
    (0x89705f4136b4a597, 1057), (0xabcc77118461cefc, 1060),
    (0xd6bf94d5e57a42bc, 1063), (0x8637bd05af6c69b5, 1067),
    (0xa7c5ac471b478423, 1070), (0xd1b71758e219652b, 1073),
    (0x83126e978d4fdf3b, 1077), (0xa3d70a3d70a3d70a, 1080),
    (0xcccccccccccccccc, 1083), (0x8000000000000000, 1087),
    (0xa000000000000000, 1090), (0xc800000000000000, 1093),
    (0xfa00000000000000, 1096), (0x9c40000000000000, 1100),
    (0xc350000000000000, 1103), (0xf424000000000000, 1106),
    (0x9896800000000000, 1110), (0xbebc200000000000, 1113),
    (0xee6b280000000000, 1116), (0x9502f90000000000, 1120),
    (0xba43b74000000000, 1123), (0xe8d4a51000000000, 1126),
    (0x9184e72a00000000, 1130), (0xb5e620f480000000, 1133),
    (0xe35fa931a0000000, 1136), (0x8e1bc9bf04000000, 1140),
    (0xb1a2bc2ec5000000, 1143), (0xde0b6b3a76400000, 1146),
    (0x8ac7230489e80000, 1150), (0xad78ebc5ac620000, 1153),
    (0xd8d726b7177a8000, 1156), (0x878678326eac9000, 1160),
    (0xa968163f0a57b400, 1163), (0xd3c21bcecceda100, 1166),
    (0x84595161401484a0, 1170), (0xa56fa5b99019a5c8, 1173),
    (0xcecb8f27f4200f3a, 1176), (0x813f3978f8940984, 1180),
    (0xa18f07d736b90be5, 1183), (0xc9f2c9cd04674ede, 1186),
    (0xfc6f7c4045812296, 1189), (0x9dc5ada82b70b59d, 1193),
    (0xc5371912364ce305, 1196), (0xf684df56c3e01bc6, 1199),
    (0x9a130b963a6c115c, 1203), (0xc097ce7bc90715b3, 1206),
    (0xf0bdc21abb48db20, 1209), (0x96769950b50d88f4, 1213),
    (0xbc143fa4e250eb31, 1216), (0xeb194f8e1ae525fd, 1219),
    (0x92efd1b8d0cf37be, 1223), (0xb7abc627050305ad, 1226),
    (0xe596b7b0c643c719, 1229), (0x8f7e32ce7bea5c6f, 1233),
    (0xb35dbf821ae4f38b, 1236), (0xe0352f62a19e306e, 1239),
    (0x8c213d9da502de45, 1243), (0xaf298d050e4395d6, 1246),
    (0xdaf3f04651d47b4c, 1249), (0x88d8762bf324cd0f, 1253),
    (0xab0e93b6efee0053, 1256), (0xd5d238a4abe98068, 1259),
    (0x85a36366eb71f041, 1263), (0xa70c3c40a64e6c51, 1266),
    (0xd0cf4b50cfe20765, 1269), (0x82818f1281ed449f, 1273),
    (0xa321f2d7226895c7, 1276), (0xcbea6f8ceb02bb39, 1279),
    (0xfee50b7025c36a08, 1282), (0x9f4f2726179a2245, 1286),
    (0xc722f0ef9d80aad6, 1289), (0xf8ebad2b84e0d58b, 1292),
    (0x9b934c3b330c8577, 1296), (0xc2781f49ffcfa6d5, 1299),
    (0xf316271c7fc3908a, 1302), (0x97edd871cfda3a56, 1306),
    (0xbde94e8e43d0c8ec, 1309), (0xed63a231d4c4fb27, 1312),
    (0x945e455f24fb1cf8, 1316), (0xb975d6b6ee39e436, 1319),
    (0xe7d34c64a9c85d44, 1322), (0x90e40fbeea1d3a4a, 1326),
    (0xb51d13aea4a488dd, 1329), (0xe264589a4dcdab14, 1332),
    (0x8d7eb76070a08aec, 1336), (0xb0de65388cc8ada8, 1339),
    (0xdd15fe86affad912, 1342), (0x8a2dbf142dfcc7ab, 1346),
    (0xacb92ed9397bf996, 1349), (0xd7e77a8f87daf7fb, 1352),
    (0x86f0ac99b4e8dafd, 1356), (0xa8acd7c0222311bc, 1359),
    (0xd2d80db02aabd62b, 1362), (0x83c7088e1aab65db, 1366),
    (0xa4b8cab1a1563f52, 1369), (0xcde6fd5e09abcf26, 1372),
    (0x80b05e5ac60b6178, 1376), (0xa0dc75f1778e39d6, 1379),
    (0xc913936dd571c84c, 1382), (0xfb5878494ace3a5f, 1385),
    (0x9d174b2dcec0e47b, 1389), (0xc45d1df942711d9a, 1392),
    (0xf5746577930d6500, 1395), (0x9968bf6abbe85f20, 1399),
    (0xbfc2ef456ae276e8, 1402), (0xefb3ab16c59b14a2, 1405),
    (0x95d04aee3b80ece5, 1409), (0xbb445da9ca61281f, 1412),
    (0xea1575143cf97226, 1415), (0x924d692ca61be758, 1419),
    (0xb6e0c377cfa2e12e, 1422), (0xe498f455c38b997a, 1425),
    (0x8edf98b59a373fec, 1429), (0xb2977ee300c50fe7, 1432),
    (0xdf3d5e9bc0f653e1, 1435), (0x8b865b215899f46c, 1439),
    (0xae67f1e9aec07187, 1442), (0xda01ee641a708de9, 1445),
    (0x884134fe908658b2, 1449), (0xaa51823e34a7eede, 1452),
    (0xd4e5e2cdc1d1ea96, 1455), (0x850fadc09923329e, 1459),
    (0xa6539930bf6bff45, 1462), (0xcfe87f7cef46ff16, 1465),
    (0x81f14fae158c5f6e, 1469), (0xa26da3999aef7749, 1472),
    (0xcb090c8001ab551c, 1475), (0xfdcb4fa002162a63, 1478),
    (0x9e9f11c4014dda7e, 1482), (0xc646d63501a1511d, 1485),
    (0xf7d88bc24209a565, 1488), (0x9ae757596946075f, 1492),
    (0xc1a12d2fc3978937, 1495), (0xf209787bb47d6b84, 1498),
    (0x9745eb4d50ce6332, 1502), (0xbd176620a501fbff, 1505),
    (0xec5d3fa8ce427aff, 1508), (0x93ba47c980e98cdf, 1512),
    (0xb8a8d9bbe123f017, 1515), (0xe6d3102ad96cec1d, 1518),
    (0x9043ea1ac7e41392, 1522), (0xb454e4a179dd1877, 1525),
    (0xe16a1dc9d8545e94, 1528), (0x8ce2529e2734bb1d, 1532),
    (0xb01ae745b101e9e4, 1535), (0xdc21a1171d42645d, 1538),
    (0x899504ae72497eba, 1542), (0xabfa45da0edbde69, 1545),
    (0xd6f8d7509292d603, 1548), (0x865b86925b9bc5c2, 1552),
    (0xa7f26836f282b732, 1555), (0xd1ef0244af2364ff, 1558),
    (0x8335616aed761f1f, 1562), (0xa402b9c5a8d3a6e7, 1565),
    (0xcd036837130890a1, 1568), (0x802221226be55a64, 1572),
    (0xa02aa96b06deb0fd, 1575), (0xc83553c5c8965d3d, 1578),
    (0xfa42a8b73abbf48c, 1581), (0x9c69a97284b578d7, 1585),
    (0xc38413cf25e2d70d, 1588), (0xf46518c2ef5b8cd1, 1591),
    (0x98bf2f79d5993802, 1595), (0xbeeefb584aff8603, 1598),
    (0xeeaaba2e5dbf6784, 1601), (0x952ab45cfa97a0b2, 1605),
    (0xba756174393d88df, 1608), (0xe912b9d1478ceb17, 1611),
    (0x91abb422ccb812ee, 1615), (0xb616a12b7fe617aa, 1618),
    (0xe39c49765fdf9d94, 1621), (0x8e41ade9fbebc27d, 1625),
    (0xb1d219647ae6b31c, 1628), (0xde469fbd99a05fe3, 1631),
    (0x8aec23d680043bee, 1635), (0xada72ccc20054ae9, 1638),
    (0xd910f7ff28069da4, 1641), (0x87aa9aff79042286, 1645),
    (0xa99541bf57452b28, 1648), (0xd3fa922f2d1675f2, 1651),
    (0x847c9b5d7c2e09b7, 1655), (0xa59bc234db398c25, 1658),
    (0xcf02b2c21207ef2e, 1661), (0x8161afb94b44f57d, 1665),
    (0xa1ba1ba79e1632dc, 1668), (0xca28a291859bbf93, 1671),
    (0xfcb2cb35e702af78, 1674), (0x9defbf01b061adab, 1678),
    (0xc56baec21c7a1916, 1681), (0xf6c69a72a3989f5b, 1684),
    (0x9a3c2087a63f6399, 1688), (0xc0cb28a98fcf3c7f, 1691),
    (0xf0fdf2d3f3c30b9f, 1694), (0x969eb7c47859e743, 1698),
    (0xbc4665b596706114, 1701), (0xeb57ff22fc0c7959, 1704),
    (0x9316ff75dd87cbd8, 1708), (0xb7dcbf5354e9bece, 1711),
    (0xe5d3ef282a242e81, 1714), (0x8fa475791a569d10, 1718),
    (0xb38d92d760ec4455, 1721), (0xe070f78d3927556a, 1724),
    (0x8c469ab843b89562, 1728), (0xaf58416654a6babb, 1731),
    (0xdb2e51bfe9d0696a, 1734), (0x88fcf317f22241e2, 1738),
    (0xab3c2fddeeaad25a, 1741), (0xd60b3bd56a5586f1, 1744),
    (0x85c7056562757456, 1748), (0xa738c6bebb12d16c, 1751),
    (0xd106f86e69d785c7, 1754), (0x82a45b450226b39c, 1758),
    (0xa34d721642b06084, 1761), (0xcc20ce9bd35c78a5, 1764),
    (0xff290242c83396ce, 1767), (0x9f79a169bd203e41, 1771),
    (0xc75809c42c684dd1, 1774), (0xf92e0c3537826145, 1777),
    (0x9bbcc7a142b17ccb, 1781), (0xc2abf989935ddbfe, 1784),
    (0xf356f7ebf83552fe, 1787), (0x98165af37b2153de, 1791),
    (0xbe1bf1b059e9a8d6, 1794), (0xeda2ee1c7064130c, 1797),
    (0x9485d4d1c63e8be7, 1801), (0xb9a74a0637ce2ee1, 1804),
    (0xe8111c87c5c1ba99, 1807), (0x910ab1d4db9914a0, 1811),
    (0xb54d5e4a127f59c8, 1814), (0xe2a0b5dc971f303a, 1817),
    (0x8da471a9de737e24, 1821), (0xb10d8e1456105dad, 1824),
    (0xdd50f1996b947518, 1827), (0x8a5296ffe33cc92f, 1831),
    (0xace73cbfdc0bfb7b, 1834), (0xd8210befd30efa5a, 1837),
    (0x8714a775e3e95c78, 1841), (0xa8d9d1535ce3b396, 1844),
    (0xd31045a8341ca07c, 1847), (0x83ea2b892091e44d, 1851),
    (0xa4e4b66b68b65d60, 1854), (0xce1de40642e3f4b9, 1857),
    (0x80d2ae83e9ce78f3, 1861), (0xa1075a24e4421730, 1864),
    (0xc94930ae1d529cfc, 1867), (0xfb9b7cd9a4a7443c, 1870),
    (0x9d412e0806e88aa5, 1874), (0xc491798a08a2ad4e, 1877),
    (0xf5b5d7ec8acb58a2, 1880), (0x9991a6f3d6bf1765, 1884),
    (0xbff610b0cc6edd3f, 1887), (0xeff394dcff8a948e, 1890),
    (0x95f83d0a1fb69cd9, 1894), (0xbb764c4ca7a4440f, 1897),
    (0xea53df5fd18d5513, 1900), (0x92746b9be2f8552c, 1904),
    (0xb7118682dbb66a77, 1907), (0xe4d5e82392a40515, 1910),
    (0x8f05b1163ba6832d, 1914), (0xb2c71d5bca9023f8, 1917),
    (0xdf78e4b2bd342cf6, 1920), (0x8bab8eefb6409c1a, 1924),
    (0xae9672aba3d0c320, 1927), (0xda3c0f568cc4f3e8, 1930),
    (0x8865899617fb1871, 1934), (0xaa7eebfb9df9de8d, 1937),
    (0xd51ea6fa85785631, 1940), (0x8533285c936b35de, 1944),
    (0xa67ff273b8460356, 1947), (0xd01fef10a657842c, 1950),
    (0x8213f56a67f6b29b, 1954), (0xa298f2c501f45f42, 1957),
    (0xcb3f2f7642717713, 1960), (0xfe0efb53d30dd4d7, 1963),
    (0x9ec95d1463e8a506, 1967), (0xc67bb4597ce2ce48, 1970),
    (0xf81aa16fdc1b81da, 1973), (0x9b10a4e5e9913128, 1977),
    (0xc1d4ce1f63f57d72, 1980), (0xf24a01a73cf2dccf, 1983),
    (0x976e41088617ca01, 1987), (0xbd49d14aa79dbc82, 1990),
    (0xec9c459d51852ba2, 1993), (0x93e1ab8252f33b45, 1997),
    (0xb8da1662e7b00a17, 2000), (0xe7109bfba19c0c9d, 2003),
    (0x906a617d450187e2, 2007), (0xb484f9dc9641e9da, 2010),
    (0xe1a63853bbd26451, 2013), (0x8d07e33455637eb2, 2017),
    (0xb049dc016abc5e5f, 2020), (0xdc5c5301c56b75f7, 2023),
    (0x89b9b3e11b6329ba, 2027), (0xac2820d9623bf429, 2030),
    (0xd732290fbacaf133, 2033), (0x867f59a9d4bed6c0, 2037),
    (0xa81f301449ee8c70, 2040), (0xd226fc195c6a2f8c, 2043),
    (0x83585d8fd9c25db7, 2047), (0xa42e74f3d032f525, 2050),
    (0xcd3a1230c43fb26f, 2053), (0x80444b5e7aa7cf85, 2057),
    (0xa0555e361951c366, 2060), (0xc86ab5c39fa63440, 2063),
    (0xfa856334878fc150, 2066), (0x9c935e00d4b9d8d2, 2070),
    (0xc3b8358109e84f07, 2073), (0xf4a642e14c6262c8, 2076),
    (0x98e7e9cccfbd7dbd, 2080), (0xbf21e44003acdd2c, 2083),
    (0xeeea5d5004981478, 2086), (0x95527a5202df0ccb, 2090),
    (0xbaa718e68396cffd, 2093), (0xe950df20247c83fd, 2096),
    (0x91d28b7416cdd27e, 2100), (0xb6472e511c81471d, 2103),
    (0xe3d8f9e563a198e5, 2106), (0x8e679c2f5e44ff8f, 2110)]

const MANTISSA128 = [0x419ea3bd35385e2d,
    0x52064cac828675b9,
    0x7343efebd1940993,
    0x1014ebe6c5f90bf8,
    0xd41a26e077774ef6,
    0x8920b098955522b4,
    0x55b46e5f5d5535b0,
    0xeb2189f734aa831d,
    0xa5e9ec7501d523e4,
    0x47b233c92125366e,
    0x999ec0bb696e840a,
    0xc00670ea43ca250d,
    0x380406926a5e5728,
    0xc605083704f5ecf2,
    0xf7864a44c633682e,
    0x7ab3ee6afbe0211d,
    0x5960ea05bad82964,
    0x6fb92487298e33bd,
    0xa5d3b6d479f8e056,
    0x8f48a4899877186c,
    0x331acdabfe94de87,
    0x9ff0c08b7f1d0b14,
    0x7ecf0ae5ee44dd9,
    0xc9e82cd9f69d6150,
    0xbe311c083a225cd2,
    0x6dbd630a48aaf406,
    0x92cbbccdad5b108,
    0x25bbf56008c58ea5,
    0xaf2af2b80af6f24e,
    0x1af5af660db4aee1,
    0x50d98d9fc890ed4d,
    0xe50ff107bab528a0,
    0x1e53ed49a96272c8,
    0x25e8e89c13bb0f7a,
    0x77b191618c54e9ac,
    0xd59df5b9ef6a2417,
    0x4b0573286b44ad1d,
    0x4ee367f9430aec32,
    0x229c41f793cda73f,
    0x6b43527578c1110f,
    0x830a13896b78aaa9,
    0x23cc986bc656d553,
    0x2cbfbe86b7ec8aa8,
    0x7bf7d71432f3d6a9,
    0xdaf5ccd93fb0cc53,
    0xd1b3400f8f9cff68,
    0x23100809b9c21fa1,
    0xabd40a0c2832a78a,
    0x16c90c8f323f516c,
    0xae3da7d97f6792e3,
    0x99cd11cfdf41779c,
    0x40405643d711d583,
    0x482835ea666b2572,
    0xda3243650005eecf,
    0x90bed43e40076a82,
    0x5a7744a6e804a291,
    0x711515d0a205cb36,
    0xd5a5b44ca873e03,
    0xe858790afe9486c2,
    0x626e974dbe39a872,
    0xfb0a3d212dc8128f,
    0x7ce66634bc9d0b99,
    0x1c1fffc1ebc44e80,
    0xa327ffb266b56220,
    0x4bf1ff9f0062baa8,
    0x6f773fc3603db4a9,
    0xcb550fb4384d21d3,
    0x7e2a53a146606a48,
    0x2eda7444cbfc426d,
    0xfa911155fefb5308,
    0x793555ab7eba27ca,
    0x4bc1558b2f3458de,
    0x9eb1aaedfb016f16,
    0x465e15a979c1cadc,
    0xbfacd89ec191ec9,
    0xcef980ec671f667b,
    0x82b7e12780e7401a,
    0xd1b2ecb8b0908810,
    0x861fa7e6dcb4aa15,
    0x67a791e093e1d49a,
    0xe0c8bb2c5c6d24e0,
    0x58fae9f773886e18,
    0xaf39a475506a899e,
    0x6d8406c952429603,
    0xc8e5087ba6d33b83,
    0xfb1e4a9a90880a64,
    0x5cf2eea09a55067f,
    0xf42faa48c0ea481e,
    0xf13b94daf124da26,
    0x76c53d08d6b70858,
    0x54768c4b0c64ca6e,
    0xa9942f5dcf7dfd09,
    0xd3f93b35435d7c4c,
    0xc47bc5014a1a6daf,
    0x359ab6419ca1091b,
    0xc30163d203c94b62,
    0x79e0de63425dcf1d,
    0x985915fc12f542e4,
    0x3e6f5b7b17b2939d,
    0xa705992ceecf9c42,
    0x50c6ff782a838353,
    0xa4f8bf5635246428,
    0x871b7795e136be99,
    0x28e2557b59846e3f,
    0x331aeada2fe589cf,
    0x3ff0d2c85def7621,
    0xfed077a756b53a9,
    0xd3e8495912c62894,
    0x64712dd7abbbd95c,
    0xbd8d794d96aacfb3,
    0xecf0d7a0fc5583a0,
    0xf41686c49db57244,
    0x311c2875c522ced5,
    0x7d633293366b828b,
    0xae5dff9c02033197,
    0xd9f57f830283fdfc,
    0xd072df63c324fd7b,
    0x4247cb9e59f71e6d,
    0x52d9be85f074e608,
    0x67902e276c921f8b,
    0xba1cd8a3db53b6,
    0x80e8a40eccd228a4,
    0x6122cd128006b2cd,
    0x796b805720085f81,
    0xcbe3303674053bb0,
    0xbedbfc4411068a9c,
    0xee92fb5515482d44,
    0x751bdd152d4d1c4a,
    0xd262d45a78a0635d,
    0x86fb897116c87c34,
    0xd45d35e6ae3d4da0,
    0x8974836059cca109,
    0x2bd1a438703fc94b,
    0x7b6306a34627ddcf,
    0x1a3bc84c17b1d542,
    0x20caba5f1d9e4a93,
    0x547eb47b7282ee9c,
    0xe99e619a4f23aa43,
    0x6405fa00e2ec94d4,
    0xde83bc408dd3dd04,
    0x9624ab50b148d445,
    0x3badd624dd9b0957,
    0xe54ca5d70a80e5d6,
    0x5e9fcf4ccd211f4c,
    0x7647c3200069671f,
    0x29ecd9f40041e073,
    0xf468107100525890,
    0x7182148d4066eeb4,
    0xc6f14cd848405530,
    0xb8ada00e5a506a7c,
    0xa6d90811f0e4851c,
    0x908f4a166d1da663,
    0x9a598e4e043287fe,
    0x40eff1e1853f29fd,
    0xd12bee59e68ef47c,
    0x82bb74f8301958ce,
    0xe36a52363c1faf01,
    0xdc44e6c3cb279ac1,
    0x29ab103a5ef8c0b9,
    0x7415d448f6b6f0e7,
    0x111b495b3464ad21,
    0xcab10dd900beec34,
    0x3d5d514f40eea742,
    0xcb4a5a3112a5112,
    0x47f0e785eaba72ab,
    0x59ed216765690f56,
    0x306869c13ec3532c,
    0x1e414218c73a13fb,
    0xe5d1929ef90898fa,
    0xdf45f746b74abf39,
    0x6b8bba8c328eb783,
    0x66ea92f3f326564,
    0xc80a537b0efefebd,
    0xbd06742ce95f5f36,
    0x2c48113823b73704,
    0xf75a15862ca504c5,
    0x9a984d73dbe722fb,
    0xc13e60d0d2e0ebba,
    0x318df905079926a8,
    0xfdf17746497f7052,
    0xfeb6ea8bedefa633,
    0xfe64a52ee96b8fc0,
    0x3dfdce7aa3c673b0,
    0x6bea10ca65c084e,
    0x486e494fcff30a62,
    0x5a89dba3c3efccfa,
    0xf89629465a75e01c,
    0xf6bbb397f1135823,
    0x746aa07ded582e2c,
    0xa8c2a44eb4571cdc,
    0x92f34d62616ce413,
    0x77b020baf9c81d17,
    0xace1474dc1d122e,
    0xd819992132456ba,
    0x10e1fff697ed6c69,
    0xca8d3ffa1ef463c1,
    0xbd308ff8a6b17cb2,
    0xac7cb3f6d05ddbde,
    0x6bcdf07a423aa96b,
    0x86c16c98d2c953c6,
    0xe871c7bf077ba8b7,
    0x11471cd764ad4972,
    0xd598e40d3dd89bcf,
    0x4aff1d108d4ec2c3,
    0xcedf722a585139ba,
    0xc2974eb4ee658828,
    0x733d226229feea32,
    0x806357d5a3f525f,
    0xca07c2dcb0cf26f7,
    0xfc89b393dd02f0b5,
    0xbbac2078d443ace2,
    0xd54b944b84aa4c0d,
    0xa9e795e65d4df11,
    0x4d4617b5ff4a16d5,
    0x504bced1bf8e4e45,
    0xe45ec2862f71e1d6,
    0x5d767327bb4e5a4c,
    0x3a6a07f8d510f86f,
    0x890489f70a55368b,
    0x2b45ac74ccea842e,
    0x3b0b8bc90012929d,
    0x9ce6ebb40173744,
    0xcc420a6a101d0515,
    0x9fa946824a12232d,
    0x47939822dc96abf9,
    0x59787e2b93bc56f7,
    0x57eb4edb3c55b65a,
    0xede622920b6b23f1,
    0xe95fab368e45eced,
    0x11dbcb0218ebb414,
    0xd652bdc29f26a119,
    0x4be76d3346f0495f,
    0x6f70a4400c562ddb,
    0xcb4ccd500f6bb952,
    0x7e2000a41346a7a7,
    0x8ed400668c0c28c8,
    0x728900802f0f32fa,
    0x4f2b40a03ad2ffb9,
    0xe2f610c84987bfa8,
    0xdd9ca7d2df4d7c9,
    0x91503d1c79720dbb,
    0x75a44c6397ce912a,
    0xc986afbe3ee11aba,
    0xfbe85badce996168,
    0xfae27299423fb9c3,
    0xdccd879fc967d41a,
    0x5400e987bbc1c920,
    0x290123e9aab23b68,
    0xf9a0b6720aaf6521,
    0xf808e40e8d5b3e69,
    0xb60b1d1230b20e04,
    0xb1c6f22b5e6f48c2,
    0x1e38aeb6360b1af3,
    0x25c6da63c38de1b0,
    0x579c487e5a38ad0e,
    0x2d835a9df0c6d851,
    0xf8e431456cf88e65,
    0x1b8e9ecb641b58ff,
    0xe272467e3d222f3f,
    0x5b0ed81dcc6abb0f,
    0x98e947129fc2b4e9,
    0x3f2398d747b36224,
    0x8eec7f0d19a03aad,
    0x1953cf68300424ac,
    0x5fa8c3423c052dd7,
    0x3792f412cb06794d,
    0xe2bbd88bbee40bd0,
    0x5b6aceaeae9d0ec4,
    0xf245825a5a445275,
    0xeed6e2f0f0d56712,
    0x55464dd69685606b,
    0xaa97e14c3c26b886,
    0xd53dd99f4b3066a8,
    0xe546a8038efe4029,
    0xde98520472bdd033,
    0x963e66858f6d4440,
    0xdde7001379a44aa8,
    0x5560c018580d5d52,
    0xaab8f01e6e10b4a6,
    0xcab3961304ca70e8,
    0x3d607b97c5fd0d22,
    0x8cb89a7db77c506a,
    0x77f3608e92adb242,
    0x55f038b237591ed3,
    0x6b6c46dec52f6688,
    0x2323ac4b3b3da015,
    0xabec975e0a0d081a,
    0x96e7bd358c904a21,
    0x7e50d64177da2e54,
    0xdde50bd1d5d0b9e9,
    0x955e4ec64b44e864,
    0xbd5af13bef0b113e,
    0xecb1ad8aeacdd58e,
    0x67de18eda5814af2,
    0x80eacf948770ced7,
    0xa1258379a94d028d,
    0x96ee45813a04330,
    0x8bca9d6e188853fc,
    0x775ea264cf55347d,
    0x95364afe032a819d,
    0x3a83ddbd83f52204,
    0xc4926a9672793542,
    0x75b7053c0f178293,
    0x5324c68b12dd6338,
    0xd3f6fc16ebca5e03,
    0x88f4bb1ca6bcf584,
    0x2b31e9e3d06c32e5,
    0x3aff322e62439fcf,
    0x9befeb9fad487c2,
    0x4c2ebe687989a9b3,
    0xf9d37014bf60a10,
    0x538484c19ef38c94,
    0x2865a5f206b06fb9,
    0xf93f87b7442e45d3,
    0xf78f69a51539d748,
    0xb573440e5a884d1b,
    0x31680a88f8953030,
    0xfdc20d2b36ba7c3d,
    0x3d32907604691b4c,
    0xa63f9a49c2c1b10f,
    0xfcf80dc33721d53,
    0xd3c36113404ea4a8,
    0x645a1cac083126e9,
    0x3d70a3d70a3d70a3,
    0xcccccccccccccccc,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x0,
    0x4000000000000000,
    0x5000000000000000,
    0xa400000000000000,
    0x4d00000000000000,
    0xf020000000000000,
    0x6c28000000000000,
    0xc732000000000000,
    0x3c7f400000000000,
    0x4b9f100000000000,
    0x1e86d40000000000,
    0x1314448000000000,
    0x17d955a000000000,
    0x5dcfab0800000000,
    0x5aa1cae500000000,
    0xf14a3d9e40000000,
    0x6d9ccd05d0000000,
    0xe4820023a2000000,
    0xdda2802c8a800000,
    0xd50b2037ad200000,
    0x4526f422cc340000,
    0x9670b12b7f410000,
    0x3c0cdd765f114000,
    0xa5880a69fb6ac800,
    0x8eea0d047a457a00,
    0x72a4904598d6d880,
    0x47a6da2b7f864750,
    0x999090b65f67d924,
    0xfff4b4e3f741cf6d,
    0xbff8f10e7a8921a4,
    0xaff72d52192b6a0d,
    0x9bf4f8a69f764490,
    0x2f236d04753d5b4,
    0x1d762422c946590,
    0x424d3ad2b7b97ef5,
    0xd2e0898765a7deb2,
    0x63cc55f49f88eb2f,
    0x3cbf6b71c76b25fb,
    0x8bef464e3945ef7a,
    0x97758bf0e3cbb5ac,
    0x3d52eeed1cbea317,
    0x4ca7aaa863ee4bdd,
    0x8fe8caa93e74ef6a,
    0xb3e2fd538e122b44,
    0x60dbbca87196b616,
    0xbc8955e946fe31cd,
    0x6babab6398bdbe41,
    0xc696963c7eed2dd1,
    0xfc1e1de5cf543ca2,
    0x3b25a55f43294bcb,
    0x49ef0eb713f39ebe,
    0x6e3569326c784337,
    0x49c2c37f07965404,
    0xdc33745ec97be906,
    0x69a028bb3ded71a3,
    0xc40832ea0d68ce0c,
    0xf50a3fa490c30190,
    0x792667c6da79e0fa,
    0x577001b891185938,
    0xed4c0226b55e6f86,
    0x544f8158315b05b4,
    0x696361ae3db1c721,
    0x3bc3a19cd1e38e9,
    0x4ab48a04065c723,
    0x62eb0d64283f9c76,
    0x3ba5d0bd324f8394,
    0xca8f44ec7ee36479,
    0x7e998b13cf4e1ecb,
    0x9e3fedd8c321a67e,
    0xc5cfe94ef3ea101e,
    0xbba1f1d158724a12,
    0x2a8a6e45ae8edc97,
    0xf52d09d71a3293bd,
    0x593c2626705f9c56,
    0x6f8b2fb00c77836c,
    0xb6dfb9c0f956447,
    0x4724bd4189bd5eac,
    0x58edec91ec2cb657,
    0x2f2967b66737e3ed,
    0xbd79e0d20082ee74,
    0xecd8590680a3aa11,
    0xe80e6f4820cc9495,
    0x3109058d147fdcdd,
    0xbd4b46f0599fd415,
    0x6c9e18ac7007c91a,
    0x3e2cf6bc604ddb0,
    0x84db8346b786151c,
    0xe612641865679a63,
    0x4fcb7e8f3f60c07e,
    0xe3be5e330f38f09d,
    0x5cadf5bfd3072cc5,
    0x73d9732fc7c8f7f6,
    0x2867e7fddcdd9afa,
    0xb281e1fd541501b8,
    0x1f225a7ca91a4226,
    0x3375788de9b06958,
    0x52d6b1641c83ae,
    0xc0678c5dbd23a49a,
    0xf840b7ba963646e0,
    0xb650e5a93bc3d898,
    0xa3e51f138ab4cebe,
    0xc66f336c36b10137,
    0xb80b0047445d4184,
    0xa60dc059157491e5,
    0x87c89837ad68db2f,
    0x29babe4598c311fb,
    0xf4296dd6fef3d67a,
    0x1899e4a65f58660c,
    0x5ec05dcff72e7f8f,
    0x76707543f4fa1f73,
    0x6a06494a791c53a8,
    0x487db9d17636892,
    0x45a9d2845d3c42b6,
    0xb8a2392ba45a9b2,
    0x8e6cac7768d7141e,
    0x3207d795430cd926,
    0x7f44e6bd49e807b8,
    0x5f16206c9c6209a6,
    0x36dba887c37a8c0f,
    0xc2494954da2c9789,
    0xf2db9baa10b7bd6c,
    0x6f92829494e5acc7,
    0xcb772339ba1f17f9,
    0xff2a760414536efb,
    0xfef5138519684aba,
    0x7eb258665fc25d69,
    0xef2f773ffbd97a61,
    0xaafb550ffacfd8fa,
    0x95ba2a53f983cf38,
    0xdd945a747bf26183,
    0x94f971119aeef9e4,
    0x7a37cd5601aab85d,
    0xac62e055c10ab33a,
    0x577b986b314d6009,
    0xed5a7e85fda0b80b,
    0x14588f13be847307,
    0x596eb2d8ae258fc8,
    0x6fca5f8ed9aef3bb,
    0x25de7bb9480d5854,
    0xaf561aa79a10ae6a,
    0x1b2ba1518094da04,
    0x90fb44d2f05d0842,
    0x353a1607ac744a53,
    0x42889b8997915ce8,
    0x69956135febada11,
    0x43fab9837e699095,
    0x94f967e45e03f4bb,
    0x1d1be0eebac278f5,
    0x6462d92a69731732,
    0x7d7b8f7503cfdcfe,
    0x5cda735244c3d43e,
    0x3a0888136afa64a7,
    0x88aaa1845b8fdd0,
    0x8aad549e57273d45,
    0x36ac54e2f678864b,
    0x84576a1bb416a7dd,
    0x656d44a2a11c51d5,
    0x9f644ae5a4b1b325,
    0x873d5d9f0dde1fee,
    0xa90cb506d155a7ea,
    0x9a7f12442d588f2,
    0xc11ed6d538aeb2f,
    0x8f1668c8a86da5fa,
    0xf96e017d694487bc,
    0x37c981dcc395a9ac,
    0x85bbe253f47b1417,
    0x93956d7478ccec8e,
    0x387ac8d1970027b2,
    0x6997b05fcc0319e,
    0x441fece3bdf81f03,
    0xd527e81cad7626c3,
    0x8a71e223d8d3b074,
    0xf6872d5667844e49,
    0xb428f8ac016561db,
    0xe13336d701beba52,
    0xecc0024661173473,
    0x27f002d7f95d0190,
    0x31ec038df7b441f4,
    0x7e67047175a15271,
    0xf0062c6e984d386,
    0x52c07b78a3e60868,
    0xa7709a56ccdf8a82,
    0x88a66076400bb691,
    0x6acff893d00ea435,
    0x583f6b8c4124d43,
    0xc3727a337a8b704a,
    0x744f18c0592e4c5c,
    0x1162def06f79df73,
    0x8addcb5645ac2ba8,
    0x6d953e2bd7173692,
    0xc8fa8db6ccdd0437,
    0x1d9c9892400a22a2,
    0x2503beb6d00cab4b,
    0x2e44ae64840fd61d,
    0x5ceaecfed289e5d2,
    0x7425a83e872c5f47,
    0xd12f124e28f77719,
    0x82bd6b70d99aaa6f,
    0x636cc64d1001550b,
    0x3c47f7e05401aa4e,
    0x65acfaec34810a71,
    0x7f1839a741a14d0d,
    0x1ede48111209a050,
    0x934aed0aab460432,
    0xf81da84d5617853f,
    0x36251260ab9d668e,
    0xc1d72b7c6b426019,
    0xb24cf65b8612f81f,
    0xdee033f26797b627,
    0x169840ef017da3b1,
    0x8e1f289560ee864e,
    0xf1a6f2bab92a27e2,
    0xae10af696774b1db,
    0xacca6da1e0a8ef29,
    0x17fd090a58d32af3,
    0xddfc4b4cef07f5b0,
    0x4abdaf101564f98e,
    0x9d6d1ad41abe37f1,
    0x84c86189216dc5ed,
    0x32fd3cf5b4e49bb4,
    0x3fbc8c33221dc2a1,
    0xfabaf3feaa5334a,
    0x29cb4d87f2a7400e,
    0x743e20e9ef511012,
    0x914da9246b255416,
    0x1ad089b6c2f7548e,
    0xa184ac2473b529b1,
    0xc9e5d72d90a2741e,
    0x7e2fa67c7a658892,
    0xddbb901b98feeab7,
    0x552a74227f3ea565,
    0xd53a88958f87275f,
    0x8a892abaf368f137,
    0x2d2b7569b0432d85,
    0x9c3b29620e29fc73,
    0x8349f3ba91b47b8f,
    0x241c70a936219a73,
    0xed238cd383aa0110,
    0xf4363804324a40aa,
    0xb143c6053edcd0d5,
    0xdd94b7868e94050a,
    0xca7cf2b4191c8326,
    0xfd1c2f611f63a3f0,
    0xbc633b39673c8cec,
    0xd5be0503e085d813,
    0x4b2d8644d8a74e18,
    0xddf8e7d60ed1219e,
    0xcabb90e5c942b503,
    0x3d6a751f3b936243,
    0xcc512670a783ad4,
    0x27fb2b80668b24c5,
    0xb1f9f660802dedf6,
    0x5e7873f8a0396973,
    0xdb0b487b6423e1e8,
    0x91ce1a9a3d2cda62,
    0x7641a140cc7810fb,
    0xa9e904c87fcb0a9d,
    0x546345fa9fbdcd44,
    0xa97c177947ad4095,
    0x49ed8eabcccc485d,
    0x5c68f256bfff5a74,
    0x73832eec6fff3111,
    0xc831fd53c5ff7eab,
    0xba3e7ca8b77f5e55,
    0x28ce1bd2e55f35eb,
    0x7980d163cf5b81b3,
    0xd7e105bcc332621f,
    0x8dd9472bf3fefaa7,
    0xb14f98f6f0feb951,
    0x6ed1bf9a569f33d3,
    0xa862f80ec4700c8,
    0xcd27bb612758c0fa,
    0x8038d51cb897789c,
    0xe0470a63e6bd56c3,
    0x1858ccfce06cac74,
    0xf37801e0c43ebc8,
    0xd30560258f54e6ba,
    0x47c6b82ef32a2069,
    0x4cdc331d57fa5441,
    0xe0133fe4adf8e952,
    0x58180fddd97723a6,
    0x570f09eaa7ea7648
];

# must be outermost layer
function Result(parser)
    function(conf::AbstractConf{T}, source, pos, len, ::Type{RT}=T) where {T, RT}
        Base.@_inline_meta
        startpos = pos
        code = SUCCESS
        b = eof(source, pos, len) ? 0x00 : peekbyte(source, pos)
        # For almost all RTs, poslen(RT, ...) will return a Parsers.PosLen. For non-string
        # types, this pl is only used for internal bookkeeping, for strings however
        # we allow the user to provide a custom PosLen type (like PosLen31) in which case
        # they need to overload this method to get the instance here.
        pl = poslen(RT, pos, 0)
        pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
        tlen = pos - startpos
        if valueok(code)
            y = x::RT
            return Result{RT}(code, tlen, y)
        elseif isgreedy(T)
            z = x::RT
            return Result{RT}(code, tlen, z)
        else
            return Result{RT}(code, tlen)
        end
    end
end

# Component design:
  # ComponentFunction: innermost layer/function; f(T, source, pos, len, b, code, pl) -> pos, code, pl, x
    # arguments are all dynamic, runtime parameters
  # ParserFunction: next innermost layer; f(::ComponentFunction) -> ComponentFunction
    # this layer allows "chaining" together however many ComponentFunctions as desired
  # ParserModifyingFunction: outermost layer; f(args...) -> ParserFunction
    # allows passing Options-time/static parameters down to customize the ComponentFunction behavior

emptysentinel(opts::Options) = emptysentinel(opts.flags.checksentinel && isempty(opts.sentinel))
function emptysentinel(checksent::Bool)
    function(parser)
        function checkemptysentinel(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
            Base.@_inline_meta
            pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
            if checksent && pl.len == 0 && (!isgreedy(T) || !quoted(code))
                code &= ~(OK | INVALID)
                code |= SENTINEL
                pl = withmissing(pl)
            end
            return pos, code, pl, x
        end
    end
end

# just ' ' and '\t'
iswh(b) = b == UInt8(' ') || b == UInt8('\t')
iswh(b, spacedelim, tabdelim) = (!spacedelim && b == UInt8(' ')) || (!tabdelim && b == UInt8('\t'))

whitespace(opts::Options) = whitespace(opts.flags.spacedelim, opts.flags.tabdelim, opts.flags.stripquoted, opts.flags.stripwhitespace)
function whitespace(spacedelim, tabdelim, stripquoted, stripwh)
    function(parser)
        function stripwhitespace(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
            Base.@_inline_meta
            # strip leading whitespace
            if !eof(source, pos, len) && (
                # pre-quotes, if delim is not whitespace
                # note that we strip even if user didn't ask in order to consume any whitespace
                # that might be present before the oq; we just need to take care when resetting
                # the pl to account for whether the user actually asked to strip or not
                !quoted(code) ||
                # within quotes, if non-string or user asked to strip quoted
                (quoted(code) && (!isgreedy(T) || stripquoted))
            )
                while iswh(b, spacedelim, tabdelim)
                    pos += 1
                    incr!(source)
                    if eof(source, pos, len)
                        code |= EOF
                        break
                    end
                    b = peekbyte(source, pos)
                end
                # for greedy, reset poslen if we're stripping whitespace
                if isgreedy(T) && (
                    # pre-quotes, if user asked to strip
                    (!quoted(code) && stripwh) ||
                    # within quotes, if user asked to strip quoted
                    (quoted(code) && stripquoted)
                )
                    pl = poslen(typeof(pl), pos, 0)
                end
            end
            pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
            # strip trailing whitespace
            if !eof(source, pos, len) && (
                # post non-quoted value, if delim is not whitespace, and non-string
                # (string already stripped in finddelimiter or findeof)
                (!quoted(code) && !isgreedy(T)) ||
                # post-quoted value, if delim is not whitespace
                quoted(code)
            )
                b = peekbyte(source, pos)
                while iswh(b, spacedelim, tabdelim)
                    pos += 1
                    incr!(source)
                    if eof(source, pos, len)
                        code |= EOF
                        return pos, code, pl, x
                    end
                    b = peekbyte(source, pos)
                end
            end
            return pos, code, pl, x
        end
    end
end

@inline function findendquoted(::Type{T}, source, pos, len, b, code, pl, isquoted, cq, e, stripquoted) where {T}
    # for quoted fields, find the closing quote character
    # we should be positioned at the correct place to find the closing quote character if everything is as it should be
    # if we don't find the quote character immediately, something's wrong, so mark INVALID
    # for greedy (strings), we're positioned at the first byte after opening quote token.
    # we need to account for stripquoted by keeping track of lastnonwhitepos
    if isquoted
        lastnonwhitepos = pos
        same = cq == e
        first = true
        while true
            match, pos = checktoken(source, pos, len, b, e)
            if same && match
                # cq = '"', e = '"', and b = '"', so we might be done
                # e is either followed by cq or it *is* cq
                # checktoken already incremented pos for us
                if eof(source, pos, len)
                    # we're done! cq was last possible byte
                    code |= EOF
                    if !first && !isgreedy(T)
                        # this means we've parsed something like a number,
                        # then immediately expected to find the closing quote
                        # character, but didn't (!first), so something's wrong
                        code |= INVALID
                    end
                    pl = withlen(pl, lastnonwhitepos - pl.pos)
                    break
                end
                # check if next byte is cq
                b = peekbyte(source, pos)
                match, pos = checktoken(source, pos, len, b, cq)
                if !match
                    # we're done! e wasn't followed by cq
                    if !first && !isgreedy(T)
                        code |= INVALID
                    end
                    pl = withlen(pl, lastnonwhitepos - pl.pos)
                    break
                end
                # this means we had e followed by cq
                # so the next byte is escaped
                code |= ESCAPED_STRING
                pl = withescaped(pl)
            elseif match
                # e, so next byte is escaped
                code |= ESCAPED_STRING
                pl = withescaped(pl)
                if eof(source, pos, len)
                    code |= EOF | INVALID_QUOTED_FIELD
                    break
                end
                pos += 1
                incr!(source)
            else
                if !same
                    # not e, so check for cq
                    match, pos = checktoken(source, pos, len, b, cq)
                    if match
                        # we're done! found cq
                        if eof(source, pos, len)
                            code |= EOF
                        end
                        if !first && !isgreedy(T)
                            code |= INVALID
                        end
                        pl = withlen(pl, lastnonwhitepos - pl.pos)
                        break
                    end
                end
                # we didn't match e or cq, so we're not done
                pos += 1
                incr!(source)
            end
            wh = iswh(b)
            lastnonwhitepos = stripquoted ? (wh ? lastnonwhitepos : pos) : pos
            if eof(source, pos, len)
                code |= EOF | INVALID_QUOTED_FIELD
                pl = withlen(pl, lastnonwhitepos - pl.pos)
                break
            end
            first = false
            b = peekbyte(source, pos)
        end
    end
    return pos, code, pl, pl
end

quoted(opts::Options) = quoted(opts.flags.checkquoted, opts.oq, opts.cq, opts.e, opts.flags.stripquoted)
function quoted(checkquoted, oq, cq, e, stripquoted)
    function(parser)
        function findquoted(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
            Base.@_inline_meta
            isquoted = false
            if checkquoted && !eof(source, pos, len)
                isquoted, pos = checktoken(source, pos, len, b, oq)
            end
            if isquoted
                code |= QUOTED
                pl = poslen(typeof(pl), pos, 0)
                if eof(source, pos, len)
                    # "dangling" oq, not valid
                    code |= INVALID_QUOTED_FIELD | EOF
                else
                    b = peekbyte(source, pos)
                end
            end
            pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
            if isgreedy(T) && isquoted
                return pos, code, pl, x
            end
            if eof(source, pos, len)
                if isquoted
                    # if we detected a quote character, it's an invalid quoted field due to eof in the middle
                    code |= INVALID_QUOTED_FIELD | EOF
                end
                return pos, code, pl, x
            end
            b = peekbyte(source, pos)
            pos, code, pl, _ = findendquoted(T, source, pos, len, b, code, pl, isquoted, cq, e, stripquoted)
            return pos, code, pl, x
        end
    end
end

sentinel(opts::Options) = sentinel(opts.flags.checksentinel, opts.sentinel)
function sentinel(chcksentinel, sentinel)
    function(parser)
        function checkforsentinel(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
            Base.@_inline_meta
            match, sentinelpos = (!chcksentinel || isempty(sentinel) || eof(source, pos, len)) ? (false, 0) : checktokens(source, pos, len, b, sentinel)
            pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
            # @show match, sentinelpos, pos, pl
            if match && sentinelpos > (pl.pos + pl.len - 1)
                # if we matched a sentinel value that was as long or longer than our type value
                code &= ~OK
                if isgreedy(T)
                    pl = withlen(pl, sentinelpos - pl.pos)
                else
                    code &= ~(INVALID | EOF | OVERFLOW | INEXACT)
                    pos = sentinelpos
                    fastseek!(source, pos - 1)
                end
                code |= SENTINEL
                pl = withmissing(pl)
                if eof(source, pos, len)
                    code |= EOF
                end
            end
            return pos, code, pl, x
        end
    end
end

@inline function finddelimiter(::Type{T}, source, pos, len, b, code, pl, delim, ignorerepeated, cmt, ignoreemptylines, stripwhitespace) where {T}
    # now we check for a delimiter; if we don't find it, keep parsing until we do
    # for greedy strings, we need to keep track of the last non-whitespace character
    # if we're stripping whitespace, but note we've already skipped leading whitespace
    lastnonwhitepos = pos
    while true
        if eof(source, pos, len)
            code |= EOF
            break
        end
        if !ignorerepeated
            # we're checking for a single appearance of a delimiter
            match, pos = checktoken(source, pos, len, b, delim)
            if match
                code |= DELIMITED
                break
            end
        else
            # keep parsing as long as we keep matching delims/newlines
            matched = false
            matchednewline = false
            while true
                match, pos = checktoken(source, pos, len, b, delim)
                if match
                    matched = true
                    code |= DELIMITED
                elseif !matchednewline && b == UInt8('\n')
                    matchednewline = matched = true
                    pos += 1
                    incr!(source)
                    pos = checkcmtemptylines(source, pos, len, cmt, ignoreemptylines)
                    code |= NEWLINE | ifelse(eof(source, pos, len), EOF, SUCCESS)
                elseif !matchednewline && b == UInt8('\r')
                    matchednewline = matched = true
                    pos += 1
                    incr!(source)
                    if !eof(source, pos, len) && peekbyte(source, pos) == UInt8('\n')
                        pos += 1
                        incr!(source)
                    end
                    pos = checkcmtemptylines(source, pos, len, cmt, ignoreemptylines)
                    code |= NEWLINE | ifelse(eof(source, pos, len), EOF, SUCCESS)
                else
                    break
                end
                if eof(source, pos, len)
                    if matched && !matchednewline
                        code |= EOF
                    end
                    break
                end
                b = peekbyte(source, pos)
            end
            if matched || eof(source, pos, len)
                break
            end
        end
        # didn't find delimiter, but let's check for a newline character
        if b == UInt8('\n')
            pos += 1
            incr!(source)
            pos = checkcmtemptylines(source, pos, len, cmt, ignoreemptylines)
            code |= NEWLINE | ifelse(eof(source, pos, len), EOF, SUCCESS)
            break
        elseif b == UInt8('\r')
            pos += 1
            incr!(source)
            if !eof(source, pos, len) && peekbyte(source, pos) == UInt8('\n')
                pos += 1
                incr!(source)
            end
            pos = checkcmtemptylines(source, pos, len, cmt, ignoreemptylines)
            code |= NEWLINE | ifelse(eof(source, pos, len), EOF, SUCCESS)
            break
        end
        if !isgreedy(T) || quoted(code)
            # didn't find delimiter or newline, so we're invalid, keep parsing until we find delimiter, newline, or len
            code |= INVALID_DELIMITER
        end
        pos += 1
        incr!(source)
        if !quoted(code)
            lastnonwhitepos = stripwhitespace ? (iswh(b) ? lastnonwhitepos : pos) : pos
        end
        if eof(source, pos, len)
            code |= EOF
            break
        end
        b = peekbyte(source, pos)
    end
    if !quoted(code)
        pl = withlen(pl, lastnonwhitepos - pl.pos)
    end
    return pos, code, pl, pl
end

delimiter(opts::Options) = delimiter(opts.flags.checkdelim, opts.delim, opts.flags.ignorerepeated, opts.cmt, opts.flags.ignoreemptylines, opts.flags.stripwhitespace)
function delimiter(checkdelim, delim, ignorerepeated, cmt, ignoreemptylines, stripwhitespace)
    function(parser)
        function _finddelimiter(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
            Base.@_inline_meta
            pos, code, pl, x = parser(conf, source, pos, len, b, code, pl)
            if eof(source, pos, len) || !checkdelim || delimited(code) || newline(code) # greedy case
                return pos, code, pl, x
            end
            b = peekbyte(source, pos)
            pos, code, pl, _ = finddelimiter(T, source, pos, len, b, code, pl, delim, ignorerepeated, cmt, ignoreemptylines, stripwhitespace)
            return pos, code, pl, x
        end
    end
end

function typeparser(opts::Options)
    function(conf::AbstractConf{T}, source, pos, len, b, code, pl) where {T}
        Base.@_inline_meta
        return typeparser(conf, source, pos, len, b, code, pl, opts)
    end
end

# backwards compat
function typeparser(conf, source, pos, len, b, code, opts::Options)
    pos, code, pl, x = typeparser(conf, source, pos, len, b, code, poslen(pos, 0), opts)
    return x, code, pos
end

function typeparser(::Type{T}, source, pos, len, b, code, opts::Options) where {T}
    pos, code, pl, x = typeparser(DefaultConf{T}(), source, pos, len, b, code, poslen(pos, 0), opts)
    return x, code, pos
end

typeparser(::Type{T}, source, pos, len, b, code, pl) where {T} =
    typeparser(DefaultConf{T}(), source, pos, len, b, code, pl, Options())
